/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return 0;
}

int
pattern24 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HQmode:
      if (GET_MODE (x2) != E_HQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HQmode
          || GET_MODE (x3) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      if (GET_MODE (x2) != E_UHQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHQmode
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      if (GET_MODE (x2) != E_HAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HAmode
          || GET_MODE (x3) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      if (GET_MODE (x2) != E_UHAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHAmode
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || pattern35 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!low_io_address_operand (operands[0], E_VOIDmode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
      operands[0] = x6;
      if (!eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTRACT:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XEXP (x8, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x11 = XEXP (x8, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              if (!register_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 0;

                case E_HImode:
                  return 1;

                case E_PSImode:
                  return 2;

                case E_SImode:
                  return 3;

                case E_DImode:
                  return 4;

                default:
                  return -1;
                }

            case MEM:
              if (GET_MODE (x11) != E_QImode)
                return -1;
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 5;

                case E_HImode:
                  return 6;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (x8))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !single_one_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !single_one_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !single_one_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !single_one_operand (operands[2], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case LT:
      return 11;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      return pattern138 (x4); /* [-1, 2] */

    case 1:
      res = pattern138 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case 2:
      res = pattern138 (x4);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case 3:
      res = pattern138 (x4);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 0
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 32
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 32)
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24
      || GET_MODE (x4) != E_HImode
      || pattern155 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 25
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 36
      || GET_MODE (x8) != E_CCmode)
    return -1;
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x3) != E_DQmode
          || GET_MODE (x4) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x3) != E_UDQmode
          || GET_MODE (x4) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x3) != E_DAmode
          || GET_MODE (x4) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x3) != E_UDAmode
          || GET_MODE (x4) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x3) != E_TAmode
          || GET_MODE (x4) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x3) != E_UTAmode
          || GET_MODE (x4) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x3) != E_HImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          res = pattern196 (
E_QImode);
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_HImode:
          res = pattern196 (
E_HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern210 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern220 (x3, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern220 (x3, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern220 (x3, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern220 (x3, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2)
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern273 (x1); /* [-1, 1] */
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 22)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return pattern277 (x1, 
E_QImode, 
21, 
26); /* [-1, 3] */
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[1], E_QImode)
      || !single_zero_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_SQmode:
      if (!register_operand (operands[1], E_SQmode)
          || !nonmemory_operand (operands[2], E_SQmode))
        return -1;
      return 1;

    case E_USQmode:
      if (!register_operand (operands[1], E_USQmode)
          || !nonmemory_operand (operands[2], E_USQmode))
        return -1;
      return 2;

    case E_SAmode:
      if (!register_operand (operands[1], E_SAmode)
          || !nonmemory_operand (operands[2], E_SAmode))
        return -1;
      return 3;

    case E_USAmode:
      if (!register_operand (operands[1], E_USAmode)
          || !nonmemory_operand (operands[2], E_USAmode))
        return -1;
      return 4;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      return 5;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !nonmemory_operand (operands[2], E_HImode))
        return -1;
      return 6;

    case E_HQmode:
      if (!register_operand (operands[1], E_HQmode)
          || !nonmemory_operand (operands[2], E_HQmode))
        return -1;
      return 7;

    case E_UHQmode:
      if (!register_operand (operands[1], E_UHQmode)
          || !nonmemory_operand (operands[2], E_UHQmode))
        return -1;
      return 8;

    case E_HAmode:
      if (!register_operand (operands[1], E_HAmode)
          || !nonmemory_operand (operands[2], E_HAmode))
        return -1;
      return 9;

    case E_UHAmode:
      if (!register_operand (operands[1], E_UHAmode)
          || !nonmemory_operand (operands[2], E_UHAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!l_register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return 0;
}

int
pattern333 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern336 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern346 (x4); /* [-1, 0] */

    case LT:
      if (pattern346 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_CODE (x1))
    {
    case CTZ:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case FFS:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern359 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !l_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_CODE (x2))
    {
    case XOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case IOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 1;

    case AND:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern387 (x1); /* [-1, 0] */

    case NE:
      if (pattern387 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern387 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern387 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern387 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern387 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      if (pattern69 (x1) == 0)
        return 182; /* *addhi3_zero_extend1_split */
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern72 (x1))
    {
    case 0:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3166; /* adddi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3173; /* *adddi3_insn */

    case 1:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3167; /* adddq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3174; /* *adddq3_insn */

    case 2:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3168; /* addudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3175; /* *addudq3_insn */

    case 3:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3169; /* addda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3176; /* *addda3_insn */

    case 4:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3170; /* adduda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3177; /* *adduda3_insn */

    case 5:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3171; /* addta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3178; /* *addta3_insn */

    case 6:
      if (
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3172; /* adduta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3179; /* *adduta3_insn */

    case 7:
      if (
#line 122 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3180; /* adddi3_const8_insn */
      if (pnum_clobbers == NULL
          || !
#line 135 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3181; /* *adddi3_const8_insn */

    case 8:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3182; /* adddi3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3189; /* *adddi3_const_insn */

    case 9:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3183; /* adddq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3190; /* *adddq3_const_insn */

    case 10:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3184; /* addudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3191; /* *addudq3_const_insn */

    case 11:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3185; /* addda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3192; /* *addda3_const_insn */

    case 12:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3186; /* adduda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3193; /* *adduda3_const_insn */

    case 13:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3187; /* addta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3194; /* *addta3_const_insn */

    case 14:
      if (
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3188; /* adduta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3195; /* *adduta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern214 (x2) != 0)
        return -1;
      if (
#line 2538 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 486; /* *osmulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2551 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (pattern214 (x2) != 0)
        return -1;
      if (
#line 2562 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 488; /* *oumulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2575 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 489; /* *oumulqihi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          if (
#line 3201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 535; /* muloqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 3214 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 536; /* *muloqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !pseudo_register_operand (operands[1], E_HImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode)
              || !
#line 3594 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 547; /* *mulohisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (pattern164 (x1) == 0)
    return 642; /* *rotlqi3_split */
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern202 (x2))
        {
        case 0:
          return 644; /* *rotlhi2.1_split */

        case 1:
          return 648; /* *rotlpsi2.1_split */

        case 2:
          return 652; /* *rotlsi2.1_split */

        default:
          break;
        }
      break;

    case 15L:
      if (register_operand (operands[0], E_HImode)
          && GET_MODE (x2) == E_HImode
          && register_operand (operands[1], E_HImode))
        return 646; /* *rotlhi2.15_split */
      break;

    case 23L:
      if (register_operand (operands[0], E_PSImode)
          && GET_MODE (x2) == E_PSImode
          && register_operand (operands[1], E_PSImode))
        return 650; /* *rotlpsi2.23_split */
      break;

    case 31L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && register_operand (operands[1], E_SImode))
        return 654; /* *rotlsi2.31_split */
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (
#line 5232 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 656; /* *rotwhi */
        }
      if (!
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *rotbhi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 5232 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 657; /* *rotwsi */
        }
      if (!
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 660; /* *rotbsi */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 659; /* *rotbpsi */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern192 (x2, 
E_QImode) == 0)
            return 634; /* xorqi3 */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern61 (x2, 
E_HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 636; /* xorhi3 */
            }
          break;

        case E_PSImode:
          if (pattern53 (x2, pnum_clobbers, 
E_PSImode) == 0)
            {
              *pnum_clobbers = 1;
              return 638; /* xorpsi3 */
            }
          break;

        case E_SImode:
          if (pnum_clobbers != NULL
              && pattern61 (x2, 
E_SImode) == 0)
            {
              *pnum_clobbers = 1;
              return 640; /* xorsi3 */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 1087; /* *insv.xor1-bit.0_split */

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern81 (x2))
        {
        case 0:
          if (!
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1092; /* *xorhi.lshiftrt */

        case 1:
          if (!
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1096; /* *xorpsi.lshiftrt */

        case 2:
          if (!
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1100; /* *xorsi.lshiftrt */

        case 3:
          if (!
#line 10988 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (XOR, operands)))
            return -1;
          return 1479; /* *nzb=1.xor.lsr_split */

        case 4:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1116; /* *xorhiqi.lshiftrt */

        case 5:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1120; /* *xorpsiqi.lshiftrt */

        case 6:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1128; /* *xorpsihi.lshiftrt */

        case 7:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1124; /* *xorsiqi.lshiftrt */

        case 8:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1132; /* *xorsihi.lshiftrt */

        case 9:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1136; /* *xorsipsi.lshiftrt */

        case 10:
          if (!
#line 11038 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (XOR, operands)))
            return -1;
          return 1485; /* *nzb=1.xor.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1094; /* *xorhi.ashift */

        case 1:
          if (!
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1098; /* *xorpsi.ashift */

        case 2:
          if (!
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1102; /* *xorsi.ashift */

        case 3:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1118; /* *xorhiqi.ashift */

        case 4:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1122; /* *xorpsiqi.ashift */

        case 5:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1130; /* *xorpsihi.ashift */

        case 6:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1126; /* *xorsiqi.ashift */

        case 7:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1134; /* *xorsihi.ashift */

        case 8:
          if (!
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1138; /* *xorsipsi.ashift */

        case 9:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1373; /* *shl.ext.and1-to-skip.hi */

        case 10:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1379; /* *shl.ext.and1-to-skip.psi */

        case 11:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1391; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1385; /* *shl.ext.and1-to-skip.si */

        case 13:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1397; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1403; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1372; /* *shl.ext.and1-to-skip.hi */

        case 16:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1378; /* *shl.ext.and1-to-skip.psi */

        case 17:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1390; /* *shl.ext.and1-to-skip.psi */

        case 18:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1384; /* *shl.ext.and1-to-skip.si */

        case 19:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1396; /* *shl.ext.and1-to-skip.si */

        case 20:
          if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1402; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          return 1104; /* *xorhiqi.0 */

        case 1:
          return 1106; /* *xorpsiqi.0 */

        case 2:
          return 1110; /* *xorpsihi.0 */

        case 3:
          return 1108; /* *xorsiqi.0 */

        case 4:
          return 1112; /* *xorsihi.0 */

        case 5:
          return 1114; /* *xorsipsi.0 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1274; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1286; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1298; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1310; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1277; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1289; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1301; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1313; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1280; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1292; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1304; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1316; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1283; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1295; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1307; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1319; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1406; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1409; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1412; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1322; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1325; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1328; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1331; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1336; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1342; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1354; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1348; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1360; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1366; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1337; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1343; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1355; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1349; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1361; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1367; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (XOR == IOR || XOR == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1473; /* *nzb=1.xor.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (XOR == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1482; /* *nzb=1.xor.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (XOR == IOR || XOR == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1488; /* *nzb=1.xor.ge0_split */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG)
    {
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) == REG
      && REGNO (x6) == 30)
    {
      switch (pattern250 (x6))
        {
        case 0:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 35; /* fxmovqi_A */
          break;

        case 1:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 36; /* fxmovqq_A */
          break;

        case 2:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 37; /* fxmovuqq_A */
          break;

        case 3:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 38; /* fxmovhi_A */
          break;

        case 4:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 39; /* fxmovhq_A */
          break;

        case 5:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 40; /* fxmovuhq_A */
          break;

        case 6:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 41; /* fxmovha_A */
          break;

        case 7:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 42; /* fxmovuha_A */
          break;

        case 8:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 43; /* fxmovsi_A */
          break;

        case 9:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 44; /* fxmovsq_A */
          break;

        case 10:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 45; /* fxmovusq_A */
          break;

        case 11:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 46; /* fxmovsa_A */
          break;

        case 12:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 47; /* fxmovusa_A */
          break;

        case 13:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 48; /* fxmovsf_A */
          break;

        case 14:
          if (
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 49; /* fxmovpsi_A */
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 121; /* *reload_inuqq */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1279 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern204 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern330 (x3))
            {
            case 0:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3173; /* *adddi3_insn */

            case 1:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3174; /* *adddq3_insn */

            case 2:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3175; /* *addudq3_insn */

            case 3:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3176; /* *addda3_insn */

            case 4:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3177; /* *adduda3_insn */

            case 5:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3178; /* *addta3_insn */

            case 6:
              if (!
#line 114 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3179; /* *adduta3_insn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern297 (x6, 
E_QImode, 
26, 
E_DImode) != 0)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !
#line 135 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3181; /* *adddi3_const8_insn */

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern331 (x3))
            {
            case 0:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3189; /* *adddi3_const_insn */

            case 1:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3190; /* *adddq3_const_insn */

            case 2:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3191; /* *addudq3_const_insn */

            case 3:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3192; /* *addda3_const_insn */

            case 4:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3193; /* *adduda3_const_insn */

            case 5:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3194; /* *addta3_const_insn */

            case 6:
              if (!
#line 161 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3195; /* *adduta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern285 (x4))
            {
            case 0:
              if (!
#line 1649 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 181; /* *addhi3_zero_extend */

            case 1:
              if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 237; /* *addpsi3.zero_extend.qi */

            case 2:
              if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 241; /* *addpsi3.zero_extend.hi */

            case 3:
              if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 239; /* *addsi3.zero_extend.qi */

            case 4:
              if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 243; /* *addsi3.zero_extend.hi */

            case 5:
              if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 245; /* *addsi3.zero_extend.psi */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x6;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 1693 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 185; /* *addhi3_zero_extend.const */

        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 1762 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 190; /* *usum_widenqihi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND
          || GET_MODE (x9) != E_HImode)
        return -1;
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern169 (x1, 
E_HImode) != 0)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 1734 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 188; /* *addhi3_zero_extend.ashift1 */

    case SIGN_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern285 (x4))
        {
        case 0:
          if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 235; /* *addhi3.sign_extend.qi */

        case 1:
          if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 236; /* *addpsi3.sign_extend.qi */

        case 2:
          if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 240; /* *addpsi3.sign_extend.hi */

        case 3:
          if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 238; /* *addsi3.sign_extend.qi */

        case 4:
          if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 242; /* *addsi3.sign_extend.hi */

        case 5:
          if (!
#line 1994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 244; /* *addsi3.sign_extend.psi */

        default:
          return -1;
        }

    case GE:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 380; /* *addqi3.ge0 */

        case 1:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 388; /* *addqi3.ge0 */

        case 2:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 396; /* *addqi3.ge0 */

        case 3:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 404; /* *addqi3.ge0 */

        case 4:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 382; /* *addhi3.ge0 */

        case 5:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 390; /* *addhi3.ge0 */

        case 6:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 398; /* *addhi3.ge0 */

        case 7:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 406; /* *addhi3.ge0 */

        case 8:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 384; /* *addpsi3.ge0 */

        case 9:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 392; /* *addpsi3.ge0 */

        case 10:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 400; /* *addpsi3.ge0 */

        case 11:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 408; /* *addpsi3.ge0 */

        case 12:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 386; /* *addsi3.ge0 */

        case 13:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 394; /* *addsi3.ge0 */

        case 14:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 402; /* *addsi3.ge0 */

        case 15:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 410; /* *addsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 381; /* *addqi3.lt0 */

        case 1:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 389; /* *addqi3.lt0 */

        case 2:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 397; /* *addqi3.lt0 */

        case 3:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 405; /* *addqi3.lt0 */

        case 4:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 383; /* *addhi3.lt0 */

        case 5:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 391; /* *addhi3.lt0 */

        case 6:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 399; /* *addhi3.lt0 */

        case 7:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 407; /* *addhi3.lt0 */

        case 8:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 385; /* *addpsi3.lt0 */

        case 9:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 393; /* *addpsi3.lt0 */

        case 10:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 401; /* *addpsi3.lt0 */

        case 11:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 409; /* *addpsi3.lt0 */

        case 12:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 387; /* *addsi3.lt0 */

        case 13:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 395; /* *addsi3.lt0 */

        case 14:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 403; /* *addsi3.lt0 */

        case 15:
          if (!
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 411; /* *addsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          if (pattern231 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 36
                  || GET_MODE (x8) != E_CCmode
                  || !
#line 2607 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 491; /* *maddqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2645 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 494; /* *maddqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern232 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              if (pattern354 (x1) != 0
                  || !
#line 2716 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (pattern354 (x1) != 0
                  || !
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 513; /* *maddqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2947 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern232 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              if (pattern354 (x1) != 0
                  || !
#line 2716 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 499; /* *umaddqihi4 */

            case SIGN_EXTEND:
              if (pattern354 (x1) != 0
                  || !
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 506; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 514; /* *umaddqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || pattern27 (x1) != 0)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 24
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (pattern386 (x14, 
E_QImode, 
23) != 0)
    return -1;
  x15 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_QImode)
    return -1;
  x17 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x17) != CLOBBER)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 36
      || GET_MODE (x18) != E_CCmode)
    return -1;
  x19 = XVECEXP (x9, 0, 0);
  operands[0] = x19;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x20 = XEXP (x16, 0);
  operands[1] = x20;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      if (!
#line 1412 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 166; /* *cpymemx_qi */

    case E_HImode:
      if (!
#line 1412 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 167; /* *cpymemx_hi */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_90 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_78 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          if (pattern28 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 7);
              if (pattern386 (x2, 
E_CCmode, 
36) == 0)
                {
                  switch (pattern385 (x1))
                    {
                    case 0:
                      if (
#line 1347 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                        return 162; /* *cpymem_qi */
                      break;

                    case 1:
                      if (
#line 1347 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                        return 163; /* *cpymem_hi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              return 164; /* cpymemx_qi */

            case 1:
              return 165; /* cpymemx_hi */

            default:
              break;
            }
          break;

        case 10:
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_88 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_89 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 6)
        return -1;
      operands[0] = x1;
      if (!set_some_operation (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern177 (x1, 
USE) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!dreg_or_0_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[5] = x12;
      if (!register_operand (operands[5], E_QImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_QImode)
          || !
#line 1225 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 156; /* set_some */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 972; /* nop */

    case RETURN:
      if (
#line 8681 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed && avr_simple_epilogue ()))
        return 999; /* return */
      if (
#line 8687 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && !(cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1000; /* return_from_epilogue */
      if (
#line 8696 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && (cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1001; /* return_from_interrupt_epilogue */
      if (!
#line 8705 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && cfun->machine->is_naked))
        return -1;
      return 1002; /* return_from_naked_epilogue */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XEXP (x3, 1);
  switch (pattern280 (x5))
    {
    case 0:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2467 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_271 (insn, operands);

    case 1:
      if (!(
#line 2513 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2515 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 2:
      if (!(
#line 3149 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3151 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern194 (x2) != 0
              || !(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2467 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_PSImode:
          switch (pattern195 (x2))
            {
            case 0:
              if (!(
#line 4108 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4110 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case 1:
              if (!(
#line 4135 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4137 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2488 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2490 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_273 (insn, operands);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 3174 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3176 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern90 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern258 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode)
                  && 
#line 6994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_569 (insn, operands);
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode)
                  && 
#line 6994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_570 (insn, operands);
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode)
                  && 
#line 6994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_571 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_595 (insn, operands);
          break;

        case 2:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_597 (insn, operands);
          break;

        case 3:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_601 (insn, operands);
          break;

        case 4:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_599 (insn, operands);
          break;

        case 5:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_603 (insn, operands);
          break;

        case 6:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_605 (insn, operands);
          break;

        case 7:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_596 (insn, operands);
          break;

        case 8:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_598 (insn, operands);
          break;

        case 9:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_602 (insn, operands);
          break;

        case 10:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_600 (insn, operands);
          break;

        case 11:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_604 (insn, operands);
          break;

        case 12:
          if ((
#line 7127 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_606 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 18)
        return NULL;
      x5 = XEXP (x2, 1);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 10)
            return NULL;
          switch (pattern329 (x3))
            {
            case 0:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1920 (insn, operands);

            case 1:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1921 (insn, operands);

            case 2:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1922 (insn, operands);

            case 3:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1923 (insn, operands);

            case 4:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1924 (insn, operands);

            case 5:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1925 (insn, operands);

            case 6:
              if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1926 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern296 (x3) != 0
              || !(
#line 529 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 531 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1927 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern230 (x2))
        {
        case 0:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_583 (insn, operands);

        case 1:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_585 (insn, operands);

        case 2:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_589 (insn, operands);

        case 3:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_587 (insn, operands);

        case 4:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_591 (insn, operands);

        case 5:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_593 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern230 (x2))
        {
        case 0:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 1:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_586 (insn, operands);

        case 2:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_590 (insn, operands);

        case 3:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_588 (insn, operands);

        case 4:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_592 (insn, operands);

        case 5:
          if (!(
#line 7096 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7099 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_594 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern152 (x3) != 0
          || !
#line 4632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_371 (insn, operands);

    case LSHIFTRT:
      switch (pattern81 (x3))
        {
        case 0:
          if (!(
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 1:
          if (!(
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_672 (insn, operands);

        case 2:
          if (!(
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_676 (insn, operands);

        case 3:
          if (!
#line 10992 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1019 (insn, operands);

        case 4:
          if (!(
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_692 (insn, operands);

        case 5:
          if (!(
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 6:
          if (!(
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_704 (insn, operands);

        case 7:
          if (!(
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_700 (insn, operands);

        case 8:
          if (!(
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_708 (insn, operands);

        case 9:
          if (!(
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_712 (insn, operands);

        case 10:
          if (!
#line 11043 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1025 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern83 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern79 (x3, 
E_HImode) == 0
                  && (
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_670 (insn, operands);
              break;

            case E_PSImode:
              if (pattern79 (x3, 
E_PSImode) == 0
                  && (
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_674 (insn, operands);
              break;

            case E_SImode:
              if (pattern79 (x3, 
E_SImode) == 0
                  && (
#line 10152 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_678 (insn, operands);
              break;

            case E_QImode:
              if (pattern80 (x3) == 0
                  && 
#line 11112 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
                return gen_split_1030 (insn, operands);
              break;

            default:
              break;
            }
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) != 8L
              || pattern218 (x3) != 0
              || !(
#line 10264 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize) && 
#line 10266 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_719 (insn, operands);

        case 1:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern46 (x3))
            {
            case 0:
              if ((
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_694 (insn, operands);
              break;

            case 1:
              if ((
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_698 (insn, operands);
              break;

            case 2:
              if ((
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_706 (insn, operands);
              break;

            case 3:
              if ((
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_702 (insn, operands);
              break;

            case 4:
              if ((
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_710 (insn, operands);
              break;

            case 5:
              if ((
#line 10198 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_714 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L)
            return NULL;
          switch (pattern228 (x3))
            {
            case 0:
              if (!(
#line 10215 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize) && 
#line 10217 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_716 (insn, operands);

            case 1:
              if (!(
#line 10248 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize) && 
#line 10250 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_718 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_913 (insn, operands);

        case 3:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_919 (insn, operands);

        case 4:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_931 (insn, operands);

        case 5:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_925 (insn, operands);

        case 6:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_937 (insn, operands);

        case 7:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_943 (insn, operands);

        case 8:
          if (!(
#line 10215 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize) && 
#line 10217 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_715 (insn, operands);

        case 9:
          if (!(
#line 10248 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize) && 
#line 10250 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_717 (insn, operands);

        case 10:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_912 (insn, operands);

        case 11:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_918 (insn, operands);

        case 12:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_930 (insn, operands);

        case 13:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_924 (insn, operands);

        case 14:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_936 (insn, operands);

        case 15:
          if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_942 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern3 (x3))
        {
        case 0:
          if (!(
#line 10175 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1) && 
#line 10177 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_680 (insn, operands);

        case 1:
          if (!(
#line 10175 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1) && 
#line 10177 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_682 (insn, operands);

        case 2:
          if (!(
#line 10175 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2) && 
#line 10177 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_686 (insn, operands);

        case 3:
          if (!(
#line 10175 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1) && 
#line 10177 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_684 (insn, operands);

        case 4:
          if (!(
#line 10175 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2) && 
#line 10177 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_688 (insn, operands);

        case 5:
          if (!(
#line 10175 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3) && 
#line 10177 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_690 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x3))
            {
            case 0:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_815 (insn, operands);

            case 1:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_827 (insn, operands);

            case 2:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            case 3:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_851 (insn, operands);

            case 4:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_818 (insn, operands);

            case 5:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_830 (insn, operands);

            case 6:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_842 (insn, operands);

            case 7:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_854 (insn, operands);

            case 8:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_821 (insn, operands);

            case 9:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_833 (insn, operands);

            case 10:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_845 (insn, operands);

            case 11:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_857 (insn, operands);

            case 12:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_824 (insn, operands);

            case 13:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_836 (insn, operands);

            case 14:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_848 (insn, operands);

            case 15:
              if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_860 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_947 (insn, operands);

            case 1:
              if (!(
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_950 (insn, operands);

            case 2:
              if (!(
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_953 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern87 (x3))
        {
        case 0:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_863 (insn, operands);

        case 1:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_866 (insn, operands);

        case 2:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_869 (insn, operands);

        case 3:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_872 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_876 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_882 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_894 (insn, operands);

        case 7:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_888 (insn, operands);

        case 8:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_900 (insn, operands);

        case 9:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_906 (insn, operands);

        case 10:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_877 (insn, operands);

        case 11:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_883 (insn, operands);

        case 12:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_895 (insn, operands);

        case 13:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_889 (insn, operands);

        case 14:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_901 (insn, operands);

        case 15:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_907 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 10948 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1016 (insn, operands);

        case 1:
          if (!
#line 11018 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1022 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern121 (x3) != 0
          || !
#line 11067 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1028 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x3;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = split_7 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern91 (x1))
        {
        case 0:
          if (!
#line 7631 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_607 (insn, operands);

        case 1:
          if (!
#line 7631 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_608 (insn, operands);

        case 2:
          if (!
#line 7631 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_609 (insn, operands);

        case 3:
          if (!
#line 7631 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_610 (insn, operands);

        case 4:
          if (!
#line 7631 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_611 (insn, operands);

        case 5:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8145 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_618 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8240 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_621 (insn, operands);

        case 6:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8145 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_619 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8240 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_622 (insn, operands);

        case 7:
          if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_612 (insn, operands);

        case 8:
          if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_613 (insn, operands);

        case 9:
          if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_614 (insn, operands);

        case 10:
          if (!
#line 7684 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_615 (insn, operands);

        case 11:
          operands[0] = x3;
          if (gelt_operator (operands[0], E_VOIDmode))
            {
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) == MEM
                  && GET_MODE (x5) == E_QImode)
                {
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  x7 = XEXP (x2, 1);
                  x8 = XEXP (x7, 0);
                  operands[2] = x8;
                  if (low_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8193 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_620 (insn, operands);
                  if (high_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8287 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_623 (insn, operands);
                }
            }
          if (GET_CODE (x3) != GE)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!
#line 9089 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_633 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (REGNO (x5))
    {
    case 30:
      switch (pattern250 (x5))
        {
        case 0:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 1:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_18 (insn, operands);

        case 2:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 3:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 4:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_21 (insn, operands);

        case 5:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_22 (insn, operands);

        case 6:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_23 (insn, operands);

        case 7:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_24 (insn, operands);

        case 8:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_25 (insn, operands);

        case 9:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_26 (insn, operands);

        case 10:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_27 (insn, operands);

        case 11:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_28 (insn, operands);

        case 12:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_29 (insn, operands);

        case 13:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_30 (insn, operands);

        case 14:
          if (!(
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_31 (insn, operands);

        default:
          return NULL;
        }

    case 36:
      if (GET_MODE (x5) != E_CCmode)
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_70 (insn, operands);

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !general_operand (operands[1], E_QQmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_71 (insn, operands);

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !general_operand (operands[1], E_UQQmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_72 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_73 (insn, operands);

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !general_operand (operands[1], E_HQmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_74 (insn, operands);

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !general_operand (operands[1], E_UHQmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_75 (insn, operands);

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !general_operand (operands[1], E_HAmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_76 (insn, operands);

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !general_operand (operands[1], E_UHAmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_77 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_78 (insn, operands);

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !general_operand (operands[1], E_SQmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_79 (insn, operands);

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !general_operand (operands[1], E_USQmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_80 (insn, operands);

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !general_operand (operands[1], E_SAmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_81 (insn, operands);

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !general_operand (operands[1], E_USAmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_82 (insn, operands);

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !general_operand (operands[1], E_SFmode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_83 (insn, operands);

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !general_operand (operands[1], E_PSImode)
              || !
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (pattern319 (x4) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern381 (x5) != 0)
    return NULL;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_PSImode)
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (pattern388 (x9, 
E_PSImode))
        {
        case 0:
          if (!
#line 7410 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_200 (insn, operands);

        case 1:
          if (!
#line 7410 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_201 (insn, operands);

        case 2:
          if (!
#line 7410 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_202 (insn, operands);

        case 3:
          if (!
#line 7410 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_203 (insn, operands);

        case 4:
          if (!
#line 7410 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_204 (insn, operands);

        case 5:
          if (!
#line 7410 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_205 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern390 (x3))
        {
        case 0:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_206 (insn, operands);

        case 1:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_207 (insn, operands);

        case 2:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_208 (insn, operands);

        case 3:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_209 (insn, operands);

        case 4:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_210 (insn, operands);

        case 5:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_211 (insn, operands);

        case 6:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_218 (insn, operands);

        case 7:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_219 (insn, operands);

        case 8:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_220 (insn, operands);

        case 9:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_221 (insn, operands);

        case 10:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_222 (insn, operands);

        case 11:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_223 (insn, operands);

        case 12:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_242 (insn, operands);

        case 13:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_243 (insn, operands);

        case 14:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_244 (insn, operands);

        case 15:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_245 (insn, operands);

        case 16:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_246 (insn, operands);

        case 17:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_247 (insn, operands);

        case 18:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_230 (insn, operands);

        case 19:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_231 (insn, operands);

        case 20:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_232 (insn, operands);

        case 21:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_233 (insn, operands);

        case 22:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_234 (insn, operands);

        case 23:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_235 (insn, operands);

        case 24:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_254 (insn, operands);

        case 25:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_255 (insn, operands);

        case 26:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_256 (insn, operands);

        case 27:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_257 (insn, operands);

        case 28:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_258 (insn, operands);

        case 29:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_259 (insn, operands);

        case 30:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_266 (insn, operands);

        case 31:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_267 (insn, operands);

        case 32:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_268 (insn, operands);

        case 33:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_269 (insn, operands);

        case 34:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_270 (insn, operands);

        case 35:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_271 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern390 (x3))
        {
        case 0:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_212 (insn, operands);

        case 1:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_213 (insn, operands);

        case 2:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_214 (insn, operands);

        case 3:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_215 (insn, operands);

        case 4:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_216 (insn, operands);

        case 5:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_217 (insn, operands);

        case 6:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_224 (insn, operands);

        case 7:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_225 (insn, operands);

        case 8:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_226 (insn, operands);

        case 9:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_227 (insn, operands);

        case 10:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_228 (insn, operands);

        case 11:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_229 (insn, operands);

        case 12:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_248 (insn, operands);

        case 13:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_249 (insn, operands);

        case 14:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_250 (insn, operands);

        case 15:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_251 (insn, operands);

        case 16:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_252 (insn, operands);

        case 17:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_253 (insn, operands);

        case 18:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_236 (insn, operands);

        case 19:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_237 (insn, operands);

        case 20:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_238 (insn, operands);

        case 21:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_239 (insn, operands);

        case 22:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_240 (insn, operands);

        case 23:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_241 (insn, operands);

        case 24:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_260 (insn, operands);

        case 25:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_261 (insn, operands);

        case 26:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_262 (insn, operands);

        case 27:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_263 (insn, operands);

        case 28:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_264 (insn, operands);

        case 29:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_265 (insn, operands);

        case 30:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_272 (insn, operands);

        case 31:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_273 (insn, operands);

        case 32:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_274 (insn, operands);

        case 33:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_275 (insn, operands);

        case 34:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_276 (insn, operands);

        case 35:
          if (!
#line 7441 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_277 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
