/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonmemory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return pattern9 (); /* [-1, 3] */
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!combine_pseudo_register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x2) != E_QQmode
              || GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x2) != E_UQQmode
              || GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      res = pattern24 (x1, 
22);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case 24:
      if (REGNO (x4) != 18)
        return -1;
      res = pattern25 (x1, 
22);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || pattern34 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern38 (x3);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  return pattern46 (x1); /* [-1, 5] */
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x2);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 6;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern61 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern61 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern61 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern61 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern61 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern70 (x1); /* [-1, 6] */

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern61 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      return 0;

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 2; /* [2, 7] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x6 = XEXP (x1, 1);
          res = pattern82 (x6);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 10; /* [10, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i4
      || GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern100 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return pattern41 (x1); /* [-1, 1] */
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !nonimmediate_operand (operands[0], E_QImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != CONST_INT
              || XWINT (x4, 0) != 128L)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != AND
              || GET_MODE (x3) != E_QImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case ZERO_EXTRACT:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_0_to_15_operand (operands[2], E_QImode))
                return -1;
              return 4;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !const_0_to_23_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LO_SUM
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nop_general_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern179 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern179 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern179 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern179 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern193 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  x12 = XEXP (x4, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern268 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern270 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern270 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_HImode))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern299 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 22
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 18
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 30
      || GET_MODE (x10) != E_HImode
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 1;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 2;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 3;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 4;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 5;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 6;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 7;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 8;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x7, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern344 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern341 (x1); /* [-1, 2] */
}

int
pattern351 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 0);
  operands[2] = x10;
  switch (GET_MODE (x7))
    {
    case E_HImode:
      if (!register_operand (operands[3], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[3], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x4) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[4], E_PSImode)
              || !register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern381 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != IF_THEN_ELSE)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != LABEL_REF)
    return -1;
  x11 = XEXP (x9, 2);
  if (GET_CODE (x11) != PC)
    return -1;
  x12 = XEXP (x8, 0);
  if (GET_CODE (x12) != PC)
    return -1;
  x13 = XEXP (x10, 0);
  operands[2] = x13;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  return pattern388 (x4, 
i1); /* [-1, 5] */
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 22)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (pattern159 (x2))
        {
        case 0:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 5; /* load_qi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 20; /* *load_qi_libgcc */
            }
          break;

        case 1:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 6; /* load_qq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 21; /* *load_qq_libgcc */
            }
          break;

        case 2:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 7; /* load_uqq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 22; /* *load_uqq_libgcc */
            }
          break;

        case 3:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 8; /* load_hi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 23; /* *load_hi_libgcc */
            }
          break;

        case 4:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 9; /* load_hq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 24; /* *load_hq_libgcc */
            }
          break;

        case 5:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 10; /* load_uhq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 25; /* *load_uhq_libgcc */
            }
          break;

        case 6:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 11; /* load_ha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 26; /* *load_ha_libgcc */
            }
          break;

        case 7:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 12; /* load_uha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 27; /* *load_uha_libgcc */
            }
          break;

        case 8:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 13; /* load_si_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 28; /* *load_si_libgcc */
            }
          break;

        case 9:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 14; /* load_sq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 29; /* *load_sq_libgcc */
            }
          break;

        case 10:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 15; /* load_usq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 30; /* *load_usq_libgcc */
            }
          break;

        case 11:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 16; /* load_sa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 31; /* *load_sa_libgcc */
            }
          break;

        case 12:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 17; /* load_usa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 32; /* *load_usa_libgcc */
            }
          break;

        case 13:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 18; /* load_sf_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 33; /* *load_sf_libgcc */
            }
          break;

        case 14:
          if (
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 19; /* load_psi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 34; /* *load_psi_libgcc */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern122 (x3))
    {
    case 0:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 49; /* fxmovpsi_A */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern68 (x2))
        {
        case 0:
          return 172; /* *strlenhi_split */

        case 1:
          return 1011; /* insert_bits */

        case 2:
          return 3126; /* roundqq3_const */

        case 3:
          return 3127; /* roundhq3_const */

        case 4:
          return 3128; /* roundha3_const */

        case 5:
          return 3129; /* roundsa3_const */

        case 6:
          return 3130; /* roundsq3_const */

        case 7:
          return 3131; /* rounduqq3_const */

        case 8:
          return 3132; /* rounduhq3_const */

        case 9:
          return 3133; /* rounduha3_const */

        case 10:
          return 3134; /* roundusa3_const */

        case 11:
          return 3135; /* roundusq3_const */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9703 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1057; /* fmul_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9718 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1058; /* *fmul_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9729 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1059; /* *fmul.call_split */
            }
          if (!
#line 9744 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1060; /* *fmul.call */

        case 5:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9775 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1061; /* fmuls_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9790 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1062; /* *fmuls_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9801 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1063; /* *fmuls.call_split */
            }
          if (!
#line 9816 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1064; /* *fmuls.call */

        case 6:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9847 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1065; /* fmulsu_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9862 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1066; /* *fmulsu_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9873 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1067; /* *fmulsu.call_split */
            }
          if (!
#line 9888 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1068; /* *fmulsu.call */

        case 8:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 24
              || GET_MODE (x5) != E_QImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x3) != 24)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_QQmode:
                  if (GET_MODE (x2) != E_QQmode
                      || GET_MODE (x4) != E_QQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3146; /* *roundqq3.libgcc_split */

                case E_UQQmode:
                  if (GET_MODE (x2) != E_UQQmode
                      || GET_MODE (x4) != E_UQQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3147; /* *rounduqq3.libgcc_split */

                case E_HQmode:
                  if (GET_MODE (x2) != E_HQmode
                      || GET_MODE (x4) != E_HQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3150; /* *roundhq3.libgcc_split */

                case E_UHQmode:
                  if (GET_MODE (x2) != E_UHQmode
                      || GET_MODE (x4) != E_UHQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3151; /* *rounduhq3.libgcc_split */

                case E_HAmode:
                  if (GET_MODE (x2) != E_HAmode
                      || GET_MODE (x4) != E_HAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3152; /* *roundha3.libgcc_split */

                case E_UHAmode:
                  if (GET_MODE (x2) != E_UHAmode
                      || GET_MODE (x4) != E_UHAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3153; /* *rounduha3.libgcc_split */

                default:
                  return -1;
                }

            case 18:
              if (REGNO (x3) != 22)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_SQmode:
                  if (GET_MODE (x2) != E_SQmode
                      || GET_MODE (x4) != E_SQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3158; /* *roundsq3.libgcc_split */

                case E_USQmode:
                  if (GET_MODE (x2) != E_USQmode
                      || GET_MODE (x4) != E_USQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3159; /* *roundusq3.libgcc_split */

                case E_SAmode:
                  if (GET_MODE (x2) != E_SAmode
                      || GET_MODE (x4) != E_SAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3160; /* *roundsa3.libgcc_split */

                case E_USAmode:
                  if (GET_MODE (x2) != E_USAmode
                      || GET_MODE (x4) != E_USAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3161; /* *roundusa3.libgcc_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 3
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != IOR
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_QImode)
          || !
#line 11130 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
        return -1;
      *pnum_clobbers = 1;
      return 1495; /* *nzb=1.ior.ashift */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern75 (x1, pnum_clobbers))
        {
        case 0:
          return 618; /* andqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 620; /* andhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 622; /* andpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 624; /* andsi3 */

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern216 (x2))
        {
        case 0:
          if (!
#line 10632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1210; /* *extract.subreg.bit */

        case 1:
          if (!
#line 10632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1212; /* *extract.subreg.bit */

        case 2:
          if (!
#line 10632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1214; /* *extract.subreg.bit */

        case 3:
          if (!
#line 10632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1211; /* *extract.subreg.bit */

        case 4:
          if (!
#line 10632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1213; /* *extract.subreg.bit */

        case 5:
          if (!
#line 10632 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1215; /* *extract.subreg.bit */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_zero_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 980; /* *cbi */

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern77 (x2))
        {
        case 0:
          return 1182; /* *insv.any_shift.qi_split */

        case 1:
          return 1185; /* *insv.any_shift.hi_split */

        case 2:
          return 1188; /* *insv.any_shift.psi_split */

        case 3:
          return 1191; /* *insv.any_shift.si_split */

        case 4:
          if (!
#line 10988 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1481; /* *nzb=1.and.lsr_split */

        case 5:
          if (!
#line 11038 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1487; /* *nzb=1.and.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1183; /* *insv.any_shift.qi_split */

        case 1:
          return 1186; /* *insv.any_shift.hi_split */

        case 2:
          return 1189; /* *insv.any_shift.psi_split */

        case 3:
          return 1192; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1184; /* *insv.any_shift.qi_split */

        case 1:
          return 1187; /* *insv.any_shift.hi_split */

        case 2:
          return 1190; /* *insv.any_shift.psi_split */

        case 3:
          return 1193; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern136 (x2))
        {
        case 0:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1457; /* *map.and1-to-skip.qi */

        case 1:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1461; /* *map.and1-to-skip.qi */

        case 2:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1465; /* *map.and1-to-skip.qi */

        case 3:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1469; /* *map.and1-to-skip.qi */

        case 4:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1458; /* *map.and1-to-skip.hi */

        case 5:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1462; /* *map.and1-to-skip.hi */

        case 6:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1466; /* *map.and1-to-skip.hi */

        case 7:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1470; /* *map.and1-to-skip.hi */

        case 8:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1459; /* *map.and1-to-skip.psi */

        case 9:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1463; /* *map.and1-to-skip.psi */

        case 10:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1467; /* *map.and1-to-skip.psi */

        case 11:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1471; /* *map.and1-to-skip.psi */

        case 12:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1460; /* *map.and1-to-skip.si */

        case 13:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1464; /* *map.and1-to-skip.si */

        case 14:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1468; /* *map.and1-to-skip.si */

        case 15:
          if (!
#line 10914 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1472; /* *map.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1475; /* *nzb=1.and.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (AND == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1484; /* *nzb=1.and.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1490; /* *nzb=1.and.ge0_split */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern108 (x4, 
E_QImode) == 0
                  && 
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 177; /* *addqi3 */
              break;

            case E_QQmode:
              if (pattern108 (x4, 
E_QQmode) == 0
                  && 
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 178; /* *addqq3 */
              break;

            case E_UQQmode:
              if (pattern108 (x4, 
E_UQQmode) == 0
                  && 
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 179; /* *adduqq3 */
              break;

            case E_HImode:
              if (pattern308 (x4, 
E_HImode) == 0
                  && 
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 199; /* *addhi3 */
              break;

            case E_HQmode:
              if (pattern308 (x4, 
E_HQmode) == 0
                  && 
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 200; /* *addhq3 */
              break;

            case E_UHQmode:
              if (pattern308 (x4, 
E_UHQmode) == 0
                  && 
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 201; /* *adduhq3 */
              break;

            case E_HAmode:
              if (pattern308 (x4, 
E_HAmode) == 0
                  && 
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 202; /* *addha3 */
              break;

            case E_UHAmode:
              if (pattern308 (x4, 
E_UHAmode) == 0
                  && 
#line 1848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return 203; /* *adduha3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern307 (x4, 
E_HImode) != 0)
            return -1;
          return 204; /* addhi3_clobber */

        case E_HQmode:
          if (pattern307 (x4, 
E_HQmode) != 0)
            return -1;
          return 205; /* addhq3_clobber */

        case E_UHQmode:
          if (pattern307 (x4, 
E_UHQmode) != 0)
            return -1;
          return 206; /* adduhq3_clobber */

        case E_HAmode:
          if (pattern307 (x4, 
E_HAmode) != 0)
            return -1;
          return 207; /* addha3_clobber */

        case E_UHAmode:
          if (pattern307 (x4, 
E_UHAmode) != 0)
            return -1;
          return 208; /* adduha3_clobber */

        case E_SImode:
          if (pattern108 (x4, 
E_SImode) != 0)
            return -1;
          return 214; /* addsi3 */

        case E_SQmode:
          if (pattern108 (x4, 
E_SQmode) != 0)
            return -1;
          return 215; /* addsq3 */

        case E_USQmode:
          if (pattern108 (x4, 
E_USQmode) != 0)
            return -1;
          return 216; /* addusq3 */

        case E_SAmode:
          if (pattern108 (x4, 
E_SAmode) != 0)
            return -1;
          return 217; /* addsa3 */

        case E_USAmode:
          if (pattern108 (x4, 
E_USAmode) != 0)
            return -1;
          return 218; /* addusa3 */

        case E_PSImode:
          if (pattern108 (x4, 
E_PSImode) != 0)
            return -1;
          return 270; /* addpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern262 (x1, 
E_HImode) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1672 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 183; /* *addhi3_zero_extend1 */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern235 (x1))
        {
        case 0:
          if (
#line 5987 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 746; /* *lshrqi3 */
          break;

        case 1:
          if (
#line 5987 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 747; /* *lshrqq3 */
          break;

        case 2:
          if (
#line 5987 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 748; /* *lshruqq3 */
          break;

        case 3:
          if (
#line 6015 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 754; /* *lshrhi3 */
          break;

        case 4:
          if (
#line 6015 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 755; /* *lshrhq3 */
          break;

        case 5:
          if (
#line 6015 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 756; /* *lshruhq3 */
          break;

        case 6:
          if (
#line 6015 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 757; /* *lshrha3 */
          break;

        case 7:
          if (
#line 6015 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 758; /* *lshruha3 */
          break;

        case 8:
          if (
#line 6074 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 766; /* *lshrsi3 */
          break;

        case 9:
          if (
#line 6074 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 767; /* *lshrsq3 */
          break;

        case 10:
          if (
#line 6074 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 768; /* *lshrusq3 */
          break;

        case 11:
          if (
#line 6074 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 769; /* *lshrsa3 */
          break;

        case 12:
          if (
#line 6074 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 770; /* *lshrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 759; /* lshrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 6165 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 776; /* *lshrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 6165 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 777; /* *lshrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 6165 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *lshrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 6165 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 779; /* *lshrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 6165 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 780; /* *lshrusa3_const */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) == MEM)
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  operands[0] = x4;
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !nox_general_operand (operands[1], E_QImode)
          || !
#line 862 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
        return -1;
      return 116; /* movqi_insn */

    case E_QQmode:
      if (!nonimmediate_operand (operands[0], E_QQmode)
          || !nox_general_operand (operands[1], E_QQmode)
          || !
#line 862 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
        return -1;
      return 117; /* movqq_insn */

    case E_UQQmode:
      if (!nonimmediate_operand (operands[0], E_UQQmode)
          || !nox_general_operand (operands[1], E_UQQmode)
          || !
#line 862 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
        return -1;
      return 118; /* movuqq_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !nox_general_operand (operands[1], E_HImode)
          || !
#line 971 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
        return -1;
      return 133; /* *movhi */

    case E_HQmode:
      if (!nonimmediate_operand (operands[0], E_HQmode)
          || !nox_general_operand (operands[1], E_HQmode)
          || !
#line 971 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
        return -1;
      return 134; /* *movhq */

    case E_UHQmode:
      if (!nonimmediate_operand (operands[0], E_UHQmode)
          || !nox_general_operand (operands[1], E_UHQmode)
          || !
#line 971 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
        return -1;
      return 135; /* *movuhq */

    case E_HAmode:
      if (!nonimmediate_operand (operands[0], E_HAmode)
          || !nox_general_operand (operands[1], E_HAmode)
          || !
#line 971 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
        return -1;
      return 136; /* *movha */

    case E_UHAmode:
      if (!nonimmediate_operand (operands[0], E_UHAmode)
          || !nox_general_operand (operands[1], E_UHAmode)
          || !
#line 971 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
        return -1;
      return 137; /* *movuha */

    case E_PSImode:
      if (!nonimmediate_operand (operands[0], E_PSImode)
          || !nox_general_operand (operands[1], E_PSImode)
          || !
#line 1144 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
        return -1;
      return 140; /* *movpsi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nox_general_operand (operands[1], E_SImode)
          || !
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
        return -1;
      return 151; /* *movsi */

    case E_SQmode:
      if (!nonimmediate_operand (operands[0], E_SQmode)
          || !nox_general_operand (operands[1], E_SQmode)
          || !
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
        return -1;
      return 152; /* *movsq */

    case E_USQmode:
      if (!nonimmediate_operand (operands[0], E_USQmode)
          || !nox_general_operand (operands[1], E_USQmode)
          || !
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
        return -1;
      return 153; /* *movusq */

    case E_SAmode:
      if (!nonimmediate_operand (operands[0], E_SAmode)
          || !nox_general_operand (operands[1], E_SAmode)
          || !
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
        return -1;
      return 154; /* *movsa */

    case E_USAmode:
      if (!nonimmediate_operand (operands[0], E_USAmode)
          || !nox_general_operand (operands[1], E_USAmode)
          || !
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
        return -1;
      return 155; /* *movusa */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !nox_general_operand (operands[1], E_SFmode)
          || !
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
        return -1;
      return 158; /* *movsf */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      if (XWINT (x6, 0) == 1L)
        {
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) == REG
              && REGNO (x9) == 36
              && GET_MODE (x9) == E_CCmode
              && 
#line 3081 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return 527; /* *ashiftqihi2.signx.1 */
        }
      x9 = XEXP (x2, 0);
      if (!scratch_operand (x9, E_QImode))
        return -1;
      operands[3] = x9;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && 
#line 3092 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 528; /* *ashifthi3.signx.const */
      operands[2] = x9;
      if (XWINT (x6, 0) != 7L
          || !
#line 3110 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 529; /* *ashifthi3.signx.const7 */

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (pattern224 (x1) != 0
          || !
#line 3128 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 530; /* *ashifthi3.zerox.const */

    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (!
#line 642 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern209 (x1, 
E_QImode) != 0)
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1149; /* *extzvqi */

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1150; /* *extzvhi */

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1151; /* *extzvpsi */

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1152; /* *extzvsi */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 10454 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1156; /* *extzv.not */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (pattern242 (x1, 
UMOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UMOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 0);
      switch (REGNO (x8))
        {
        case 24:
          if (pattern379 (x1, 
E_QImode, 
E_CCmode, 
36, 
23, 
25) != 0
              || !
#line 3978 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 589; /* *udivmodqi4_call */

        case 22:
          if (pattern379 (x1, 
E_HImode, 
E_QImode, 
21, 
26, 
24) != 0)
            return -1;
          return 594; /* *udivmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern324 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3122; /* *udivsa3.call */

        case 1:
          if (!
#line 625 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3124; /* *udivusa3.call */

        default:
          return -1;
        }

    case 2:
      return 616; /* *udivmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3110; /* *udivhq3.call */

    case 4:
      if (!
#line 577 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3112; /* *udivuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3114; /* *udivha3.call */

    case 6:
      if (!
#line 577 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3116; /* *udivuha3.call */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern106 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x4) == REG)
        {
          res = recog_80 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      switch (pattern264 (x1))
        {
        case 0:
          if (!
#line 3403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 541; /* *mulsi3 */

        case 1:
          if (!
#line 4197 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 601; /* *mulpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG)
        {
          switch (pattern267 (x1))
            {
            case 0:
              if (
#line 2437 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return 476; /* *umulqihi3.call_split */
              break;

            case 1:
              if (
#line 675 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                return 3361; /* umulsidi3_insn */
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern271 (x1))
        {
        case 0:
          if (!
#line 3483 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 543; /* *muluqisi3 */

        case 1:
          if (!
#line 3483 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 544; /* *muluhisi3 */

        case 2:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 549; /* *usmulqiqisi3 */

        case 3:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 557; /* *usmulqihisi3 */

        case 4:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 553; /* *usmulhiqisi3 */

        case 5:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 561; /* *usmulhihisi3 */

        case 6:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 551; /* *uumulqiqisi3 */

        case 7:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 559; /* *uumulqihisi3 */

        case 8:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 555; /* *uumulhiqisi3 */

        case 9:
          if (!
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 563; /* *uumulhihisi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 26
          || GET_MODE (x7) != E_HImode)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) == 18)
        {
          switch (pattern304 (x1))
            {
            case 0:
              if (
#line 3535 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 545; /* *mulsqisi3 */
              break;

            case 1:
              if (
#line 3535 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 546; /* *mulshisi3 */
              break;

            case 2:
              if (
#line 4178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 600; /* *mulsqipsi3 */
              break;

            case 3:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 548; /* *ssmulqiqisi3 */
              break;

            case 4:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 556; /* *ssmulqihisi3 */
              break;

            case 5:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 552; /* *ssmulhiqisi3 */
              break;

            case 6:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 560; /* *ssmulhihisi3 */
              break;

            case 7:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 550; /* *sumulqiqisi3 */
              break;

            case 8:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 558; /* *sumulqihisi3 */
              break;

            case 9:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 554; /* *sumulhiqisi3 */
              break;

            case 10:
              if (
#line 3646 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 562; /* *sumulhihisi3 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || pattern305 (x1) != 0
          || !
#line 675 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        return -1;
      return 3360; /* mulsidi3_insn */

    case NOT:
      if (pattern244 (x1) != 0
          || !
#line 3594 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      return 547; /* *mulohisi3 */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (REGNO (x2))
        {
        case 32:
          if (GET_MODE (x2) == E_HImode
              && register_operand (operands[0], E_HImode)
              && 
#line 537 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed
   && frame_pointer_needed
   && !cfun->calls_alloca
   && find_reg_note (insn, REG_ARGS_SIZE, const0_rtx)
   && REGNO (operands[0]) != REG_Y))
            return gen_split_1 (insn, operands);
          break;

        case 22:
          switch (pattern159 (x2))
            {
            case 0:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_2 (insn, operands);
              break;

            case 1:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_3 (insn, operands);
              break;

            case 2:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_4 (insn, operands);
              break;

            case 3:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_5 (insn, operands);
              break;

            case 4:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_6 (insn, operands);
              break;

            case 5:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_7 (insn, operands);
              break;

            case 6:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_8 (insn, operands);
              break;

            case 7:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_9 (insn, operands);
              break;

            case 8:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_10 (insn, operands);
              break;

            case 9:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_11 (insn, operands);
              break;

            case 10:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_12 (insn, operands);
              break;

            case 11:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_13 (insn, operands);
              break;

            case 12:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_14 (insn, operands);
              break;

            case 13:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_15 (insn, operands);
              break;

            case 14:
              if ((
#line 572 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_16 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern67 (x3))
    {
    case 0:
      if (!(
#line 848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode)) && 
#line 851 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_62 (insn, operands);

    case 1:
      if (!(
#line 848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode)) && 
#line 851 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_63 (insn, operands);

    case 2:
      if (!(
#line 848 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode)) && 
#line 851 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_64 (insn, operands);

    case 3:
      if (nonimmediate_operand (operands[0], E_HImode)
          && nox_general_operand (operands[1], E_HImode)
          && (
#line 959 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_65 (insn, operands);
      if (!register_operand (operands[0], E_HImode)
          || !reg_or_0_operand (operands[1], E_HImode)
          || !
#line 4891 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed
   && GENERAL_REG_P (operands[0])
   && (operands[1] == const0_rtx || GENERAL_REG_P (operands[1]))
   && (!AVR_HAVE_MOVW
       || const0_rtx == operands[1])))
        return NULL;
      return gen_split_386 (insn, operands);

    case 4:
      if (!(
#line 959 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], HQmode)
   || reg_or_0_operand (operands[1], HQmode)) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_66 (insn, operands);

    case 5:
      if (!(
#line 959 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], UHQmode)
   || reg_or_0_operand (operands[1], UHQmode)) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_67 (insn, operands);

    case 6:
      if (!(
#line 959 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], HAmode)
   || reg_or_0_operand (operands[1], HAmode)) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_68 (insn, operands);

    case 7:
      if (!(
#line 959 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], UHAmode)
   || reg_or_0_operand (operands[1], UHAmode)) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_69 (insn, operands);

    case 8:
      if (nonimmediate_operand (operands[0], E_PSImode)
          && nox_general_operand (operands[1], E_PSImode)
          && (
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], PSImode)
   || register_operand (operands[1], PSImode)
   || const0_rtx == operands[1]) && 
#line 1135 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_85 (insn, operands);
      if (!register_operand (operands[0], E_PSImode)
          || !register_operand (operands[1], E_PSImode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_381 (insn, operands);

    case 9:
      if (nonimmediate_operand (operands[0], E_SImode)
          && nox_general_operand (operands[1], E_SImode)
          && (
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_86 (insn, operands);
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_379 (insn, operands);

    case 10:
      if (nonimmediate_operand (operands[0], E_SQmode)
          && nox_general_operand (operands[1], E_SQmode)
          && (
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], SQmode)
   || reg_or_0_operand (operands[1], SQmode)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_87 (insn, operands);
      if (!register_operand (operands[0], E_SQmode)
          || !register_operand (operands[1], E_SQmode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_382 (insn, operands);

    case 11:
      if (nonimmediate_operand (operands[0], E_USQmode)
          && nox_general_operand (operands[1], E_USQmode)
          && (
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], USQmode)
   || reg_or_0_operand (operands[1], USQmode)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_88 (insn, operands);
      if (!register_operand (operands[0], E_USQmode)
          || !register_operand (operands[1], E_USQmode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_383 (insn, operands);

    case 12:
      if (nonimmediate_operand (operands[0], E_SAmode)
          && nox_general_operand (operands[1], E_SAmode)
          && (
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], SAmode)
   || reg_or_0_operand (operands[1], SAmode)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_89 (insn, operands);
      if (!register_operand (operands[0], E_SAmode)
          || !register_operand (operands[1], E_SAmode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_384 (insn, operands);

    case 13:
      if (nonimmediate_operand (operands[0], E_USAmode)
          && nox_general_operand (operands[1], E_USAmode)
          && (
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], USAmode)
   || reg_or_0_operand (operands[1], USAmode)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_90 (insn, operands);
      if (!register_operand (operands[0], E_USAmode)
          || !register_operand (operands[1], E_USAmode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_385 (insn, operands);

    case 14:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && nox_general_operand (operands[1], E_SFmode)
          && (
#line 1240 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)) && 
#line 1243 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_91 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_SFmode)
          || !
#line 4870 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_380 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x1, 0);
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (pattern124 (x1, 
E_QImode) == 0
                  && 
#line 1579 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_99 (insn, operands);
              break;

            case E_QQmode:
              if (pattern124 (x1, 
E_QQmode) == 0
                  && 
#line 1579 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_100 (insn, operands);
              break;

            case E_UQQmode:
              if (pattern124 (x1, 
E_UQQmode) == 0
                  && 
#line 1579 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_101 (insn, operands);
              break;

            case E_HImode:
              if (GET_MODE (x2) == E_HImode)
                {
                  operands[1] = x4;
                  if (stack_register_operand (operands[1], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[2] = x5;
                      if (stack_register_operand (operands[2], E_HImode))
                        {
                          operands[0] = x3;
                          if (avr_sp_immediate_operand (operands[0], E_HImode))
                            return gen_split_108 (insn, operands);
                        }
                    }
                  operands[0] = x4;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[1] = x5;
                      if (register_operand (operands[1], E_HImode))
                        {
                          operands[2] = x3;
                          if (nonmemory_or_const_operand (operands[2], E_HImode))
                            return gen_split_109 (insn, operands);
                        }
                    }
                }
              break;

            case E_HQmode:
              if (pattern151 (x1, 
E_HQmode) == 0)
                return gen_split_110 (insn, operands);
              break;

            case E_UHQmode:
              if (pattern151 (x1, 
E_UHQmode) == 0)
                return gen_split_111 (insn, operands);
              break;

            case E_HAmode:
              if (pattern151 (x1, 
E_HAmode) == 0)
                return gen_split_112 (insn, operands);
              break;

            case E_UHAmode:
              if (pattern151 (x1, 
E_UHAmode) == 0)
                return gen_split_113 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (pattern69 (x1) == 0
              && 
#line 1661 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_103 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG)
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1866 (insn, operands);

        case 1:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1867 (insn, operands);

        case 2:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1868 (insn, operands);

        case 3:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 4:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 5:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1871 (insn, operands);

        case 6:
          if (!(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1872 (insn, operands);

        case 7:
          if (!(
#line 122 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 124 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1873 (insn, operands);

        case 8:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1874 (insn, operands);

        case 9:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1875 (insn, operands);

        case 10:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1876 (insn, operands);

        case 11:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1877 (insn, operands);

        case 12:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1878 (insn, operands);

        case 13:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1879 (insn, operands);

        case 14:
          if (!(
#line 147 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1880 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              if (!
#line 1638 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 2:
              if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_130 (insn, operands);

            case 3:
              if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 4:
              if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_132 (insn, operands);

            case 5:
              if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_134 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          operands[2] = x3;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || pattern189 (x2) != 0
              || !
#line 1682 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        case ZERO_EXTEND:
          if (pattern161 (x2) != 0
              || !
#line 1750 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!
#line 1721 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_105 (insn, operands);

    case 3:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_911 (insn, operands);

    case 4:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_917 (insn, operands);

    case 5:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_929 (insn, operands);

    case 6:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_923 (insn, operands);

    case 7:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_935 (insn, operands);

    case 8:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_941 (insn, operands);

    case 9:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_910 (insn, operands);

    case 10:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_916 (insn, operands);

    case 11:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_928 (insn, operands);

    case 12:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_922 (insn, operands);

    case 13:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_934 (insn, operands);

    case 14:
      if (!(
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_940 (insn, operands);

    case 15:
      if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_124 (insn, operands);

    case 16:
      if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_125 (insn, operands);

    case 17:
      if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_129 (insn, operands);

    case 18:
      if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_127 (insn, operands);

    case 19:
      if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_131 (insn, operands);

    case 20:
      if (!(
#line 1974 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_133 (insn, operands);

    case 21:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_174 (insn, operands);

    case 22:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    case 23:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_178 (insn, operands);

    case 24:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_180 (insn, operands);

    case 25:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_182 (insn, operands);

    case 26:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 27:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 28:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_186 (insn, operands);

    case 29:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_190 (insn, operands);

    case 30:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 31:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_175 (insn, operands);

    case 32:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_177 (insn, operands);

    case 33:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_179 (insn, operands);

    case 34:
      if (!
#line 2316 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_181 (insn, operands);

    case 35:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 36:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 38:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 39:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_191 (insn, operands);

    case 40:
      if (!(
#line 2332 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2334 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 41:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_206 (insn, operands);

    case 42:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_214 (insn, operands);

    case 43:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_222 (insn, operands);

    case 44:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_230 (insn, operands);

    case 45:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_208 (insn, operands);

    case 46:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_216 (insn, operands);

    case 47:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_224 (insn, operands);

    case 48:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_232 (insn, operands);

    case 49:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_210 (insn, operands);

    case 50:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case 51:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_226 (insn, operands);

    case 52:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_234 (insn, operands);

    case 53:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_212 (insn, operands);

    case 54:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_220 (insn, operands);

    case 55:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_228 (insn, operands);

    case 56:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_236 (insn, operands);

    case 57:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_207 (insn, operands);

    case 58:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_215 (insn, operands);

    case 59:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_223 (insn, operands);

    case 60:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_231 (insn, operands);

    case 61:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_209 (insn, operands);

    case 62:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_217 (insn, operands);

    case 63:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_225 (insn, operands);

    case 64:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_233 (insn, operands);

    case 65:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_211 (insn, operands);

    case 66:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_219 (insn, operands);

    case 67:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_227 (insn, operands);

    case 68:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_235 (insn, operands);

    case 69:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_213 (insn, operands);

    case 70:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_221 (insn, operands);

    case 71:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_229 (insn, operands);

    case 72:
      if (!
#line 2403 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_237 (insn, operands);

    case 73:
      x2 = XEXP (x1, 1);
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode)
          || !(
#line 2592 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2594 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern127 (x2))
        {
        case 0:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !register_operand (operands[3], E_HImode))
            return NULL;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2701 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2703 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_281 (insn, operands);

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2763 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_286 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_874 (insn, operands);

        case 2:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_880 (insn, operands);

        case 3:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_892 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_886 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_898 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_904 (insn, operands);

        default:
          return NULL;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern128 (x2))
        {
        case 0:
          if (!(
#line 2701 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2703 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_282 (insn, operands);

        case 1:
          if (!(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2763 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_285 (insn, operands);

        case 2:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (XWINT (x7, 0) != 2L)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!(
#line 2832 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 2835 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_289 (insn, operands);

        case 3:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_875 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_881 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_893 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_887 (insn, operands);

        case 7:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_899 (insn, operands);

        case 8:
          if (!(
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_905 (insn, operands);

        default:
          return NULL;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern129 (x2))
        {
        case 0:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_862 (insn, operands);

        case 1:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_865 (insn, operands);

        case 2:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_868 (insn, operands);

        case 3:
          if (!(
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_871 (insn, operands);

        default:
          return NULL;
        }

    case 77:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_814 (insn, operands);

    case 78:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_826 (insn, operands);

    case 79:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_838 (insn, operands);

    case 80:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_850 (insn, operands);

    case 81:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_817 (insn, operands);

    case 82:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_829 (insn, operands);

    case 83:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_841 (insn, operands);

    case 84:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_853 (insn, operands);

    case 85:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_820 (insn, operands);

    case 86:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_832 (insn, operands);

    case 87:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_844 (insn, operands);

    case 88:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_856 (insn, operands);

    case 89:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_823 (insn, operands);

    case 90:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_835 (insn, operands);

    case 91:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_847 (insn, operands);

    case 92:
      if (!(
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_859 (insn, operands);

    case 93:
      if (!(
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_946 (insn, operands);

    case 94:
      if (!(
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_949 (insn, operands);

    case 95:
      if (!(
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_952 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return NULL;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return NULL;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return NULL;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_SImode)
      || !(
#line 3439 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed) && 
#line 3444 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
    return NULL;
  return gen_split_313 (insn, operands);
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_24 (x1, insn);

    case PLUS:
      return split_25 (x1, insn);

    case MINUS:
      return split_26 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern281 (x1) != 0
                  || !(
#line 2239 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2241 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern282 (x1) != 0
                  || !(
#line 3715 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3717 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern283 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1824 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1825 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1826 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1827 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2996 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3030 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3032 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3048 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3050 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2994 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2996 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3012 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3014 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_27 (x1, insn);

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode
          || pattern183 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern358 (x9))
            {
            case 0:
              if (!(
#line 3800 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3802 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3800 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3802 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9405 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_647 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4543 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4578 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4657 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4689 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4721 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4778 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4808 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4840 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern252 (x1))
        {
        case 0:
          if ((
#line 5232 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5237 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5232 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5237 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5255 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_435 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_438 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_441 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_444 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 6029 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_436 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_439 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_442 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_445 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 5829 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern171 (x1) != 0
          || !
#line 6634 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_560 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern323 (x5))
        {
        case 0:
          if (!(
#line 6908 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_566 (insn, operands);

        case 1:
          if (!(
#line 6908 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 2:
          if (!(
#line 6908 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern289 (x1))
        {
        case 0:
          if (
#line 7016 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_572 (insn, operands);
          break;

        case 1:
          if (
#line 7016 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_573 (insn, operands);
          break;

        case 2:
          if (
#line 7016 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_574 (insn, operands);
          break;

        case 3:
          if (
#line 7016 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_575 (insn, operands);
          break;

        case 4:
          if (
#line 7016 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_576 (insn, operands);
          break;

        case 5:
          if (
#line 7043 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_577 (insn, operands);
          break;

        case 6:
          if (
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_578 (insn, operands);
          break;

        case 7:
          if (
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_579 (insn, operands);
          break;

        case 8:
          if (
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_580 (insn, operands);
          break;

        case 9:
          if (
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_581 (insn, operands);
          break;

        case 10:
          if (
#line 7071 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_582 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern290 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1928 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1929 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1930 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1932 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1933 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1934 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern225 (x1))
        {
        case 0:
          if (!(
#line 9140 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9142 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_635 (insn, operands);

        case 1:
          if (!(
#line 9169 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9171 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9155 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9157 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_636 (insn, operands);

    case CLZ:
      if (pattern156 (x1) != 0
          || !
#line 9384 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_646 (insn, operands);

    case CTZ:
      if (pattern156 (x1) != 0
          || !
#line 9453 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_648 (insn, operands);

    case FFS:
      if (pattern156 (x1) != 0
          || !
#line 9525 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern293 (x1))
        {
        case 0:
          if (!(
#line 9729 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9731 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!(
#line 9801 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9803 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 9873 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9875 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_658 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1860 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1864 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1865 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1833 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
