/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 14;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 15;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 16;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 17;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 18;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 19;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 20;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 21;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 22;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 23;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 24;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 25;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 26;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 27;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 28;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 29;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 30;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 31;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 32;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 33;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 34;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 35;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 36;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 37;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 38;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 39;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 40;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 41;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 42;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 43;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 44;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 45;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 46;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern192 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern192 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern192 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern192 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern192 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern192 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern192 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern192 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern192 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern192 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern192 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern192 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern192 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern192 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern192 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern192 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern192 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern192 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern192 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern192 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern192 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern192 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern192 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern192 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern192 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern192 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern192 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern192 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern192 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern192 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern192 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern192 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern192 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern192 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern192 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern192 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern192 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern192 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern192 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern192 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern192 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern192 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern192 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern192 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern192 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern192 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern192 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern192 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern192 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern192 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern192 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern192 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern192 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern192 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern192 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern192 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern192 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern192 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern192 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern192 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern192 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern192 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern192 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern192 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern192 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern192 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern192 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern192 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern192 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern192 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern192 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern192 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern192 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern192 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern192 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern192 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern192 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern192 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern192 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern192 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern192 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern192 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern192 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern192 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern192 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern192 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern192 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern192 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern192 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern192 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern192 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern192 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern192 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern192 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern192 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern192 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern192 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern192 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern192 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern192 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern192 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern192 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern192 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern192 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern192 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern192 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern192 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern192 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern192 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern192 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern192 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern192 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern192 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern192 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern192 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern192 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern192 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern192 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern192 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern192 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern192 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern192 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern168 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern168 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern168 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern168 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern168 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern168 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern168 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern168 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern168 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern168 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern168 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern168 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern168 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern168 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern168 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern168 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern168 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern168 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern168 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern168 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern168 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern168 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern168 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern168 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern168 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern168 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern168 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern168 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern168 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern168 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern168 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern168 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern168 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern168 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern168 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern168 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern168 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern168 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern168 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern168 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern168 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern168 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern168 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern168 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern168 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern168 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern168 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern168 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_all_trues_mask_operand (operands[3], i2)
      || !vector_const_0_operand (operands[5], i1)
      || !vector_merge_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vector_all_trues_mask_operand (operands[4], i1)
      || !vector_const_0_operand (operands[9], i2)
      || !vector_merge_operand (operands[10], i2)
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x1, 2);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          return pattern248 (x2, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
            return -1;
          return 5;

        case E_V1HImode:
          if (pattern248 (x2, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
            return -1;
          return 6;

        case E_V2HImode:
          if (pattern248 (x2, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
            return -1;
          return 7;

        case E_V4HImode:
          if (pattern248 (x2, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
            return -1;
          return 8;

        case E_V8HImode:
          if (pattern248 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V16HImode:
          if (pattern248 (x2, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
            return -1;
          return 10;

        case E_V32HImode:
          if (pattern248 (x2, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
            return -1;
          return 11;

        case E_V64HImode:
          if (pattern248 (x2, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
            return -1;
          return 12;

        case E_V128HImode:
          if (pattern248 (x2, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
            return -1;
          return 13;

        case E_V256HImode:
          if (pattern248 (x2, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
            return -1;
          return 14;

        case E_V512HImode:
          if (pattern248 (x2, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
            return -1;
          return 15;

        case E_V1024HImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
            return -1;
          return 16;

        case E_V2048HImode:
          if (pattern248 (x2, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 22;

        case E_V1SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V1BImode
              || GET_MODE (x3) != E_V1SImode
              || GET_MODE (x4) != E_V1SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V1SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V1BImode
              || !vector_all_trues_mask_operand (operands[4], E_V1BImode)
              || !vector_const_0_operand (operands[9], E_V1SImode)
              || !vector_merge_operand (operands[10], E_V1SImode)
              || !register_operand (operands[1], E_V1BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V1SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V1BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V1HImode:
              if (!register_operand (operands[3], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[3], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V2BImode
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V2SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V2BImode
              || !vector_all_trues_mask_operand (operands[4], E_V2BImode)
              || !vector_const_0_operand (operands[9], E_V2SImode)
              || !vector_merge_operand (operands[10], E_V2SImode)
              || !register_operand (operands[1], E_V2BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V2SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2HImode:
              if (!register_operand (operands[3], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V4BImode
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V4BImode
              || !vector_all_trues_mask_operand (operands[4], E_V4BImode)
              || !vector_const_0_operand (operands[9], E_V4SImode)
              || !vector_merge_operand (operands[10], E_V4SImode)
              || !register_operand (operands[1], E_V4BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V8BImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V8SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V8BImode
              || !vector_all_trues_mask_operand (operands[4], E_V8BImode)
              || !vector_const_0_operand (operands[9], E_V8SImode)
              || !vector_merge_operand (operands[10], E_V8SImode)
              || !register_operand (operands[1], E_V8BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V8SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[3], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V16BImode
              || GET_MODE (x3) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V16SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V16BImode
              || !vector_all_trues_mask_operand (operands[4], E_V16BImode)
              || !vector_const_0_operand (operands[9], E_V16SImode)
              || !vector_merge_operand (operands[10], E_V16SImode)
              || !register_operand (operands[1], E_V16BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V16SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V16BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V16HImode:
              if (!register_operand (operands[3], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[3], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V32BImode
              || GET_MODE (x3) != E_V32SImode
              || GET_MODE (x4) != E_V32SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V32SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V32BImode
              || !vector_all_trues_mask_operand (operands[4], E_V32BImode)
              || !vector_const_0_operand (operands[9], E_V32SImode)
              || !vector_merge_operand (operands[10], E_V32SImode)
              || !register_operand (operands[1], E_V32BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V32SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V32BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V32HImode:
              if (!register_operand (operands[3], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[3], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V64BImode
              || GET_MODE (x3) != E_V64SImode
              || GET_MODE (x4) != E_V64SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V64SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V64BImode
              || !vector_all_trues_mask_operand (operands[4], E_V64BImode)
              || !vector_const_0_operand (operands[9], E_V64SImode)
              || !vector_merge_operand (operands[10], E_V64SImode)
              || !register_operand (operands[1], E_V64BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V64SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V64BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V64HImode:
              if (!register_operand (operands[3], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[3], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V128BImode
              || GET_MODE (x3) != E_V128SImode
              || GET_MODE (x4) != E_V128SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V128SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V128BImode
              || !vector_all_trues_mask_operand (operands[4], E_V128BImode)
              || !vector_const_0_operand (operands[9], E_V128SImode)
              || !vector_merge_operand (operands[10], E_V128SImode)
              || !register_operand (operands[1], E_V128BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V128SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V128BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V128HImode:
              if (!register_operand (operands[3], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[3], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V256BImode
              || GET_MODE (x3) != E_V256SImode
              || GET_MODE (x4) != E_V256SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V256SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V256BImode
              || !vector_all_trues_mask_operand (operands[4], E_V256BImode)
              || !vector_const_0_operand (operands[9], E_V256SImode)
              || !vector_merge_operand (operands[10], E_V256SImode)
              || !register_operand (operands[1], E_V256BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V256SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V256BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V256HImode:
              if (!register_operand (operands[3], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[3], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V512BImode
              || GET_MODE (x3) != E_V512SImode
              || GET_MODE (x4) != E_V512SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V512SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V512BImode
              || !vector_all_trues_mask_operand (operands[4], E_V512BImode)
              || !vector_const_0_operand (operands[9], E_V512SImode)
              || !vector_merge_operand (operands[10], E_V512SImode)
              || !register_operand (operands[1], E_V512BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V512SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V512BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V512HImode:
              if (!register_operand (operands[3], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[3], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1SImode)
      || GET_MODE (x1) != E_RVVM1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 0;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 0;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern339 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !fp_native_comparison (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[2], E_HFmode)
          || !register_operand (operands[3], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XEXP (x8, 0);
  return pattern341 (x13); /* [-1, 3] */
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern350 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern350 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern362 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern362 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern362 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern362 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern362 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern362 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern362 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != AND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != NOT
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x11 = XEXP (x7, 1);
  operands[2] = x11;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x9, 0);
  operands[3] = x12;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i2
      || XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_two_s12 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != AND
      || GET_MODE (x9) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x10 = XEXP (x9, 1);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x14 = XEXP (x9, 0);
  return pattern378 (x14); /* [-1, 1] */
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return 0;
}

int
pattern397 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  return pattern227 (x2); /* [-1, 1] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern414 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 4;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 7;

    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      return 8;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 9;

    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      return 10;

    case E_V128DImode:
      if (!register_operand (operands[1], E_V128DImode))
        return -1;
      return 11;

    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 12;

    case E_V512DImode:
      if (!register_operand (operands[1], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern464 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern475 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern475 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern475 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern475 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern475 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern475 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern475 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern475 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern475 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern475 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern475 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern475 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern475 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern475 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern504 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern504 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern504 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern504 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern504 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern504 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern504 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern504 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern504 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern504 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern504 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern504 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern504 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern504 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern504 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern504 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern504 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern504 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern578 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern593 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_neg_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern480 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern480 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern480 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern480 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern480 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!register_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[4], E_RVVM4HFmode)
          || !register_operand (operands[5], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM8SFmode:
      if (!register_operand (operands[4], E_RVVM8SFmode)
          || !register_operand (operands[5], E_RVVM8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[4], E_RVVM1HFmode)
          || !register_operand (operands[5], E_RVVM1HFmode))
        return -1;
      return 0;

    case E_RVVM2SFmode:
      if (!register_operand (operands[4], E_RVVM2SFmode)
          || !register_operand (operands[5], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM4DFmode:
      if (!register_operand (operands[4], E_RVVM4DFmode)
          || !register_operand (operands[5], E_RVVM4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[4], E_V1HFmode)
          || !register_operand (operands[5], E_V1HFmode))
        return -1;
      return 0;

    case E_V1SFmode:
      if (!register_operand (operands[4], E_V1SFmode)
          || !register_operand (operands[5], E_V1SFmode))
        return -1;
      return 1;

    case E_V1DFmode:
      if (!register_operand (operands[4], E_V1DFmode)
          || !register_operand (operands[5], E_V1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || !register_operand (operands[5], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || !register_operand (operands[5], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || !register_operand (operands[5], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || !register_operand (operands[5], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || !register_operand (operands[5], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || !register_operand (operands[5], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1024BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1024BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[4], E_V1024HFmode)
          || !register_operand (operands[5], E_V1024HFmode))
        return -1;
      return 0;

    case E_V1024SFmode:
      if (!register_operand (operands[4], E_V1024SFmode)
          || !register_operand (operands[5], E_V1024SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern628 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != SET)
        return -1;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != i1)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x21 = XEXP (x16, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 8
          || GET_MODE (x21) != i1)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != RETURN)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 1;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern674 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern681 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern690 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i4
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern698 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], E_DImode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern702 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern702 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern702 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern702 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern702 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern702 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVM8SImode
          || GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM8SImode
          || GET_MODE (x4) != E_RVVM8SImode
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode)
              || !register_operand (operands[4], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 7;

            case E_RVVM8QImode:
              if (!register_operand (operands[4], E_RVVM8QImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVM4SImode
          || GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM4SImode
          || GET_MODE (x4) != E_RVVM4SImode
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode)
              || !register_operand (operands[4], E_RVVM2HImode))
            return -1;
          return 9;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 10;

            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVM2SImode
          || GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM2SImode
          || GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode)
              || !register_operand (operands[4], E_RVVM1HImode))
            return -1;
          return 12;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 13;

            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVM1SImode
          || GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM1SImode
          || GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode)
              || !register_operand (operands[4], E_RVVMF2HImode))
            return -1;
          return 15;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVMF2QImode:
              if (!register_operand (operands[4], E_RVVMF2QImode))
                return -1;
              return 16;

            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern702 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVM8DImode:
      if (pattern702 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 19;

    case E_RVVM4DImode:
      if (pattern702 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 20;

    case E_RVVM2DImode:
      if (pattern702 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1DImode:
      if (pattern702 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_V1HImode:
      if (pattern702 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 23;

    case E_V2HImode:
      if (pattern702 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 24;

    case E_V4HImode:
      if (pattern702 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 25;

    case E_V8HImode:
      if (pattern702 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 26;

    case E_V16HImode:
      if (pattern702 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 27;

    case E_V32HImode:
      if (pattern702 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 28;

    case E_V64HImode:
      if (pattern702 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 29;

    case E_V128HImode:
      if (pattern702 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 30;

    case E_V256HImode:
      if (pattern702 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 31;

    case E_V512HImode:
      if (pattern702 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 32;

    case E_V1024HImode:
      if (pattern702 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 33;

    case E_V2048HImode:
      if (pattern702 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 34;

    case E_V1SImode:
      if (pattern702 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2SImode:
      if (pattern702 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4SImode:
      if (pattern702 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8SImode:
      if (pattern702 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16SImode:
      if (pattern702 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32SImode:
      if (pattern702 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64SImode:
      if (pattern702 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128SImode:
      if (pattern702 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256SImode:
      if (pattern702 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512SImode:
      if (pattern702 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024SImode:
      if (pattern702 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V1DImode:
      if (pattern702 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 46;

    case E_V2DImode:
      if (pattern702 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 47;

    case E_V4DImode:
      if (pattern702 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 48;

    case E_V8DImode:
      if (pattern702 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 49;

    case E_V16DImode:
      if (pattern702 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 50;

    case E_V32DImode:
      if (pattern702 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 51;

    case E_V64DImode:
      if (pattern702 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 52;

    case E_V128DImode:
      if (pattern702 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 53;

    case E_V256DImode:
      if (pattern702 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 54;

    case E_V512DImode:
      if (pattern702 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 55;

    default:
      return -1;
    }
}

int
pattern741 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern744 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  return 0;
}

int
pattern749 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x27, 1);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  return 0;
}

int
pattern756 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -24L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -28L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -48L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -56L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern764 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23)
        return -1;
      return 0;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21)
        return -1;
      return 1;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9
          || REGNO (x32) != 8
          || REGNO (x37) != 1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x42) != 10)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 10
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x46) != RETURN)
        return -1;
      x47 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x47) != USE)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 1
          || GET_MODE (x48) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x52, 1);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern794 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -44])
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  x63 = XEXP (x61, 1);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XVECEXP (x1, 0, 13);
  x67 = XEXP (x66, 0);
  if (GET_MODE (x67) != i1)
    return -1;
  x68 = XEXP (x66, 1);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x68, 0);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  x71 = XVECEXP (x1, 0, 14);
  x72 = XEXP (x71, 0);
  if (GET_MODE (x72) != i1)
    return -1;
  x73 = XVECEXP (x1, 0, 15);
  x74 = XEXP (x73, 0);
  if (GET_MODE (x74) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 869 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 9; /* *addsi3_extended2 */

    case MINUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 18; /* *subsi3_extended2 */

    case NEG:
      operands[2] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1102 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 22; /* *negsi2_extended2 */

    case MULT:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 29; /* *mulsi3_extended2 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 1967 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_XTHEADMEMIDX))
            return -1;
          return 127; /* *extendsidi2_internal */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 130; /* *extendqidi2 */
          if (!(
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 544; /* *extendqidi2_bitmanip */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 133; /* *extendhidi2 */
          if (!(
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 547; /* *extendhidi2_bitmanip */

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 128; /* *extendqihi2 */
          if (!
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 542; /* *extendqihi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 131; /* *extendhihi2 */
          if (!
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 545; /* *extendhihi2_bitmanip */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 129; /* *extendqisi2 */
          if (!
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 543; /* *extendqisi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 132; /* *extendhisi2 */
          if (!
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 546; /* *extendhisi2_bitmanip */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 65 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 874; /* *extendhihi2_th_ext */
          if (!
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return -1;
          return 929; /* *th_memidx_extendhihi2 */

        case 1:
          if (
#line 76 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 877; /* *extendqihi2_th_ext */
          if (
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 926; /* *th_memidx_extendqihi2 */
          if (!
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 937; /* *th_memidx_bb_extendqihi2 */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 65 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 875; /* *extendhisi2_th_ext */
          if (
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 930; /* *th_memidx_extendhisi2 */
          if (!
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 935; /* *th_memidx_bb_extendhisi2 */

        case 1:
          if (
#line 76 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 878; /* *extendqisi2_th_ext */
          if (
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 927; /* *th_memidx_extendqisi2 */
          if (!
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 938; /* *th_memidx_bb_extendqisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 65 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 876; /* *extendhidi2_th_ext */
          if ((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 931; /* *th_memidx_extendhidi2 */
          if (!(
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 936; /* *th_memidx_bb_extendhidi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 76 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 879; /* *extendqidi2_th_ext */
          if ((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 928; /* *th_memidx_extendqidi2 */
          if (!(
#line 628 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 939; /* *th_memidx_bb_extendqidi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 482 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX))
            return -1;
          return 922; /* *th_memidx_extendsidi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || pattern333 (x3) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28261; /* *pred_extract_first_sextdirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28262; /* *pred_extract_first_sextdirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28263; /* *pred_extract_first_sextdirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28264; /* *pred_extract_first_sextdirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28265; /* *pred_extract_first_sextdirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28266; /* *pred_extract_first_sextdirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28267; /* *pred_extract_first_sextdirvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 28279; /* *pred_extract_first_sextdiv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 28280; /* *pred_extract_first_sextdiv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 28281; /* *pred_extract_first_sextdiv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 28282; /* *pred_extract_first_sextdiv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 28283; /* *pred_extract_first_sextdiv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 28284; /* *pred_extract_first_sextdiv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28285; /* *pred_extract_first_sextdiv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28286; /* *pred_extract_first_sextdiv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28287; /* *pred_extract_first_sextdiv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28288; /* *pred_extract_first_sextdiv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28289; /* *pred_extract_first_sextdiv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28290; /* *pred_extract_first_sextdiv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28291; /* *pred_extract_first_sextdiv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28268; /* *pred_extract_first_sextdirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28269; /* *pred_extract_first_sextdirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28270; /* *pred_extract_first_sextdirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28271; /* *pred_extract_first_sextdirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28272; /* *pred_extract_first_sextdirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28273; /* *pred_extract_first_sextdirvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 28292; /* *pred_extract_first_sextdiv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 28293; /* *pred_extract_first_sextdiv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 28294; /* *pred_extract_first_sextdiv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 28295; /* *pred_extract_first_sextdiv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 28296; /* *pred_extract_first_sextdiv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28297; /* *pred_extract_first_sextdiv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28298; /* *pred_extract_first_sextdiv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28299; /* *pred_extract_first_sextdiv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28300; /* *pred_extract_first_sextdiv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28301; /* *pred_extract_first_sextdiv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28302; /* *pred_extract_first_sextdiv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28303; /* *pred_extract_first_sextdiv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8SImode:
              if (!register_operand (operands[1], E_RVVM8SImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28274; /* *pred_extract_first_sextdirvvm8si */

            case E_RVVM4SImode:
              if (!register_operand (operands[1], E_RVVM4SImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28275; /* *pred_extract_first_sextdirvvm4si */

            case E_RVVM2SImode:
              if (!register_operand (operands[1], E_RVVM2SImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28276; /* *pred_extract_first_sextdirvvm2si */

            case E_RVVM1SImode:
              if (!register_operand (operands[1], E_RVVM1SImode)
                  || !
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28277; /* *pred_extract_first_sextdirvvm1si */

            case E_RVVMF2SImode:
              if (!register_operand (operands[1], E_RVVMF2SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28278; /* *pred_extract_first_sextdirvvmf2si */

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 28304; /* *pred_extract_first_sextdiv1si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 28305; /* *pred_extract_first_sextdiv2si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 28306; /* *pred_extract_first_sextdiv4si */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 28307; /* *pred_extract_first_sextdiv8si */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28308; /* *pred_extract_first_sextdiv16si */

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28309; /* *pred_extract_first_sextdiv32si */

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28310; /* *pred_extract_first_sextdiv64si */

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28311; /* *pred_extract_first_sextdiv128si */

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28312; /* *pred_extract_first_sextdiv256si */

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28313; /* *pred_extract_first_sextdiv512si */

            case E_V1024SImode:
              if (!register_operand (operands[1], E_V1024SImode)
                  || !(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28314; /* *pred_extract_first_sextdiv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28315; /* *pred_extract_first_sextsirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28316; /* *pred_extract_first_sextsirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28317; /* *pred_extract_first_sextsirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28318; /* *pred_extract_first_sextsirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28319; /* *pred_extract_first_sextsirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28320; /* *pred_extract_first_sextsirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28321; /* *pred_extract_first_sextsirvvmf8qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28322; /* *pred_extract_first_sextsirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28323; /* *pred_extract_first_sextsirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28324; /* *pred_extract_first_sextsirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28325; /* *pred_extract_first_sextsirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28326; /* *pred_extract_first_sextsirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 85 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 561 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28327; /* *pred_extract_first_sextsirvvmf4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern149 (x2))
    {
    case 0:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30149; /* *dual_widen_suburvvm8hi */

    case 1:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30155; /* *dual_widen_suburvvm4hi */

    case 2:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30161; /* *dual_widen_suburvvm2hi */

    case 3:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30167; /* *dual_widen_suburvvm1hi */

    case 4:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30173; /* *dual_widen_suburvvmf2hi */

    case 5:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30179; /* *dual_widen_suburvvmf4hi */

    case 6:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30185; /* *dual_widen_suburvvm8si */

    case 7:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30191; /* *dual_widen_suburvvm4si */

    case 8:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30197; /* *dual_widen_suburvvm2si */

    case 9:
      if (!
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30203; /* *dual_widen_suburvvm1si */

    case 10:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30209; /* *dual_widen_suburvvmf2si */

    case 11:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30215; /* *dual_widen_suburvvm8di */

    case 12:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30221; /* *dual_widen_suburvvm4di */

    case 13:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30227; /* *dual_widen_suburvvm2di */

    case 14:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30233; /* *dual_widen_suburvvm1di */

    case 15:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30239; /* *dual_widen_subuv1hi */

    case 16:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30245; /* *dual_widen_subuv2hi */

    case 17:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30251; /* *dual_widen_subuv4hi */

    case 18:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30257; /* *dual_widen_subuv8hi */

    case 19:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30263; /* *dual_widen_subuv16hi */

    case 20:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30269; /* *dual_widen_subuv32hi */

    case 21:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30275; /* *dual_widen_subuv64hi */

    case 22:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30281; /* *dual_widen_subuv128hi */

    case 23:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30287; /* *dual_widen_subuv256hi */

    case 24:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30293; /* *dual_widen_subuv512hi */

    case 25:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30299; /* *dual_widen_subuv1024hi */

    case 26:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30305; /* *dual_widen_subuv2048hi */

    case 27:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30311; /* *dual_widen_subuv1si */

    case 28:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30317; /* *dual_widen_subuv2si */

    case 29:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30323; /* *dual_widen_subuv4si */

    case 30:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30329; /* *dual_widen_subuv8si */

    case 31:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30335; /* *dual_widen_subuv16si */

    case 32:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30341; /* *dual_widen_subuv32si */

    case 33:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30347; /* *dual_widen_subuv64si */

    case 34:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30353; /* *dual_widen_subuv128si */

    case 35:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30359; /* *dual_widen_subuv256si */

    case 36:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30365; /* *dual_widen_subuv512si */

    case 37:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30371; /* *dual_widen_subuv1024si */

    case 38:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30377; /* *dual_widen_subuv1di */

    case 39:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30383; /* *dual_widen_subuv2di */

    case 40:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30389; /* *dual_widen_subuv4di */

    case 41:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30395; /* *dual_widen_subuv8di */

    case 42:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30401; /* *dual_widen_subuv16di */

    case 43:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30407; /* *dual_widen_subuv32di */

    case 44:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30413; /* *dual_widen_subuv64di */

    case 45:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30419; /* *dual_widen_subuv128di */

    case 46:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30425; /* *dual_widen_subuv256di */

    case 47:
      if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30431; /* *dual_widen_subuv512di */

    case 48:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30531; /* *single_widen_first_suburvvm8hi */

    case 49:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30533; /* *single_widen_first_suburvvm4hi */

    case 50:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30535; /* *single_widen_first_suburvvm2hi */

    case 51:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30537; /* *single_widen_first_suburvvm1hi */

    case 52:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30539; /* *single_widen_first_suburvvmf2hi */

    case 53:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30541; /* *single_widen_first_suburvvmf4hi */

    case 54:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30543; /* *single_widen_first_suburvvm8si */

    case 55:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30545; /* *single_widen_first_suburvvm4si */

    case 56:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30547; /* *single_widen_first_suburvvm2si */

    case 57:
      if (!
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30549; /* *single_widen_first_suburvvm1si */

    case 58:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30551; /* *single_widen_first_suburvvmf2si */

    case 59:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30553; /* *single_widen_first_suburvvm8di */

    case 60:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30555; /* *single_widen_first_suburvvm4di */

    case 61:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30557; /* *single_widen_first_suburvvm2di */

    case 62:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30559; /* *single_widen_first_suburvvm1di */

    case 63:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30561; /* *single_widen_first_subuv1hi */

    case 64:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30563; /* *single_widen_first_subuv2hi */

    case 65:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30565; /* *single_widen_first_subuv4hi */

    case 66:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30567; /* *single_widen_first_subuv8hi */

    case 67:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30569; /* *single_widen_first_subuv16hi */

    case 68:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30571; /* *single_widen_first_subuv32hi */

    case 69:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30573; /* *single_widen_first_subuv64hi */

    case 70:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30575; /* *single_widen_first_subuv128hi */

    case 71:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30577; /* *single_widen_first_subuv256hi */

    case 72:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30579; /* *single_widen_first_subuv512hi */

    case 73:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30581; /* *single_widen_first_subuv1024hi */

    case 74:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30583; /* *single_widen_first_subuv2048hi */

    case 75:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30585; /* *single_widen_first_subuv1si */

    case 76:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30587; /* *single_widen_first_subuv2si */

    case 77:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30589; /* *single_widen_first_subuv4si */

    case 78:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30591; /* *single_widen_first_subuv8si */

    case 79:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30593; /* *single_widen_first_subuv16si */

    case 80:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30595; /* *single_widen_first_subuv32si */

    case 81:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30597; /* *single_widen_first_subuv64si */

    case 82:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30599; /* *single_widen_first_subuv128si */

    case 83:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30601; /* *single_widen_first_subuv256si */

    case 84:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30603; /* *single_widen_first_subuv512si */

    case 85:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30605; /* *single_widen_first_subuv1024si */

    case 86:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30607; /* *single_widen_first_subuv1di */

    case 87:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30609; /* *single_widen_first_subuv2di */

    case 88:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30611; /* *single_widen_first_subuv4di */

    case 89:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30613; /* *single_widen_first_subuv8di */

    case 90:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30615; /* *single_widen_first_subuv16di */

    case 91:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30617; /* *single_widen_first_subuv32di */

    case 92:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30619; /* *single_widen_first_subuv64di */

    case 93:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30621; /* *single_widen_first_subuv128di */

    case 94:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30623; /* *single_widen_first_subuv256di */

    case 95:
      if (!(
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30625; /* *single_widen_first_subuv512di */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern163 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32389; /* *vwsll_zext1_trunc_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32449; /* *vwsll_zext1_trunc_scalar_rvvm8si */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32390; /* *vwsll_zext1_trunc_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32450; /* *vwsll_zext1_trunc_scalar_rvvm4si */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32391; /* *vwsll_zext1_trunc_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32451; /* *vwsll_zext1_trunc_scalar_rvvm2si */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32392; /* *vwsll_zext1_trunc_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32452; /* *vwsll_zext1_trunc_scalar_rvvm1si */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32393; /* *vwsll_zext1_trunc_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32453; /* *vwsll_zext1_trunc_scalar_rvvmf2si */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32394; /* *vwsll_zext1_trunc_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32454; /* *vwsll_zext1_trunc_scalar_rvvm8di */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32395; /* *vwsll_zext1_trunc_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32455; /* *vwsll_zext1_trunc_scalar_rvvm4di */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32396; /* *vwsll_zext1_trunc_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32456; /* *vwsll_zext1_trunc_scalar_rvvm2di */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32397; /* *vwsll_zext1_trunc_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32457; /* *vwsll_zext1_trunc_scalar_rvvm1di */

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32398; /* *vwsll_zext1_trunc_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32458; /* *vwsll_zext1_trunc_scalar_v1si */

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32399; /* *vwsll_zext1_trunc_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32459; /* *vwsll_zext1_trunc_scalar_v2si */

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32400; /* *vwsll_zext1_trunc_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32460; /* *vwsll_zext1_trunc_scalar_v4si */

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32401; /* *vwsll_zext1_trunc_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32461; /* *vwsll_zext1_trunc_scalar_v8si */

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32402; /* *vwsll_zext1_trunc_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32462; /* *vwsll_zext1_trunc_scalar_v16si */

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32403; /* *vwsll_zext1_trunc_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32463; /* *vwsll_zext1_trunc_scalar_v32si */

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32404; /* *vwsll_zext1_trunc_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32464; /* *vwsll_zext1_trunc_scalar_v64si */

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32405; /* *vwsll_zext1_trunc_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32465; /* *vwsll_zext1_trunc_scalar_v128si */

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32406; /* *vwsll_zext1_trunc_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32466; /* *vwsll_zext1_trunc_scalar_v256si */

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32407; /* *vwsll_zext1_trunc_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32467; /* *vwsll_zext1_trunc_scalar_v512si */

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32408; /* *vwsll_zext1_trunc_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32468; /* *vwsll_zext1_trunc_scalar_v1024si */

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32409; /* *vwsll_zext1_trunc_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32469; /* *vwsll_zext1_trunc_scalar_v1di */

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32410; /* *vwsll_zext1_trunc_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32470; /* *vwsll_zext1_trunc_scalar_v2di */

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32411; /* *vwsll_zext1_trunc_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32471; /* *vwsll_zext1_trunc_scalar_v4di */

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32412; /* *vwsll_zext1_trunc_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32472; /* *vwsll_zext1_trunc_scalar_v8di */

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32413; /* *vwsll_zext1_trunc_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32473; /* *vwsll_zext1_trunc_scalar_v16di */

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32414; /* *vwsll_zext1_trunc_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32474; /* *vwsll_zext1_trunc_scalar_v32di */

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32415; /* *vwsll_zext1_trunc_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32475; /* *vwsll_zext1_trunc_scalar_v64di */

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32416; /* *vwsll_zext1_trunc_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32476; /* *vwsll_zext1_trunc_scalar_v128di */

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32417; /* *vwsll_zext1_trunc_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32477; /* *vwsll_zext1_trunc_scalar_v256di */

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && (
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32418; /* *vwsll_zext1_trunc_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32478; /* *vwsll_zext1_trunc_scalar_v512di */

    case 30:
      if (!
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32419; /* *vwsll_zext2_trunc_rvvm8si */

    case 31:
      if (!
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32420; /* *vwsll_zext2_trunc_rvvm4si */

    case 32:
      if (!
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32421; /* *vwsll_zext2_trunc_rvvm2si */

    case 33:
      if (!
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32422; /* *vwsll_zext2_trunc_rvvm1si */

    case 34:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32423; /* *vwsll_zext2_trunc_rvvmf2si */

    case 35:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32424; /* *vwsll_zext2_trunc_rvvm8di */

    case 36:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32425; /* *vwsll_zext2_trunc_rvvm4di */

    case 37:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32426; /* *vwsll_zext2_trunc_rvvm2di */

    case 38:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32427; /* *vwsll_zext2_trunc_rvvm1di */

    case 39:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32428; /* *vwsll_zext2_trunc_v1si */

    case 40:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32429; /* *vwsll_zext2_trunc_v2si */

    case 41:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32430; /* *vwsll_zext2_trunc_v4si */

    case 42:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32431; /* *vwsll_zext2_trunc_v8si */

    case 43:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32432; /* *vwsll_zext2_trunc_v16si */

    case 44:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32433; /* *vwsll_zext2_trunc_v32si */

    case 45:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32434; /* *vwsll_zext2_trunc_v64si */

    case 46:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32435; /* *vwsll_zext2_trunc_v128si */

    case 47:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32436; /* *vwsll_zext2_trunc_v256si */

    case 48:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32437; /* *vwsll_zext2_trunc_v512si */

    case 49:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32438; /* *vwsll_zext2_trunc_v1024si */

    case 50:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32439; /* *vwsll_zext2_trunc_v1di */

    case 51:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32440; /* *vwsll_zext2_trunc_v2di */

    case 52:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32441; /* *vwsll_zext2_trunc_v4di */

    case 53:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32442; /* *vwsll_zext2_trunc_v8di */

    case 54:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32443; /* *vwsll_zext2_trunc_v16di */

    case 55:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32444; /* *vwsll_zext2_trunc_v32di */

    case 56:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32445; /* *vwsll_zext2_trunc_v64di */

    case 57:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32446; /* *vwsll_zext2_trunc_v128di */

    case 58:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32447; /* *vwsll_zext2_trunc_v256di */

    case 59:
      if (!(
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32448; /* *vwsll_zext2_trunc_v512di */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern241 (x3))
    {
    case 0:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27891; /* copysignrvvm8hf3 */

    case 1:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27892; /* copysignrvvm4hf3 */

    case 2:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27893; /* copysignrvvm2hf3 */

    case 3:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27894; /* copysignrvvm1hf3 */

    case 4:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27895; /* copysignrvvmf2hf3 */

    case 5:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27896; /* copysignrvvmf4hf3 */

    case 6:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27897; /* copysignrvvm8sf3 */

    case 7:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27898; /* copysignrvvm4sf3 */

    case 8:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27899; /* copysignrvvm2sf3 */

    case 9:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27900; /* copysignrvvm1sf3 */

    case 10:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27901; /* copysignrvvmf2sf3 */

    case 11:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27902; /* copysignrvvm8df3 */

    case 12:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27903; /* copysignrvvm4df3 */

    case 13:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27904; /* copysignrvvm2df3 */

    case 14:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27905; /* copysignrvvm1df3 */

    case 15:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27906; /* copysignv1hf3 */

    case 16:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27907; /* copysignv2hf3 */

    case 17:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27908; /* copysignv4hf3 */

    case 18:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27909; /* copysignv8hf3 */

    case 19:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27910; /* copysignv16hf3 */

    case 20:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27911; /* copysignv32hf3 */

    case 21:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27912; /* copysignv64hf3 */

    case 22:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27913; /* copysignv128hf3 */

    case 23:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27914; /* copysignv256hf3 */

    case 24:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27915; /* copysignv512hf3 */

    case 25:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27916; /* copysignv1024hf3 */

    case 26:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27917; /* copysignv2048hf3 */

    case 27:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27918; /* copysignv1sf3 */

    case 28:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27919; /* copysignv2sf3 */

    case 29:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27920; /* copysignv4sf3 */

    case 30:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27921; /* copysignv8sf3 */

    case 31:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27922; /* copysignv16sf3 */

    case 32:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27923; /* copysignv32sf3 */

    case 33:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27924; /* copysignv64sf3 */

    case 34:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27925; /* copysignv128sf3 */

    case 35:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27926; /* copysignv256sf3 */

    case 36:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27927; /* copysignv512sf3 */

    case 37:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27928; /* copysignv1024sf3 */

    case 38:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27929; /* copysignv1df3 */

    case 39:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27930; /* copysignv2df3 */

    case 40:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27931; /* copysignv4df3 */

    case 41:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27932; /* copysignv8df3 */

    case 42:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27933; /* copysignv16df3 */

    case 43:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27934; /* copysignv32df3 */

    case 44:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27935; /* copysignv64df3 */

    case 45:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27936; /* copysignv128df3 */

    case 46:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27937; /* copysignv256df3 */

    case 47:
      if (!(
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27938; /* copysignv512df3 */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern167 (x1))
    {
    case 0:
      if (!(
#line 3573 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 394; /* fle_quietsfsi4_zfa */

    case 1:
      if (!(
#line 3573 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 398; /* fle_quietdfsi4_zfa */

    case 2:
      if (!(
#line 3573 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 402; /* fle_quiethfsi4_zfa */

    case 3:
      if (!(
#line 3573 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 396; /* fle_quietsfdi4_zfa */

    case 4:
      if (!(
#line 3573 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 400; /* fle_quietdfdi4_zfa */

    case 5:
      if (!(
#line 3573 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 404; /* fle_quiethfdi4_zfa */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !(
#line 2333 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 257; /* rintsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 2333 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 258; /* rintdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 2333 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 259; /* rinthf2 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF8QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8695; /* pred_madcrvvmf8qi_scalar */

    case E_RVVMF4HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8701; /* pred_madcrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8706; /* pred_madcrvvmf2si_scalar */

    case E_RVVM1DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 3567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8800; /* *pred_madcrvvm1di_scalar */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V512QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8716; /* pred_madcv512qi_scalar */

    case E_V512HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8729; /* pred_madcv512hi_scalar */

    case E_V512SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8741; /* pred_madcv512si_scalar */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18676; /* pred_redxor_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18684; /* pred_redxor_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18692; /* pred_redxor_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18700; /* pred_redxor_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18804; /* pred_redxor_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18812; /* pred_redxor_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18820; /* pred_redxor_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18852; /* pred_redxor_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18860; /* pred_redxor_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18868; /* pred_redxor_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18876; /* pred_redxor_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18884; /* pred_redxor_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18892; /* pred_redxor_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18900; /* pred_redxor_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18908; /* pred_redxor_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18916; /* pred_redxor_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18924; /* pred_redxor_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18932; /* pred_redxor_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18940; /* pred_redxor_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18948; /* pred_redxor_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18708; /* pred_redxor_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18716; /* pred_redxor_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18724; /* pred_redxor_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18732; /* pred_redxor_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18828; /* pred_redxor_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18836; /* pred_redxor_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18956; /* pred_redxor_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18964; /* pred_redxor_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18972; /* pred_redxor_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18980; /* pred_redxor_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18988; /* pred_redxor_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18996; /* pred_redxor_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19004; /* pred_redxor_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19012; /* pred_redxor_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19020; /* pred_redxor_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19028; /* pred_redxor_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19036; /* pred_redxor_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19044; /* pred_redxor_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18740; /* pred_redxor_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18748; /* pred_redxor_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18756; /* pred_redxor_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18764; /* pred_redxor_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18844; /* pred_redxor_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19052; /* pred_redxor_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19060; /* pred_redxor_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19068; /* pred_redxor_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19076; /* pred_redxor_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19084; /* pred_redxor_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19092; /* pred_redxor_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19100; /* pred_redxor_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19108; /* pred_redxor_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19116; /* pred_redxor_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19124; /* pred_redxor_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19132; /* pred_redxor_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18772; /* pred_redxor_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18780; /* pred_redxor_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18788; /* pred_redxor_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18796; /* pred_redxor_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19140; /* pred_redxor_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19148; /* pred_redxor_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19156; /* pred_redxor_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19164; /* pred_redxor_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19172; /* pred_redxor_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19180; /* pred_redxor_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19188; /* pred_redxor_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19196; /* pred_redxor_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19204; /* pred_redxor_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19212; /* pred_redxor_vl0sv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18672; /* pred_redminu_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18680; /* pred_redminu_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18688; /* pred_redminu_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18696; /* pred_redminu_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18800; /* pred_redminu_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18808; /* pred_redminu_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18816; /* pred_redminu_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18848; /* pred_redminu_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18856; /* pred_redminu_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18864; /* pred_redminu_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18872; /* pred_redminu_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18880; /* pred_redminu_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18888; /* pred_redminu_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18896; /* pred_redminu_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18904; /* pred_redminu_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18912; /* pred_redminu_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18920; /* pred_redminu_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18928; /* pred_redminu_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18936; /* pred_redminu_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18944; /* pred_redminu_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18704; /* pred_redminu_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18712; /* pred_redminu_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18720; /* pred_redminu_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18728; /* pred_redminu_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18824; /* pred_redminu_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18832; /* pred_redminu_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18952; /* pred_redminu_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18960; /* pred_redminu_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18968; /* pred_redminu_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18976; /* pred_redminu_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18984; /* pred_redminu_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18992; /* pred_redminu_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19000; /* pred_redminu_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19008; /* pred_redminu_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19016; /* pred_redminu_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19024; /* pred_redminu_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19032; /* pred_redminu_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19040; /* pred_redminu_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18736; /* pred_redminu_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18744; /* pred_redminu_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18752; /* pred_redminu_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18760; /* pred_redminu_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18840; /* pred_redminu_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19048; /* pred_redminu_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19056; /* pred_redminu_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19064; /* pred_redminu_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19072; /* pred_redminu_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19080; /* pred_redminu_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19088; /* pred_redminu_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19096; /* pred_redminu_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19104; /* pred_redminu_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19112; /* pred_redminu_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19120; /* pred_redminu_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19128; /* pred_redminu_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18768; /* pred_redminu_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18776; /* pred_redminu_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18784; /* pred_redminu_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18792; /* pred_redminu_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19136; /* pred_redminu_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19144; /* pred_redminu_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19152; /* pred_redminu_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19160; /* pred_redminu_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19168; /* pred_redminu_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19176; /* pred_redminu_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19184; /* pred_redminu_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19192; /* pred_redminu_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19200; /* pred_redminu_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19208; /* pred_redminu_vl0sv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18125; /* pred_redsumrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18133; /* pred_redsumrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18141; /* pred_redsumrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18149; /* pred_redsumrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18253; /* pred_redsumrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18261; /* pred_redsumrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18269; /* pred_redsumrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18301; /* pred_redsumv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18309; /* pred_redsumv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18317; /* pred_redsumv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18325; /* pred_redsumv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18333; /* pred_redsumv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18341; /* pred_redsumv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18349; /* pred_redsumv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18357; /* pred_redsumv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18365; /* pred_redsumv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18373; /* pred_redsumv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18381; /* pred_redsumv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18389; /* pred_redsumv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18397; /* pred_redsumv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18157; /* pred_redsumrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18165; /* pred_redsumrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18173; /* pred_redsumrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18181; /* pred_redsumrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18277; /* pred_redsumrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18285; /* pred_redsumrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18405; /* pred_redsumv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18413; /* pred_redsumv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18421; /* pred_redsumv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18429; /* pred_redsumv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18437; /* pred_redsumv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18445; /* pred_redsumv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18453; /* pred_redsumv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18461; /* pred_redsumv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18469; /* pred_redsumv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18477; /* pred_redsumv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18485; /* pred_redsumv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18493; /* pred_redsumv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18189; /* pred_redsumrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18197; /* pred_redsumrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18205; /* pred_redsumrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18213; /* pred_redsumrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18293; /* pred_redsumrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18501; /* pred_redsumv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18509; /* pred_redsumv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18517; /* pred_redsumv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18525; /* pred_redsumv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18533; /* pred_redsumv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18541; /* pred_redsumv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18549; /* pred_redsumv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18557; /* pred_redsumv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18565; /* pred_redsumv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18573; /* pred_redsumv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18581; /* pred_redsumv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18221; /* pred_redsumrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18229; /* pred_redsumrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18237; /* pred_redsumrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18245; /* pred_redsumrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18589; /* pred_redsumv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18597; /* pred_redsumv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18605; /* pred_redsumv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18613; /* pred_redsumv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18621; /* pred_redsumv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18629; /* pred_redsumv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18637; /* pred_redsumv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18645; /* pred_redsumv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18653; /* pred_redsumv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18661; /* pred_redsumv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 6:
      return recog_84 (x1, insn, pnum_clobbers);

    case 8:
      x8 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 66
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 67
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 69
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[5] = x12;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x3, 0, 3);
      operands[7] = x14;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x15 = XVECEXP (x3, 0, 4);
      operands[8] = x15;
      if (!const_int_operand (operands[8], E_VOIDmode))
        return -1;
      switch (XINT (x4, 1))
        {
        case 145:
          return recog_83 (x1, insn, pnum_clobbers);

        case 146:
          return recog_82 (x1, insn, pnum_clobbers);

        case 147:
          return recog_81 (x1, insn, pnum_clobbers);

        case 148:
          return recog_80 (x1, insn, pnum_clobbers);

        case 167:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19813; /* pred_wredosumrvvm8hf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19815; /* pred_wredosumrvvm4hf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19817; /* pred_wredosumrvvm2hf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19819; /* pred_wredosumrvvm1hf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19821; /* pred_wredosumrvvmf2hf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19823; /* pred_wredosumrvvmf4hf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19835; /* pred_wredosumv1hf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19837; /* pred_wredosumv2hf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19839; /* pred_wredosumv4hf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19841; /* pred_wredosumv8hf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19843; /* pred_wredosumv16hf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19845; /* pred_wredosumv32hf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19847; /* pred_wredosumv64hf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19849; /* pred_wredosumv128hf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19851; /* pred_wredosumv256hf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19853; /* pred_wredosumv512hf */

                case 16:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19855; /* pred_wredosumv1024hf */

                case 17:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19857; /* pred_wredosumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19825; /* pred_wredosumrvvm8sf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19827; /* pred_wredosumrvvm4sf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19829; /* pred_wredosumrvvm2sf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19831; /* pred_wredosumrvvm1sf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19833; /* pred_wredosumrvvmf2sf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19859; /* pred_wredosumv1sf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19861; /* pred_wredosumv2sf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19863; /* pred_wredosumv4sf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19865; /* pred_wredosumv8sf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19867; /* pred_wredosumv16sf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19869; /* pred_wredosumv32sf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19871; /* pred_wredosumv64sf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19873; /* pred_wredosumv128sf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19875; /* pred_wredosumv256sf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19877; /* pred_wredosumv512sf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19879; /* pred_wredosumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 168:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19814; /* pred_wredusumrvvm8hf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19816; /* pred_wredusumrvvm4hf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19818; /* pred_wredusumrvvm2hf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19820; /* pred_wredusumrvvm1hf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19822; /* pred_wredusumrvvmf2hf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19824; /* pred_wredusumrvvmf4hf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19836; /* pred_wredusumv1hf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19838; /* pred_wredusumv2hf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19840; /* pred_wredusumv4hf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19842; /* pred_wredusumv8hf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19844; /* pred_wredusumv16hf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19846; /* pred_wredusumv32hf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19848; /* pred_wredusumv64hf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19850; /* pred_wredusumv128hf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19852; /* pred_wredusumv256hf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19854; /* pred_wredusumv512hf */

                case 16:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19856; /* pred_wredusumv1024hf */

                case 17:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19858; /* pred_wredusumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19826; /* pred_wredusumrvvm8sf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19828; /* pred_wredusumrvvm4sf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19830; /* pred_wredusumrvvm2sf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19832; /* pred_wredusumrvvm1sf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19834; /* pred_wredusumrvvmf2sf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19860; /* pred_wredusumv1sf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19862; /* pred_wredusumv2sf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19864; /* pred_wredusumv4sf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19866; /* pred_wredusumv8sf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19868; /* pred_wredusumv16sf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19870; /* pred_wredusumv32sf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19872; /* pred_wredusumv64sf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19874; /* pred_wredusumv128sf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19876; /* pred_wredusumv256sf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19878; /* pred_wredusumv512sf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19880; /* pred_wredusumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 169:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19881; /* pred_wredosum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19883; /* pred_wredosum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19885; /* pred_wredosum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19887; /* pred_wredosum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19889; /* pred_wredosum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19891; /* pred_wredosum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19903; /* pred_wredosum_vl0sv1hf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19905; /* pred_wredosum_vl0sv2hf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19907; /* pred_wredosum_vl0sv4hf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19909; /* pred_wredosum_vl0sv8hf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19911; /* pred_wredosum_vl0sv16hf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19913; /* pred_wredosum_vl0sv32hf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19915; /* pred_wredosum_vl0sv64hf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19917; /* pred_wredosum_vl0sv128hf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19919; /* pred_wredosum_vl0sv256hf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19921; /* pred_wredosum_vl0sv512hf */

                case 16:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19923; /* pred_wredosum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19925; /* pred_wredosum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19893; /* pred_wredosum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19895; /* pred_wredosum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19897; /* pred_wredosum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19899; /* pred_wredosum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19901; /* pred_wredosum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19927; /* pred_wredosum_vl0sv1sf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19929; /* pred_wredosum_vl0sv2sf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19931; /* pred_wredosum_vl0sv4sf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19933; /* pred_wredosum_vl0sv8sf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19935; /* pred_wredosum_vl0sv16sf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19937; /* pred_wredosum_vl0sv32sf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19939; /* pred_wredosum_vl0sv64sf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19941; /* pred_wredosum_vl0sv128sf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19943; /* pred_wredosum_vl0sv256sf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19945; /* pred_wredosum_vl0sv512sf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19947; /* pred_wredosum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 170:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19882; /* pred_wredusum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19884; /* pred_wredusum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19886; /* pred_wredusum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19888; /* pred_wredusum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19890; /* pred_wredusum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19892; /* pred_wredusum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19904; /* pred_wredusum_vl0sv1hf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19906; /* pred_wredusum_vl0sv2hf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19908; /* pred_wredusum_vl0sv4hf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19910; /* pred_wredusum_vl0sv8hf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19912; /* pred_wredusum_vl0sv16hf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19914; /* pred_wredusum_vl0sv32hf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19916; /* pred_wredusum_vl0sv64hf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19918; /* pred_wredusum_vl0sv128hf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19920; /* pred_wredusum_vl0sv256hf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19922; /* pred_wredusum_vl0sv512hf */

                case 16:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19924; /* pred_wredusum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19926; /* pred_wredusum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19894; /* pred_wredusum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19896; /* pred_wredusum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19898; /* pred_wredusum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19900; /* pred_wredusum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 19902; /* pred_wredusum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19928; /* pred_wredusum_vl0sv1sf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19930; /* pred_wredusum_vl0sv2sf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19932; /* pred_wredusum_vl0sv4sf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19934; /* pred_wredusum_vl0sv8sf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19936; /* pred_wredusum_vl0sv16sf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19938; /* pred_wredusum_vl0sv32sf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19940; /* pred_wredusum_vl0sv64sf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19942; /* pred_wredusum_vl0sv128sf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19944; /* pred_wredusum_vl0sv256sf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19946; /* pred_wredusum_vl0sv512sf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19948; /* pred_wredusum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20487; /* pred_slide1uprvvm8hf */

    case 1:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20489; /* pred_slide1uprvvm4hf */

    case 2:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20491; /* pred_slide1uprvvm2hf */

    case 3:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20493; /* pred_slide1uprvvm1hf */

    case 4:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20495; /* pred_slide1uprvvmf2hf */

    case 5:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20497; /* pred_slide1uprvvmf4hf */

    case 6:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20499; /* pred_slide1uprvvm8sf */

    case 7:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20501; /* pred_slide1uprvvm4sf */

    case 8:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20503; /* pred_slide1uprvvm2sf */

    case 9:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20505; /* pred_slide1uprvvm1sf */

    case 10:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20507; /* pred_slide1uprvvmf2sf */

    case 11:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20509; /* pred_slide1uprvvm8df */

    case 12:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20511; /* pred_slide1uprvvm4df */

    case 13:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20513; /* pred_slide1uprvvm2df */

    case 14:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20515; /* pred_slide1uprvvm1df */

    case 15:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 20517; /* pred_slide1upv1hf */

    case 16:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 20519; /* pred_slide1upv2hf */

    case 17:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 20521; /* pred_slide1upv4hf */

    case 18:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 20523; /* pred_slide1upv8hf */

    case 19:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 20525; /* pred_slide1upv16hf */

    case 20:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20527; /* pred_slide1upv32hf */

    case 21:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20529; /* pred_slide1upv64hf */

    case 22:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20531; /* pred_slide1upv128hf */

    case 23:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20533; /* pred_slide1upv256hf */

    case 24:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20535; /* pred_slide1upv512hf */

    case 25:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20537; /* pred_slide1upv1024hf */

    case 26:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20539; /* pred_slide1upv2048hf */

    case 27:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20541; /* pred_slide1upv1sf */

    case 28:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20543; /* pred_slide1upv2sf */

    case 29:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20545; /* pred_slide1upv4sf */

    case 30:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20547; /* pred_slide1upv8sf */

    case 31:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20549; /* pred_slide1upv16sf */

    case 32:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20551; /* pred_slide1upv32sf */

    case 33:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20553; /* pred_slide1upv64sf */

    case 34:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20555; /* pred_slide1upv128sf */

    case 35:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20557; /* pred_slide1upv256sf */

    case 36:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20559; /* pred_slide1upv512sf */

    case 37:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20561; /* pred_slide1upv1024sf */

    case 38:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20563; /* pred_slide1upv1df */

    case 39:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20565; /* pred_slide1upv2df */

    case 40:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20567; /* pred_slide1upv4df */

    case 41:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20569; /* pred_slide1upv8df */

    case 42:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20571; /* pred_slide1upv16df */

    case 43:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20573; /* pred_slide1upv32df */

    case 44:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20575; /* pred_slide1upv64df */

    case 45:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20577; /* pred_slide1upv128df */

    case 46:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20579; /* pred_slide1upv256df */

    case 47:
      if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20581; /* pred_slide1upv512df */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 186:
      switch (pattern183 (x1, 
186))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2325; /* pred_indexed_store_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2331; /* pred_indexed_store_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2349; /* pred_indexed_store_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2337; /* pred_indexed_store_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2355; /* pred_indexed_store_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2373; /* pred_indexed_store_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2343; /* pred_indexed_store_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2361; /* pred_indexed_store_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2379; /* pred_indexed_store_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2397; /* pred_indexed_store_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2367; /* pred_indexed_store_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2385; /* pred_indexed_store_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2403; /* pred_indexed_store_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2391; /* pred_indexed_store_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2409; /* pred_indexed_store_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2415; /* pred_indexed_store_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2421; /* pred_indexed_store_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2427; /* pred_indexed_store_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2433; /* pred_indexed_store_widthbrvvmf2si */

        default:
          return -1;
        }

    case 188:
      switch (pattern183 (x1, 
188))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2326; /* pred_indexed_store_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2332; /* pred_indexed_store_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2350; /* pred_indexed_store_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2338; /* pred_indexed_store_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2356; /* pred_indexed_store_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2374; /* pred_indexed_store_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2344; /* pred_indexed_store_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2362; /* pred_indexed_store_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2380; /* pred_indexed_store_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2398; /* pred_indexed_store_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2368; /* pred_indexed_store_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2386; /* pred_indexed_store_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2404; /* pred_indexed_store_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2392; /* pred_indexed_store_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2410; /* pred_indexed_store_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2416; /* pred_indexed_store_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2422; /* pred_indexed_store_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2428; /* pred_indexed_store_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2434; /* pred_indexed_store_widthhrvvmf2si */

        default:
          return -1;
        }

    case 190:
      switch (pattern183 (x1, 
190))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2327; /* pred_indexed_store_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2333; /* pred_indexed_store_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2351; /* pred_indexed_store_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2339; /* pred_indexed_store_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2357; /* pred_indexed_store_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2375; /* pred_indexed_store_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2345; /* pred_indexed_store_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2363; /* pred_indexed_store_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2381; /* pred_indexed_store_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2399; /* pred_indexed_store_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2369; /* pred_indexed_store_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2387; /* pred_indexed_store_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2405; /* pred_indexed_store_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2393; /* pred_indexed_store_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2411; /* pred_indexed_store_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2417; /* pred_indexed_store_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2423; /* pred_indexed_store_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2429; /* pred_indexed_store_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2435; /* pred_indexed_store_widthwrvvmf2si */

        default:
          return -1;
        }

    case 192:
      switch (pattern183 (x1, 
192))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2328; /* pred_indexed_ustore_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2334; /* pred_indexed_ustore_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2352; /* pred_indexed_ustore_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2340; /* pred_indexed_ustore_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2358; /* pred_indexed_ustore_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2376; /* pred_indexed_ustore_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2346; /* pred_indexed_ustore_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2364; /* pred_indexed_ustore_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2382; /* pred_indexed_ustore_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2400; /* pred_indexed_ustore_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2370; /* pred_indexed_ustore_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2388; /* pred_indexed_ustore_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2406; /* pred_indexed_ustore_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2394; /* pred_indexed_ustore_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2412; /* pred_indexed_ustore_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2418; /* pred_indexed_ustore_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2424; /* pred_indexed_ustore_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2430; /* pred_indexed_ustore_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2436; /* pred_indexed_ustore_widthbrvvmf2si */

        default:
          return -1;
        }

    case 193:
      switch (pattern183 (x1, 
193))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2329; /* pred_indexed_ustore_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2335; /* pred_indexed_ustore_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2353; /* pred_indexed_ustore_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2341; /* pred_indexed_ustore_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2359; /* pred_indexed_ustore_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2377; /* pred_indexed_ustore_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2347; /* pred_indexed_ustore_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2365; /* pred_indexed_ustore_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2383; /* pred_indexed_ustore_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2401; /* pred_indexed_ustore_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2371; /* pred_indexed_ustore_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2389; /* pred_indexed_ustore_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2407; /* pred_indexed_ustore_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2395; /* pred_indexed_ustore_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2413; /* pred_indexed_ustore_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2419; /* pred_indexed_ustore_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2425; /* pred_indexed_ustore_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2431; /* pred_indexed_ustore_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2437; /* pred_indexed_ustore_widthhrvvmf2si */

        default:
          return -1;
        }

    case 194:
      switch (pattern183 (x1, 
194))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2330; /* pred_indexed_ustore_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2336; /* pred_indexed_ustore_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2354; /* pred_indexed_ustore_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2342; /* pred_indexed_ustore_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2360; /* pred_indexed_ustore_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2378; /* pred_indexed_ustore_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2348; /* pred_indexed_ustore_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2366; /* pred_indexed_ustore_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2384; /* pred_indexed_ustore_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2402; /* pred_indexed_ustore_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2372; /* pred_indexed_ustore_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2390; /* pred_indexed_ustore_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2408; /* pred_indexed_ustore_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2396; /* pred_indexed_ustore_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2414; /* pred_indexed_ustore_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2420; /* pred_indexed_ustore_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2426; /* pred_indexed_ustore_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2432; /* pred_indexed_ustore_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2438; /* pred_indexed_ustore_widthwrvvmf2si */

        default:
          return -1;
        }

    case 91:
      if (pattern184 (x1, 
67) != 0
          || !const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 1743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3644; /* vsetvl_vtype_change_only */

    case 96:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 93)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 66
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 67
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SCRATCH)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[4] = x12;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      return recog_93 (x1, insn, pnum_clobbers);

    case 97:
      return recog_97 (x1, insn, pnum_clobbers);

    case 98:
      return recog_96 (x1, insn, pnum_clobbers);

    case 128:
      return recog_100 (x1, insn, pnum_clobbers);

    case 129:
      return recog_99 (x1, insn, pnum_clobbers);

    case 130:
      return recog_101 (x1, insn, pnum_clobbers);

    case 131:
      return recog_102 (x1, insn, pnum_clobbers);

    case 132:
      return recog_103 (x1, insn, pnum_clobbers);

    case 133:
      switch (pattern197 (x1))
        {
        case 0:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20488; /* pred_slide1downrvvm8hf */

        case 1:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20490; /* pred_slide1downrvvm4hf */

        case 2:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20492; /* pred_slide1downrvvm2hf */

        case 3:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20494; /* pred_slide1downrvvm1hf */

        case 4:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20496; /* pred_slide1downrvvmf2hf */

        case 5:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20498; /* pred_slide1downrvvmf4hf */

        case 6:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20500; /* pred_slide1downrvvm8sf */

        case 7:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20502; /* pred_slide1downrvvm4sf */

        case 8:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20504; /* pred_slide1downrvvm2sf */

        case 9:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20506; /* pred_slide1downrvvm1sf */

        case 10:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20508; /* pred_slide1downrvvmf2sf */

        case 11:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20510; /* pred_slide1downrvvm8df */

        case 12:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20512; /* pred_slide1downrvvm4df */

        case 13:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20514; /* pred_slide1downrvvm2df */

        case 14:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20516; /* pred_slide1downrvvm1df */

        case 15:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20518; /* pred_slide1downv1hf */

        case 16:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20520; /* pred_slide1downv2hf */

        case 17:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20522; /* pred_slide1downv4hf */

        case 18:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20524; /* pred_slide1downv8hf */

        case 19:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20526; /* pred_slide1downv16hf */

        case 20:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20528; /* pred_slide1downv32hf */

        case 21:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20530; /* pred_slide1downv64hf */

        case 22:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20532; /* pred_slide1downv128hf */

        case 23:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20534; /* pred_slide1downv256hf */

        case 24:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20536; /* pred_slide1downv512hf */

        case 25:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20538; /* pred_slide1downv1024hf */

        case 26:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20540; /* pred_slide1downv2048hf */

        case 27:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20542; /* pred_slide1downv1sf */

        case 28:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20544; /* pred_slide1downv2sf */

        case 29:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20546; /* pred_slide1downv4sf */

        case 30:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20548; /* pred_slide1downv8sf */

        case 31:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20550; /* pred_slide1downv16sf */

        case 32:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20552; /* pred_slide1downv32sf */

        case 33:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20554; /* pred_slide1downv64sf */

        case 34:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20556; /* pred_slide1downv128sf */

        case 35:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20558; /* pred_slide1downv256sf */

        case 36:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20560; /* pred_slide1downv512sf */

        case 37:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20562; /* pred_slide1downv1024sf */

        case 38:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20564; /* pred_slide1downv1df */

        case 39:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20566; /* pred_slide1downv2df */

        case 40:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20568; /* pred_slide1downv4df */

        case 41:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20570; /* pred_slide1downv8df */

        case 42:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20572; /* pred_slide1downv16df */

        case 43:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20574; /* pred_slide1downv32df */

        case 44:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20576; /* pred_slide1downv64df */

        case 45:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20578; /* pred_slide1downv128df */

        case 46:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20580; /* pred_slide1downv256df */

        case 47:
          if (!(
#line 8218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20582; /* pred_slide1downv512df */

        default:
          return -1;
        }

    case 95:
      return recog_98 (x1, insn, pnum_clobbers);

    case 374:
      if (pattern198 (x1) != 0
          || !
#line 2566 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34084; /* riscv_cv_simd_cplxmul_r_si */

    case 375:
      if (pattern198 (x1) != 0
          || !
#line 2583 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34085; /* riscv_cv_simd_cplxmul_i_si */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HFmode)
      && reg_or_mem_operand (operands[1], E_V1024HFmode))
    {
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3294; /* *movv1024hfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3295; /* *movv1024hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HFmode)
      || !register_operand (operands[1], E_V1024HFmode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3392; /* *movv1024hf_vls */
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512DImode)
      && reg_or_mem_operand (operands[1], E_V512DImode))
    {
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3282; /* *movv512disi_lra */
        }
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3283; /* *movv512didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512DImode)
      || !register_operand (operands[1], E_V512DImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3381; /* *movv512di_vls */
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SImode)
      && reg_or_mem_operand (operands[1], E_V512SImode))
    {
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3270; /* *movv512sisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3271; /* *movv512sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SImode)
      || !register_operand (operands[1], E_V512SImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3370; /* *movv512si_vls */
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode))
    {
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3258; /* *movv1024hisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3259; /* *movv1024hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3359; /* *movv1024hi_vls */
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode))
    {
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv4096qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3247; /* *movv4096qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3348; /* *movv4096qi_vls */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode))
    {
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv64qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3235; /* *movv64qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3342; /* *movv64qi_vls */
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF16BImode)
      && register_operand (operands[1], E_RVVMF16BImode)
      && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2814; /* *movrvvmf16bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF16BImode))
    return -1;
  if ((
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2852; /* *movrvvmf16bisi_lra */
    }
  if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2853; /* *movrvvmf16bidi_lra */
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2HFmode)
      && register_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 2797; /* *movrvvmf2hf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2HFmode))
    return -1;
  if ((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2833; /* *movrvvmf2hfsi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2844; /* *movrvvmf2hfdi_lra */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4QImode)
      && register_operand (operands[1], E_RVVMF4QImode)
      && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return 2791; /* *movrvvmf4qi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4QImode))
    return -1;
  if ((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2827; /* *movrvvmf4qisi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2838; /* *movrvvmf4qidi_lra */
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2BImode)
      && reg_or_mem_operand (operands[1], E_V2BImode)
      && (
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2BImode)
       || register_operand (operands[1], V2BImode))) && 
#line 4341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
    return 3228; /* *movv2bi */
  if (!register_operand (operands[0], E_V2BImode)
      || !register_operand (operands[1], E_V2BImode)
      || !(
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
    return -1;
  return 3495; /* *movv2bi_vls */
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DFmode)
      && reg_or_mem_operand (operands[1], E_V1DFmode)
      && (
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DFmode)
       || register_operand (operands[1], V1DFmode))) && 
#line 4334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3222; /* *movv1df */
  if (!register_operand (operands[0], E_V1DFmode)
      || !register_operand (operands[1], E_V1DFmode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3405; /* *movv1df_vls */
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode)
      && (
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3216; /* *movv16hf */
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3386; /* *movv16hf_vls */
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DImode)
      && reg_or_mem_operand (operands[1], E_V8DImode)
      && (
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))) && 
#line 4322 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 3210; /* *movv8di */
  if (!register_operand (operands[0], E_V8DImode)
      || !register_operand (operands[1], E_V8DImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3375; /* *movv8di_vls */
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode)
      && (
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4316 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 3204; /* *movv4si */
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 3363; /* *movv4si_vls */
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode)
      && (
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 3197; /* *movv1hi */
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !(
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 3349; /* *movv1hi_vls */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3190; /* *movrvvm4x2qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3191; /* *movrvvm4x2qi_di */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3176; /* *movrvvm4x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3177; /* *movrvvm4x2sf_di */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3162; /* *movrvvm4x2si_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3163; /* *movrvvm4x2si_di */
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3150; /* *movrvvm1x6qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3151; /* *movrvvm1x6qi_di */
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3136; /* *movrvvm2x3sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3137; /* *movrvvm2x3sf_di */
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3122; /* *movrvvm1x3hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3123; /* *movrvvm1x3hf_di */
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3108; /* *movrvvm1x3bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3109; /* *movrvvm1x3bf_di */
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3088; /* *movrvvm1x4hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3089; /* *movrvvm1x4hi_di */
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3072; /* *movrvvmf2x3qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3073; /* *movrvvmf2x3qi_di */
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3056; /* *movrvvm1x5sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3057; /* *movrvvm1x5sf_di */
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3040; /* *movrvvmf2x4hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3041; /* *movrvvmf2x4hf_di */
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3024; /* *movrvvmf2x3bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3025; /* *movrvvmf2x3bf_di */
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3008; /* *movrvvm1x5si_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3009; /* *movrvvm1x5si_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2994; /* *movrvvmf2x5hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2995; /* *movrvvmf2x5hi_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2978; /* *movrvvmf4x4qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2979; /* *movrvvmf4x4qi_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2962; /* *movrvvm1x3df_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2963; /* *movrvvm1x3df_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2946; /* *movrvvmf2x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2947; /* *movrvvmf2x2sf_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2930; /* *movrvvmf4x8bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2931; /* *movrvvmf4x8bf_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2914; /* *movrvvm1x7di_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2915; /* *movrvvm1x7di_di */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2898; /* *movrvvmf2x6si_si */
    }
  if (!(
#line 1405 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2899; /* *movrvvmf2x6si_di */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern328 (x2))
    {
    case 0:
      return 297; /* *ashrsi3 */

    case 1:
      if (!
#line 2914 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 300; /* ashrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25494; /* ashrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25698; /* vashrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25497; /* ashrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25701; /* vashrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25500; /* ashrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25704; /* vashrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25503; /* ashrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25707; /* vashrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25506; /* ashrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25710; /* vashrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25509; /* ashrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25713; /* vashrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25512; /* ashrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25716; /* vashrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25515; /* ashrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25719; /* vashrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25518; /* ashrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25722; /* vashrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25521; /* ashrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25725; /* vashrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25524; /* ashrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25728; /* vashrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25527; /* ashrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25731; /* vashrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25530; /* ashrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25734; /* vashrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25533; /* ashrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25737; /* vashrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25536; /* ashrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25740; /* vashrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25539; /* ashrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25743; /* vashrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25542; /* ashrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25746; /* vashrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25545; /* ashrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25749; /* vashrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25548; /* ashrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25752; /* vashrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25551; /* ashrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25755; /* vashrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25554; /* ashrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25758; /* vashrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25557; /* ashrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25761; /* vashrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 25560; /* ashrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25764; /* vashrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 25563; /* ashrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25767; /* vashrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 25566; /* ashrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25770; /* vashrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 25569; /* ashrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25773; /* vashrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 25572; /* ashrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25776; /* vashrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 25575; /* ashrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25779; /* vashrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 25578; /* ashrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25782; /* vashrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 25581; /* ashrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25785; /* vashrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 25584; /* ashrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25788; /* vashrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 25587; /* ashrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25791; /* vashrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 25590; /* ashrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25794; /* vashrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 25593; /* ashrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25797; /* vashrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 25596; /* ashrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25800; /* vashrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 25599; /* ashrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25803; /* vashrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 25602; /* ashrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25806; /* vashrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 25605; /* ashrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25809; /* vashrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 25608; /* ashrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25812; /* vashrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 25611; /* ashrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25815; /* vashrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 25614; /* ashrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25818; /* vashrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 25617; /* ashrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25821; /* vashrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 25620; /* ashrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25824; /* vashrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 25623; /* ashrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25827; /* vashrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 25626; /* ashrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25830; /* vashrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 25629; /* ashrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25833; /* vashrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 25632; /* ashrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25836; /* vashrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 25635; /* ashrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25839; /* vashrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 25638; /* ashrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25842; /* vashrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 25641; /* ashrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25845; /* vashrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 25644; /* ashrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25848; /* vashrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 25647; /* ashrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25851; /* vashrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 25650; /* ashrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25854; /* vashrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 25653; /* ashrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25857; /* vashrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 25656; /* ashrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25860; /* vashrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 25659; /* ashrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25863; /* vashrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 25662; /* ashrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25866; /* vashrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 25665; /* ashrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25869; /* vashrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 25668; /* ashrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25872; /* vashrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 25671; /* ashrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25875; /* vashrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 25674; /* ashrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25878; /* vashrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 25677; /* ashrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25881; /* vashrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 25680; /* ashrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25884; /* vashrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 25683; /* ashrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25887; /* vashrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 25686; /* ashrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25890; /* vashrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 25689; /* ashrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25893; /* vashrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 25692; /* ashrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25896; /* vashrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 25695; /* ashrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25899; /* vashrv512di3 */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33508; /* pred_crypto_vvsm4rvsrvvm8si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33568; /* pred_crypto_vvsm4rvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33628; /* pred_crypto_vvsm4rvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33676; /* pred_crypto_vvsm4rvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33712; /* pred_crypto_vvsm4rvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33736; /* pred_crypto_vvsm4rvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33520; /* pred_crypto_vvsm4rvsrvvm4si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33580; /* pred_crypto_vvsm4rvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33640; /* pred_crypto_vvsm4rvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33688; /* pred_crypto_vvsm4rvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33724; /* pred_crypto_vvsm4rvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33532; /* pred_crypto_vvsm4rvsrvvm2si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33592; /* pred_crypto_vvsm4rvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33652; /* pred_crypto_vvsm4rvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33700; /* pred_crypto_vvsm4rvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33544; /* pred_crypto_vvsm4rvsrvvm1si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33604; /* pred_crypto_vvsm4rvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33664; /* pred_crypto_vvsm4rvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 33556; /* pred_crypto_vvsm4rvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33616; /* pred_crypto_vvsm4rvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33505; /* pred_crypto_vvaesdmvsrvvm8si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33565; /* pred_crypto_vvaesdmvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33625; /* pred_crypto_vvaesdmvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33673; /* pred_crypto_vvaesdmvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33709; /* pred_crypto_vvaesdmvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33733; /* pred_crypto_vvaesdmvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33517; /* pred_crypto_vvaesdmvsrvvm4si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33577; /* pred_crypto_vvaesdmvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33637; /* pred_crypto_vvaesdmvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33685; /* pred_crypto_vvaesdmvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33721; /* pred_crypto_vvaesdmvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33529; /* pred_crypto_vvaesdmvsrvvm2si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33589; /* pred_crypto_vvaesdmvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33649; /* pred_crypto_vvaesdmvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33697; /* pred_crypto_vvaesdmvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33541; /* pred_crypto_vvaesdmvsrvvm1si */
      if (!
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33601; /* pred_crypto_vvaesdmvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33661; /* pred_crypto_vvaesdmvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 33553; /* pred_crypto_vvaesdmvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33613; /* pred_crypto_vvaesdmvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x7;
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      return recog_397 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      x12 = XEXP (x7, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          return recog_398 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern684 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4033; /* *pred_mergervvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern684 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4034; /* *pred_mergervvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern684 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4035; /* *pred_mergervvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern684 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4036; /* *pred_mergervvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern684 (x2, 
E_V1DImode, 
E_V1BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4037; /* *pred_mergev1di_extended_scalar */

            case E_V2DImode:
              if (pattern684 (x2, 
E_V2DImode, 
E_V2BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4038; /* *pred_mergev2di_extended_scalar */

            case E_V4DImode:
              if (pattern684 (x2, 
E_V4DImode, 
E_V4BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4039; /* *pred_mergev4di_extended_scalar */

            case E_V8DImode:
              if (pattern684 (x2, 
E_V8DImode, 
E_V8BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 4040; /* *pred_mergev8di_extended_scalar */

            case E_V16DImode:
              if (pattern684 (x2, 
E_V16DImode, 
E_V16BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 4041; /* *pred_mergev16di_extended_scalar */

            case E_V32DImode:
              if (pattern684 (x2, 
E_V32DImode, 
E_V32BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 4042; /* *pred_mergev32di_extended_scalar */

            case E_V64DImode:
              if (pattern684 (x2, 
E_V64DImode, 
E_V64BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 4043; /* *pred_mergev64di_extended_scalar */

            case E_V128DImode:
              if (pattern684 (x2, 
E_V128DImode, 
E_V128BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 4044; /* *pred_mergev128di_extended_scalar */

            case E_V256DImode:
              if (pattern684 (x2, 
E_V256DImode, 
E_V256BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 4045; /* *pred_mergev256di_extended_scalar */

            case E_V512DImode:
              if (pattern684 (x2, 
E_V512DImode, 
E_V512BImode) != 0
                  || !(
#line 2104 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 4046; /* *pred_mergev512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28608; /* *cond_len_extendrvvm4qirvvm8hi */

        case 1:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28610; /* *cond_len_extendrvvm2qirvvm4hi */

        case 2:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28612; /* *cond_len_extendrvvm1qirvvm2hi */

        case 3:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28614; /* *cond_len_extendrvvmf2qirvvm1hi */

        case 4:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28616; /* *cond_len_extendrvvmf4qirvvmf2hi */

        case 5:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28618; /* *cond_len_extendrvvmf8qirvvmf4hi */

        case 6:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28620; /* *cond_len_extendrvvm4hirvvm8si */

        case 7:
          if (!
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28704; /* *cond_len_extendrvvm2qirvvm8si */

        case 8:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28622; /* *cond_len_extendrvvm2hirvvm4si */

        case 9:
          if (!
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28706; /* *cond_len_extendrvvm1qirvvm4si */

        case 10:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28624; /* *cond_len_extendrvvm1hirvvm2si */

        case 11:
          if (!
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28708; /* *cond_len_extendrvvmf2qirvvm2si */

        case 12:
          if (!
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28626; /* *cond_len_extendrvvmf2hirvvm1si */

        case 13:
          if (!
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28710; /* *cond_len_extendrvvmf4qirvvm1si */

        case 14:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28628; /* *cond_len_extendrvvmf4hirvvmf2si */

        case 15:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28712; /* *cond_len_extendrvvmf8qirvvmf2si */

        case 16:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28630; /* *cond_len_extendrvvm4sirvvm8di */

        case 17:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28714; /* *cond_len_extendrvvm2hirvvm8di */

        case 18:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28764; /* *cond_len_extendrvvm1qirvvm8di */

        case 19:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28632; /* *cond_len_extendrvvm2sirvvm4di */

        case 20:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28716; /* *cond_len_extendrvvm1hirvvm4di */

        case 21:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28766; /* *cond_len_extendrvvmf2qirvvm4di */

        case 22:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28634; /* *cond_len_extendrvvm1sirvvm2di */

        case 23:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28718; /* *cond_len_extendrvvmf2hirvvm2di */

        case 24:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28768; /* *cond_len_extendrvvmf4qirvvm2di */

        case 25:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28636; /* *cond_len_extendrvvmf2sirvvm1di */

        case 26:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28720; /* *cond_len_extendrvvmf4hirvvm1di */

        case 27:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28770; /* *cond_len_extendrvvmf8qirvvm1di */

        case 28:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 28638; /* *cond_len_extendv1qiv1hi */

        case 29:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 28640; /* *cond_len_extendv2qiv2hi */

        case 30:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 28642; /* *cond_len_extendv4qiv4hi */

        case 31:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 28644; /* *cond_len_extendv8qiv8hi */

        case 32:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 28646; /* *cond_len_extendv16qiv16hi */

        case 33:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28648; /* *cond_len_extendv32qiv32hi */

        case 34:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28650; /* *cond_len_extendv64qiv64hi */

        case 35:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28652; /* *cond_len_extendv128qiv128hi */

        case 36:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28654; /* *cond_len_extendv256qiv256hi */

        case 37:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28656; /* *cond_len_extendv512qiv512hi */

        case 38:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28658; /* *cond_len_extendv1024qiv1024hi */

        case 39:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28660; /* *cond_len_extendv2048qiv2048hi */

        case 40:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28662; /* *cond_len_extendv1hiv1si */

        case 41:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28722; /* *cond_len_extendv1qiv1si */

        case 42:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28664; /* *cond_len_extendv2hiv2si */

        case 43:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28724; /* *cond_len_extendv2qiv2si */

        case 44:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28666; /* *cond_len_extendv4hiv4si */

        case 45:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28726; /* *cond_len_extendv4qiv4si */

        case 46:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28668; /* *cond_len_extendv8hiv8si */

        case 47:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28728; /* *cond_len_extendv8qiv8si */

        case 48:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28670; /* *cond_len_extendv16hiv16si */

        case 49:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28730; /* *cond_len_extendv16qiv16si */

        case 50:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28672; /* *cond_len_extendv32hiv32si */

        case 51:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28732; /* *cond_len_extendv32qiv32si */

        case 52:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28674; /* *cond_len_extendv64hiv64si */

        case 53:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28734; /* *cond_len_extendv64qiv64si */

        case 54:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28676; /* *cond_len_extendv128hiv128si */

        case 55:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28736; /* *cond_len_extendv128qiv128si */

        case 56:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28678; /* *cond_len_extendv256hiv256si */

        case 57:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28738; /* *cond_len_extendv256qiv256si */

        case 58:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28680; /* *cond_len_extendv512hiv512si */

        case 59:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28740; /* *cond_len_extendv512qiv512si */

        case 60:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28682; /* *cond_len_extendv1024hiv1024si */

        case 61:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28742; /* *cond_len_extendv1024qiv1024si */

        case 62:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28684; /* *cond_len_extendv1siv1di */

        case 63:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28744; /* *cond_len_extendv1hiv1di */

        case 64:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28772; /* *cond_len_extendv1qiv1di */

        case 65:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28686; /* *cond_len_extendv2siv2di */

        case 66:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28746; /* *cond_len_extendv2hiv2di */

        case 67:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28774; /* *cond_len_extendv2qiv2di */

        case 68:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28688; /* *cond_len_extendv4siv4di */

        case 69:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28748; /* *cond_len_extendv4hiv4di */

        case 70:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28776; /* *cond_len_extendv4qiv4di */

        case 71:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28690; /* *cond_len_extendv8siv8di */

        case 72:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28750; /* *cond_len_extendv8hiv8di */

        case 73:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28778; /* *cond_len_extendv8qiv8di */

        case 74:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28692; /* *cond_len_extendv16siv16di */

        case 75:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28752; /* *cond_len_extendv16hiv16di */

        case 76:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28780; /* *cond_len_extendv16qiv16di */

        case 77:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28694; /* *cond_len_extendv32siv32di */

        case 78:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28754; /* *cond_len_extendv32hiv32di */

        case 79:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28782; /* *cond_len_extendv32qiv32di */

        case 80:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28696; /* *cond_len_extendv64siv64di */

        case 81:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28756; /* *cond_len_extendv64hiv64di */

        case 82:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28784; /* *cond_len_extendv64qiv64di */

        case 83:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28698; /* *cond_len_extendv128siv128di */

        case 84:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28758; /* *cond_len_extendv128hiv128di */

        case 85:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28786; /* *cond_len_extendv128qiv128di */

        case 86:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28700; /* *cond_len_extendv256siv256di */

        case 87:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28760; /* *cond_len_extendv256hiv256di */

        case 88:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28788; /* *cond_len_extendv256qiv256di */

        case 89:
          if (!(
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28702; /* *cond_len_extendv512siv512di */

        case 90:
          if (!(
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28762; /* *cond_len_extendv512hiv512di */

        case 91:
          if (!(
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28790; /* *cond_len_extendv512qiv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_399 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      operands[4] = x4;
      operands[5] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[6] = x8;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      x10 = XEXP (x6, 2);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern470 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28870; /* *cond_len_extendrvvm4hfrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28871; /* *cond_len_extendrvvm2hfrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28872; /* *cond_len_extendrvvm1hfrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28873; /* *cond_len_extendrvvmf2hfrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28874; /* *cond_len_extendrvvmf4hfrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28875; /* *cond_len_extendrvvm4sfrvvm8df */

        case E_RVVM4DFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28876; /* *cond_len_extendrvvm2sfrvvm4df */

        case E_RVVM2DFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28877; /* *cond_len_extendrvvm1sfrvvm2df */

        case E_RVVM1DFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28878; /* *cond_len_extendrvvmf2sfrvvm1df */

        case E_V1SFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28879; /* *cond_len_extendv1hfv1sf */

        case E_V2SFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28880; /* *cond_len_extendv2hfv2sf */

        case E_V4SFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28881; /* *cond_len_extendv4hfv4sf */

        case E_V8SFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28882; /* *cond_len_extendv8hfv8sf */

        case E_V16SFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28883; /* *cond_len_extendv16hfv16sf */

        case E_V32SFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28884; /* *cond_len_extendv32hfv32sf */

        case E_V64SFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28885; /* *cond_len_extendv64hfv64sf */

        case E_V128SFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28886; /* *cond_len_extendv128hfv128sf */

        case E_V256SFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28887; /* *cond_len_extendv256hfv256sf */

        case E_V512SFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28888; /* *cond_len_extendv512hfv512sf */

        case E_V1024SFmode:
          if (pattern470 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28889; /* *cond_len_extendv1024hfv1024sf */

        case E_V1DFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28890; /* *cond_len_extendv1sfv1df */

        case E_V2DFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28891; /* *cond_len_extendv2sfv2df */

        case E_V4DFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28892; /* *cond_len_extendv4sfv4df */

        case E_V8DFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28893; /* *cond_len_extendv8sfv8df */

        case E_V16DFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28894; /* *cond_len_extendv16sfv16df */

        case E_V32DFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28895; /* *cond_len_extendv32sfv32df */

        case E_V64DFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28896; /* *cond_len_extendv64sfv64df */

        case E_V128DFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28897; /* *cond_len_extendv128sfv128df */

        case E_V256DFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28898; /* *cond_len_extendv256sfv256df */

        case E_V512DFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !(
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28899; /* *cond_len_extendv512sfv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_475 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32HImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 4292; /* *pred_broadcastv32hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32HImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4414; /* *pred_broadcastv32hi_imm */
}

 int
recog_483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024QImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 4284; /* *pred_broadcastv1024qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024QImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4406; /* *pred_broadcastv1024qi_imm */
}

 int
recog_490 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8QImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 4277; /* *pred_broadcastv8qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8QImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 4399; /* *pred_broadcastv8qi_imm */
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM8DFmode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4270; /* *pred_broadcastrvvm8df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8DFmode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4392; /* *pred_broadcastrvvm8df_imm */
}

 int
recog_504 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVMF2HFmode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4263; /* *pred_broadcastrvvmf2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2HFmode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4385; /* *pred_broadcastrvvmf2hf_imm */
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern669 (x2))
    {
    case 0:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4720; /* pred_indexed_uloadrvvm8qi_same_eew */

    case 1:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4722; /* pred_indexed_uloadrvvm4qi_same_eew */

    case 2:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5088; /* pred_indexed_uloadrvvm4qi_x2_smaller_eew */

    case 3:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4724; /* pred_indexed_uloadrvvm2qi_same_eew */

    case 4:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5090; /* pred_indexed_uloadrvvm2qi_x2_smaller_eew */

    case 5:
      if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5146; /* pred_indexed_uloadrvvm2qi_x4_smaller_eew */

    case 6:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4726; /* pred_indexed_uloadrvvm1qi_same_eew */

    case 7:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5092; /* pred_indexed_uloadrvvm1qi_x2_smaller_eew */

    case 8:
      if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5148; /* pred_indexed_uloadrvvm1qi_x4_smaller_eew */

    case 9:
      if (!(
#line 2571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 395 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5180; /* pred_indexed_uloadrvvm1qi_x8_smaller_eew */

    case 10:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4728; /* pred_indexed_uloadrvvmf2qi_same_eew */

    case 11:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5094; /* pred_indexed_uloadrvvmf2qi_x2_smaller_eew */

    case 12:
      if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5150; /* pred_indexed_uloadrvvmf2qi_x4_smaller_eew */

    case 13:
      if (!(
#line 2571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 396 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5182; /* pred_indexed_uloadrvvmf2qi_x8_smaller_eew */

    case 14:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4730; /* pred_indexed_uloadrvvmf4qi_same_eew */

    case 15:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5096; /* pred_indexed_uloadrvvmf4qi_x2_smaller_eew */

    case 16:
      if (!
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5152; /* pred_indexed_uloadrvvmf4qi_x4_smaller_eew */

    case 17:
      if (!(
#line 2571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 397 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5184; /* pred_indexed_uloadrvvmf4qi_x8_smaller_eew */

    case 18:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1542 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4732; /* pred_indexed_uloadrvvmf8qi_same_eew */

    case 19:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5098; /* pred_indexed_uloadrvvmf8qi_x2_smaller_eew */

    case 20:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 376 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5154; /* pred_indexed_uloadrvvmf8qi_x4_smaller_eew */

    case 21:
      if (!(
#line 2571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 398 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5186; /* pred_indexed_uloadrvvmf8qi_x8_smaller_eew */

    case 22:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4734; /* pred_indexed_uloadrvvm8hi_same_eew */

    case 23:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4964; /* pred_indexed_uloadrvvm8hi_x2_greater_eew */

    case 24:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4736; /* pred_indexed_uloadrvvm4hi_same_eew */

    case 25:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4966; /* pred_indexed_uloadrvvm4hi_x2_greater_eew */

    case 26:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5100; /* pred_indexed_uloadrvvm4hi_x2_smaller_eew */

    case 27:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4738; /* pred_indexed_uloadrvvm2hi_same_eew */

    case 28:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4968; /* pred_indexed_uloadrvvm2hi_x2_greater_eew */

    case 29:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5102; /* pred_indexed_uloadrvvm2hi_x2_smaller_eew */

    case 30:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 378 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5156; /* pred_indexed_uloadrvvm2hi_x4_smaller_eew */

    case 31:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4740; /* pred_indexed_uloadrvvm1hi_same_eew */

    case 32:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4970; /* pred_indexed_uloadrvvm1hi_x2_greater_eew */

    case 33:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5104; /* pred_indexed_uloadrvvm1hi_x2_smaller_eew */

    case 34:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5158; /* pred_indexed_uloadrvvm1hi_x4_smaller_eew */

    case 35:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4742; /* pred_indexed_uloadrvvmf2hi_same_eew */

    case 36:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4972; /* pred_indexed_uloadrvvmf2hi_x2_greater_eew */

    case 37:
      if (!
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5106; /* pred_indexed_uloadrvvmf2hi_x2_smaller_eew */

    case 38:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 380 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5160; /* pred_indexed_uloadrvvmf2hi_x4_smaller_eew */

    case 39:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1544 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4744; /* pred_indexed_uloadrvvmf4hi_same_eew */

    case 40:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4974; /* pred_indexed_uloadrvvmf4hi_x2_greater_eew */

    case 41:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5108; /* pred_indexed_uloadrvvmf4hi_x2_smaller_eew */

    case 42:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 381 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5162; /* pred_indexed_uloadrvvmf4hi_x4_smaller_eew */

    case 43:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4746; /* pred_indexed_uloadrvvm8si_same_eew */

    case 44:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5000; /* pred_indexed_uloadrvvm8si_x2_greater_eew */

    case 45:
      if (!
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5036; /* pred_indexed_uloadrvvm8si_x4_greater_eew */

    case 46:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4748; /* pred_indexed_uloadrvvm4si_same_eew */

    case 47:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5002; /* pred_indexed_uloadrvvm4si_x2_greater_eew */

    case 48:
      if (!
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5038; /* pred_indexed_uloadrvvm4si_x4_greater_eew */

    case 49:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 364 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5130; /* pred_indexed_uloadrvvm4si_x2_smaller_eew */

    case 50:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4750; /* pred_indexed_uloadrvvm2si_same_eew */

    case 51:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5004; /* pred_indexed_uloadrvvm2si_x2_greater_eew */

    case 52:
      if (!
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5040; /* pred_indexed_uloadrvvm2si_x4_greater_eew */

    case 53:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 365 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5132; /* pred_indexed_uloadrvvm2si_x2_smaller_eew */

    case 54:
      if (!
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4752; /* pred_indexed_uloadrvvm1si_same_eew */

    case 55:
      if (!
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5006; /* pred_indexed_uloadrvvm1si_x2_greater_eew */

    case 56:
      if (!
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5042; /* pred_indexed_uloadrvvm1si_x4_greater_eew */

    case 57:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 366 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5134; /* pred_indexed_uloadrvvm1si_x2_smaller_eew */

    case 58:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4754; /* pred_indexed_uloadrvvmf2si_same_eew */

    case 59:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5008; /* pred_indexed_uloadrvvmf2si_x2_greater_eew */

    case 60:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5044; /* pred_indexed_uloadrvvmf2si_x4_greater_eew */

    case 61:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5136; /* pred_indexed_uloadrvvmf2si_x2_smaller_eew */

    case 62:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1548 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4756; /* pred_indexed_uloadrvvm8di_same_eew */

    case 63:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5020; /* pred_indexed_uloadrvvm8di_x2_greater_eew */

    case 64:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5056; /* pred_indexed_uloadrvvm8di_x4_greater_eew */

    case 65:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5072; /* pred_indexed_uloadrvvm8di_x8_greater_eew */

    case 66:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1549 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4758; /* pred_indexed_uloadrvvm4di_same_eew */

    case 67:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5022; /* pred_indexed_uloadrvvm4di_x2_greater_eew */

    case 68:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5058; /* pred_indexed_uloadrvvm4di_x4_greater_eew */

    case 69:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5074; /* pred_indexed_uloadrvvm4di_x8_greater_eew */

    case 70:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4760; /* pred_indexed_uloadrvvm2di_same_eew */

    case 71:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5024; /* pred_indexed_uloadrvvm2di_x2_greater_eew */

    case 72:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5060; /* pred_indexed_uloadrvvm2di_x4_greater_eew */

    case 73:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5076; /* pred_indexed_uloadrvvm2di_x8_greater_eew */

    case 74:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4762; /* pred_indexed_uloadrvvm1di_same_eew */

    case 75:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5026; /* pred_indexed_uloadrvvm1di_x2_greater_eew */

    case 76:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5062; /* pred_indexed_uloadrvvm1di_x4_greater_eew */

    case 77:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5078; /* pred_indexed_uloadrvvm1di_x8_greater_eew */

    case 78:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4764; /* pred_indexed_uloadrvvm8bf_same_eew */

    case 79:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4976; /* pred_indexed_uloadrvvm8bf_x2_greater_eew */

    case 80:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1554 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4766; /* pred_indexed_uloadrvvm4bf_same_eew */

    case 81:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4978; /* pred_indexed_uloadrvvm4bf_x2_greater_eew */

    case 82:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5110; /* pred_indexed_uloadrvvm4bf_x2_smaller_eew */

    case 83:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1555 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4768; /* pred_indexed_uloadrvvm2bf_same_eew */

    case 84:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4980; /* pred_indexed_uloadrvvm2bf_x2_greater_eew */

    case 85:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5112; /* pred_indexed_uloadrvvm2bf_x2_smaller_eew */

    case 86:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 383 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5164; /* pred_indexed_uloadrvvm2bf_x4_smaller_eew */

    case 87:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4770; /* pred_indexed_uloadrvvm1bf_same_eew */

    case 88:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4982; /* pred_indexed_uloadrvvm1bf_x2_greater_eew */

    case 89:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5114; /* pred_indexed_uloadrvvm1bf_x2_smaller_eew */

    case 90:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 384 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5166; /* pred_indexed_uloadrvvm1bf_x4_smaller_eew */

    case 91:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1557 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4772; /* pred_indexed_uloadrvvmf2bf_same_eew */

    case 92:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4984; /* pred_indexed_uloadrvvmf2bf_x2_greater_eew */

    case 93:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5116; /* pred_indexed_uloadrvvmf2bf_x2_smaller_eew */

    case 94:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 385 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5168; /* pred_indexed_uloadrvvmf2bf_x4_smaller_eew */

    case 95:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1558 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4774; /* pred_indexed_uloadrvvmf4bf_same_eew */

    case 96:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4986; /* pred_indexed_uloadrvvmf4bf_x2_greater_eew */

    case 97:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 358 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5118; /* pred_indexed_uloadrvvmf4bf_x2_smaller_eew */

    case 98:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5170; /* pred_indexed_uloadrvvmf4bf_x4_smaller_eew */

    case 99:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4776; /* pred_indexed_uloadrvvm8hf_same_eew */

    case 100:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4988; /* pred_indexed_uloadrvvm8hf_x2_greater_eew */

    case 101:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4778; /* pred_indexed_uloadrvvm4hf_same_eew */

    case 102:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4990; /* pred_indexed_uloadrvvm4hf_x2_greater_eew */

    case 103:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5120; /* pred_indexed_uloadrvvm4hf_x2_smaller_eew */

    case 104:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4780; /* pred_indexed_uloadrvvm2hf_same_eew */

    case 105:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4992; /* pred_indexed_uloadrvvm2hf_x2_greater_eew */

    case 106:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5122; /* pred_indexed_uloadrvvm2hf_x2_smaller_eew */

    case 107:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 388 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5172; /* pred_indexed_uloadrvvm2hf_x4_smaller_eew */

    case 108:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4782; /* pred_indexed_uloadrvvm1hf_same_eew */

    case 109:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4994; /* pred_indexed_uloadrvvm1hf_x2_greater_eew */

    case 110:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5124; /* pred_indexed_uloadrvvm1hf_x2_smaller_eew */

    case 111:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 389 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5174; /* pred_indexed_uloadrvvm1hf_x4_smaller_eew */

    case 112:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4784; /* pred_indexed_uloadrvvmf2hf_same_eew */

    case 113:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4996; /* pred_indexed_uloadrvvmf2hf_x2_greater_eew */

    case 114:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5126; /* pred_indexed_uloadrvvmf2hf_x2_smaller_eew */

    case 115:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 390 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5176; /* pred_indexed_uloadrvvmf2hf_x4_smaller_eew */

    case 116:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1562 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4786; /* pred_indexed_uloadrvvmf4hf_same_eew */

    case 117:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 316 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4998; /* pred_indexed_uloadrvvmf4hf_x2_greater_eew */

    case 118:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 362 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5128; /* pred_indexed_uloadrvvmf4hf_x2_smaller_eew */

    case 119:
      if (!(
#line 2550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 391 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5178; /* pred_indexed_uloadrvvmf4hf_x4_smaller_eew */

    case 120:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4788; /* pred_indexed_uloadrvvm8sf_same_eew */

    case 121:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5010; /* pred_indexed_uloadrvvm8sf_x2_greater_eew */

    case 122:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5046; /* pred_indexed_uloadrvvm8sf_x4_greater_eew */

    case 123:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4790; /* pred_indexed_uloadrvvm4sf_same_eew */

    case 124:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5012; /* pred_indexed_uloadrvvm4sf_x2_greater_eew */

    case 125:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5048; /* pred_indexed_uloadrvvm4sf_x4_greater_eew */

    case 126:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 369 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5138; /* pred_indexed_uloadrvvm4sf_x2_smaller_eew */

    case 127:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4792; /* pred_indexed_uloadrvvm2sf_same_eew */

    case 128:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5014; /* pred_indexed_uloadrvvm2sf_x2_greater_eew */

    case 129:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5050; /* pred_indexed_uloadrvvm2sf_x4_greater_eew */

    case 130:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 370 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5140; /* pred_indexed_uloadrvvm2sf_x2_smaller_eew */

    case 131:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4794; /* pred_indexed_uloadrvvm1sf_same_eew */

    case 132:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5016; /* pred_indexed_uloadrvvm1sf_x2_greater_eew */

    case 133:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5052; /* pred_indexed_uloadrvvm1sf_x4_greater_eew */

    case 134:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5142; /* pred_indexed_uloadrvvm1sf_x2_smaller_eew */

    case 135:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1566 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4796; /* pred_indexed_uloadrvvmf2sf_same_eew */

    case 136:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5018; /* pred_indexed_uloadrvvmf2sf_x2_greater_eew */

    case 137:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5054; /* pred_indexed_uloadrvvmf2sf_x4_greater_eew */

    case 138:
      if (!(
#line 2529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 372 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5144; /* pred_indexed_uloadrvvmf2sf_x2_smaller_eew */

    case 139:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1568 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4798; /* pred_indexed_uloadrvvm8df_same_eew */

    case 140:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5028; /* pred_indexed_uloadrvvm8df_x2_greater_eew */

    case 141:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5064; /* pred_indexed_uloadrvvm8df_x4_greater_eew */

    case 142:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5080; /* pred_indexed_uloadrvvm8df_x8_greater_eew */

    case 143:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4800; /* pred_indexed_uloadrvvm4df_same_eew */

    case 144:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5030; /* pred_indexed_uloadrvvm4df_x2_greater_eew */

    case 145:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5066; /* pred_indexed_uloadrvvm4df_x4_greater_eew */

    case 146:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5082; /* pred_indexed_uloadrvvm4df_x8_greater_eew */

    case 147:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1570 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4802; /* pred_indexed_uloadrvvm2df_same_eew */

    case 148:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5032; /* pred_indexed_uloadrvvm2df_x2_greater_eew */

    case 149:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5068; /* pred_indexed_uloadrvvm2df_x4_greater_eew */

    case 150:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5084; /* pred_indexed_uloadrvvm2df_x8_greater_eew */

    case 151:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4804; /* pred_indexed_uloadrvvm1df_same_eew */

    case 152:
      if (!(
#line 2465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5034; /* pred_indexed_uloadrvvm1df_x2_greater_eew */

    case 153:
      if (!(
#line 2486 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5070; /* pred_indexed_uloadrvvm1df_x4_greater_eew */

    case 154:
      if (!(
#line 2507 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5086; /* pred_indexed_uloadrvvm1df_x8_greater_eew */

    case 155:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4806; /* pred_indexed_uloadv1qi_same_eew */

    case 156:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4808; /* pred_indexed_uloadv2qi_same_eew */

    case 157:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4810; /* pred_indexed_uloadv4qi_same_eew */

    case 158:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4812; /* pred_indexed_uloadv8qi_same_eew */

    case 159:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4814; /* pred_indexed_uloadv16qi_same_eew */

    case 160:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4816; /* pred_indexed_uloadv32qi_same_eew */

    case 161:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4818; /* pred_indexed_uloadv64qi_same_eew */

    case 162:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4820; /* pred_indexed_uloadv128qi_same_eew */

    case 163:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4822; /* pred_indexed_uloadv256qi_same_eew */

    case 164:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4824; /* pred_indexed_uloadv512qi_same_eew */

    case 165:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4826; /* pred_indexed_uloadv1024qi_same_eew */

    case 166:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4828; /* pred_indexed_uloadv2048qi_same_eew */

    case 167:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4830; /* pred_indexed_uloadv4096qi_same_eew */

    case 168:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4832; /* pred_indexed_uloadv1hi_same_eew */

    case 169:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4834; /* pred_indexed_uloadv2hi_same_eew */

    case 170:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4836; /* pred_indexed_uloadv4hi_same_eew */

    case 171:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4838; /* pred_indexed_uloadv8hi_same_eew */

    case 172:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4840; /* pred_indexed_uloadv16hi_same_eew */

    case 173:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4842; /* pred_indexed_uloadv32hi_same_eew */

    case 174:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4844; /* pred_indexed_uloadv64hi_same_eew */

    case 175:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4846; /* pred_indexed_uloadv128hi_same_eew */

    case 176:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4848; /* pred_indexed_uloadv256hi_same_eew */

    case 177:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4850; /* pred_indexed_uloadv512hi_same_eew */

    case 178:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4852; /* pred_indexed_uloadv1024hi_same_eew */

    case 179:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4854; /* pred_indexed_uloadv2048hi_same_eew */

    case 180:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4856; /* pred_indexed_uloadv1si_same_eew */

    case 181:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4858; /* pred_indexed_uloadv2si_same_eew */

    case 182:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4860; /* pred_indexed_uloadv4si_same_eew */

    case 183:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4862; /* pred_indexed_uloadv8si_same_eew */

    case 184:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4864; /* pred_indexed_uloadv16si_same_eew */

    case 185:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4866; /* pred_indexed_uloadv32si_same_eew */

    case 186:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4868; /* pred_indexed_uloadv64si_same_eew */

    case 187:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4870; /* pred_indexed_uloadv128si_same_eew */

    case 188:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4872; /* pred_indexed_uloadv256si_same_eew */

    case 189:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1607 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4874; /* pred_indexed_uloadv512si_same_eew */

    case 190:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4876; /* pred_indexed_uloadv1024si_same_eew */

    case 191:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4878; /* pred_indexed_uloadv1di_same_eew */

    case 192:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1610 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4880; /* pred_indexed_uloadv2di_same_eew */

    case 193:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1611 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4882; /* pred_indexed_uloadv4di_same_eew */

    case 194:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1612 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4884; /* pred_indexed_uloadv8di_same_eew */

    case 195:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4886; /* pred_indexed_uloadv16di_same_eew */

    case 196:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1614 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4888; /* pred_indexed_uloadv32di_same_eew */

    case 197:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1615 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4890; /* pred_indexed_uloadv64di_same_eew */

    case 198:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1616 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4892; /* pred_indexed_uloadv128di_same_eew */

    case 199:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1617 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4894; /* pred_indexed_uloadv256di_same_eew */

    case 200:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1618 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4896; /* pred_indexed_uloadv512di_same_eew */

    case 201:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1620 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 4898; /* pred_indexed_uloadv1hf_same_eew */

    case 202:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1621 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 4900; /* pred_indexed_uloadv2hf_same_eew */

    case 203:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 4902; /* pred_indexed_uloadv4hf_same_eew */

    case 204:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1623 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 4904; /* pred_indexed_uloadv8hf_same_eew */

    case 205:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1624 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 4906; /* pred_indexed_uloadv16hf_same_eew */

    case 206:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1625 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4908; /* pred_indexed_uloadv32hf_same_eew */

    case 207:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4910; /* pred_indexed_uloadv64hf_same_eew */

    case 208:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1627 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4912; /* pred_indexed_uloadv128hf_same_eew */

    case 209:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1628 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4914; /* pred_indexed_uloadv256hf_same_eew */

    case 210:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1629 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4916; /* pred_indexed_uloadv512hf_same_eew */

    case 211:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1630 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4918; /* pred_indexed_uloadv1024hf_same_eew */

    case 212:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1631 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4920; /* pred_indexed_uloadv2048hf_same_eew */

    case 213:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1632 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4922; /* pred_indexed_uloadv1sf_same_eew */

    case 214:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1633 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4924; /* pred_indexed_uloadv2sf_same_eew */

    case 215:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1634 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4926; /* pred_indexed_uloadv4sf_same_eew */

    case 216:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1635 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4928; /* pred_indexed_uloadv8sf_same_eew */

    case 217:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1636 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4930; /* pred_indexed_uloadv16sf_same_eew */

    case 218:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1637 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4932; /* pred_indexed_uloadv32sf_same_eew */

    case 219:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1638 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4934; /* pred_indexed_uloadv64sf_same_eew */

    case 220:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4936; /* pred_indexed_uloadv128sf_same_eew */

    case 221:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1640 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4938; /* pred_indexed_uloadv256sf_same_eew */

    case 222:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1641 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4940; /* pred_indexed_uloadv512sf_same_eew */

    case 223:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1642 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4942; /* pred_indexed_uloadv1024sf_same_eew */

    case 224:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4944; /* pred_indexed_uloadv1df_same_eew */

    case 225:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1644 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4946; /* pred_indexed_uloadv2df_same_eew */

    case 226:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1645 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4948; /* pred_indexed_uloadv4df_same_eew */

    case 227:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1646 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4950; /* pred_indexed_uloadv8df_same_eew */

    case 228:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1647 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4952; /* pred_indexed_uloadv16df_same_eew */

    case 229:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1648 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4954; /* pred_indexed_uloadv32df_same_eew */

    case 230:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1649 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4956; /* pred_indexed_uloadv64df_same_eew */

    case 231:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1650 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4958; /* pred_indexed_uloadv128df_same_eew */

    case 232:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1651 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4960; /* pred_indexed_uloadv256df_same_eew */

    case 233:
      if (!(
#line 2443 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1652 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4962; /* pred_indexed_uloadv512df_same_eew */

    case 234:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21934; /* pred_indexed_uloadrvvmf8x2qirvvmf8qi */

    case 235:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21936; /* pred_indexed_uloadrvvmf8x2qirvvmf4hi */

    case 236:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21938; /* pred_indexed_uloadrvvmf8x2qirvvmf2si */

    case 237:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21940; /* pred_indexed_uloadrvvmf8x2qirvvm1di */

    case 238:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21942; /* pred_indexed_uloadrvvmf8x3qirvvmf8qi */

    case 239:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21944; /* pred_indexed_uloadrvvmf8x3qirvvmf4hi */

    case 240:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21946; /* pred_indexed_uloadrvvmf8x3qirvvmf2si */

    case 241:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21948; /* pred_indexed_uloadrvvmf8x3qirvvm1di */

    case 242:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21950; /* pred_indexed_uloadrvvmf8x4qirvvmf8qi */

    case 243:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21952; /* pred_indexed_uloadrvvmf8x4qirvvmf4hi */

    case 244:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21954; /* pred_indexed_uloadrvvmf8x4qirvvmf2si */

    case 245:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21956; /* pred_indexed_uloadrvvmf8x4qirvvm1di */

    case 246:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21958; /* pred_indexed_uloadrvvmf8x5qirvvmf8qi */

    case 247:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21960; /* pred_indexed_uloadrvvmf8x5qirvvmf4hi */

    case 248:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21962; /* pred_indexed_uloadrvvmf8x5qirvvmf2si */

    case 249:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21964; /* pred_indexed_uloadrvvmf8x5qirvvm1di */

    case 250:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21966; /* pred_indexed_uloadrvvmf8x6qirvvmf8qi */

    case 251:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21968; /* pred_indexed_uloadrvvmf8x6qirvvmf4hi */

    case 252:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21970; /* pred_indexed_uloadrvvmf8x6qirvvmf2si */

    case 253:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21972; /* pred_indexed_uloadrvvmf8x6qirvvm1di */

    case 254:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21974; /* pred_indexed_uloadrvvmf8x7qirvvmf8qi */

    case 255:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21976; /* pred_indexed_uloadrvvmf8x7qirvvmf4hi */

    case 256:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21978; /* pred_indexed_uloadrvvmf8x7qirvvmf2si */

    case 257:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21980; /* pred_indexed_uloadrvvmf8x7qirvvm1di */

    case 258:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21982; /* pred_indexed_uloadrvvmf8x8qirvvmf8qi */

    case 259:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21984; /* pred_indexed_uloadrvvmf8x8qirvvmf4hi */

    case 260:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21986; /* pred_indexed_uloadrvvmf8x8qirvvmf2si */

    case 261:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21988; /* pred_indexed_uloadrvvmf8x8qirvvm1di */

    case 262:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21990; /* pred_indexed_uloadrvvmf4x2hirvvmf8qi */

    case 263:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21992; /* pred_indexed_uloadrvvmf4x2hirvvmf4hi */

    case 264:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21994; /* pred_indexed_uloadrvvmf4x2hirvvmf2si */

    case 265:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21996; /* pred_indexed_uloadrvvmf4x2hirvvm1di */

    case 266:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21998; /* pred_indexed_uloadrvvmf4x3hirvvmf8qi */

    case 267:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22000; /* pred_indexed_uloadrvvmf4x3hirvvmf4hi */

    case 268:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22002; /* pred_indexed_uloadrvvmf4x3hirvvmf2si */

    case 269:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22004; /* pred_indexed_uloadrvvmf4x3hirvvm1di */

    case 270:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22006; /* pred_indexed_uloadrvvmf4x4hirvvmf8qi */

    case 271:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22008; /* pred_indexed_uloadrvvmf4x4hirvvmf4hi */

    case 272:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22010; /* pred_indexed_uloadrvvmf4x4hirvvmf2si */

    case 273:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22012; /* pred_indexed_uloadrvvmf4x4hirvvm1di */

    case 274:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22014; /* pred_indexed_uloadrvvmf4x5hirvvmf8qi */

    case 275:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22016; /* pred_indexed_uloadrvvmf4x5hirvvmf4hi */

    case 276:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22018; /* pred_indexed_uloadrvvmf4x5hirvvmf2si */

    case 277:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22020; /* pred_indexed_uloadrvvmf4x5hirvvm1di */

    case 278:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22022; /* pred_indexed_uloadrvvmf4x6hirvvmf8qi */

    case 279:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22024; /* pred_indexed_uloadrvvmf4x6hirvvmf4hi */

    case 280:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22026; /* pred_indexed_uloadrvvmf4x6hirvvmf2si */

    case 281:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22028; /* pred_indexed_uloadrvvmf4x6hirvvm1di */

    case 282:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22030; /* pred_indexed_uloadrvvmf4x7hirvvmf8qi */

    case 283:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22032; /* pred_indexed_uloadrvvmf4x7hirvvmf4hi */

    case 284:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22034; /* pred_indexed_uloadrvvmf4x7hirvvmf2si */

    case 285:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22036; /* pred_indexed_uloadrvvmf4x7hirvvm1di */

    case 286:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22038; /* pred_indexed_uloadrvvmf4x8hirvvmf8qi */

    case 287:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22040; /* pred_indexed_uloadrvvmf4x8hirvvmf4hi */

    case 288:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22042; /* pred_indexed_uloadrvvmf4x8hirvvmf2si */

    case 289:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22044; /* pred_indexed_uloadrvvmf4x8hirvvm1di */

    case 290:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22046; /* pred_indexed_uloadrvvmf2x2sirvvmf8qi */

    case 291:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22048; /* pred_indexed_uloadrvvmf2x2sirvvmf4hi */

    case 292:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22050; /* pred_indexed_uloadrvvmf2x2sirvvmf2si */

    case 293:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22052; /* pred_indexed_uloadrvvmf2x2sirvvm1di */

    case 294:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22054; /* pred_indexed_uloadrvvmf2x3sirvvmf8qi */

    case 295:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22056; /* pred_indexed_uloadrvvmf2x3sirvvmf4hi */

    case 296:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22058; /* pred_indexed_uloadrvvmf2x3sirvvmf2si */

    case 297:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22060; /* pred_indexed_uloadrvvmf2x3sirvvm1di */

    case 298:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22062; /* pred_indexed_uloadrvvmf2x4sirvvmf8qi */

    case 299:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22064; /* pred_indexed_uloadrvvmf2x4sirvvmf4hi */

    case 300:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22066; /* pred_indexed_uloadrvvmf2x4sirvvmf2si */

    case 301:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22068; /* pred_indexed_uloadrvvmf2x4sirvvm1di */

    case 302:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22070; /* pred_indexed_uloadrvvmf2x5sirvvmf8qi */

    case 303:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22072; /* pred_indexed_uloadrvvmf2x5sirvvmf4hi */

    case 304:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22074; /* pred_indexed_uloadrvvmf2x5sirvvmf2si */

    case 305:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22076; /* pred_indexed_uloadrvvmf2x5sirvvm1di */

    case 306:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22078; /* pred_indexed_uloadrvvmf2x6sirvvmf8qi */

    case 307:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22080; /* pred_indexed_uloadrvvmf2x6sirvvmf4hi */

    case 308:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22082; /* pred_indexed_uloadrvvmf2x6sirvvmf2si */

    case 309:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22084; /* pred_indexed_uloadrvvmf2x6sirvvm1di */

    case 310:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22086; /* pred_indexed_uloadrvvmf2x7sirvvmf8qi */

    case 311:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22088; /* pred_indexed_uloadrvvmf2x7sirvvmf4hi */

    case 312:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22090; /* pred_indexed_uloadrvvmf2x7sirvvmf2si */

    case 313:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22092; /* pred_indexed_uloadrvvmf2x7sirvvm1di */

    case 314:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22094; /* pred_indexed_uloadrvvmf2x8sirvvmf8qi */

    case 315:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22096; /* pred_indexed_uloadrvvmf2x8sirvvmf4hi */

    case 316:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22098; /* pred_indexed_uloadrvvmf2x8sirvvmf2si */

    case 317:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22100; /* pred_indexed_uloadrvvmf2x8sirvvm1di */

    case 318:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22102; /* pred_indexed_uloadrvvm1x2dirvvmf8qi */

    case 319:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22104; /* pred_indexed_uloadrvvm1x2dirvvmf4hi */

    case 320:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22106; /* pred_indexed_uloadrvvm1x2dirvvmf2si */

    case 321:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22108; /* pred_indexed_uloadrvvm1x2dirvvm1di */

    case 322:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22110; /* pred_indexed_uloadrvvm1x3dirvvmf8qi */

    case 323:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22112; /* pred_indexed_uloadrvvm1x3dirvvmf4hi */

    case 324:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22114; /* pred_indexed_uloadrvvm1x3dirvvmf2si */

    case 325:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22116; /* pred_indexed_uloadrvvm1x3dirvvm1di */

    case 326:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22118; /* pred_indexed_uloadrvvm1x4dirvvmf8qi */

    case 327:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22120; /* pred_indexed_uloadrvvm1x4dirvvmf4hi */

    case 328:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22122; /* pred_indexed_uloadrvvm1x4dirvvmf2si */

    case 329:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22124; /* pred_indexed_uloadrvvm1x4dirvvm1di */

    case 330:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22126; /* pred_indexed_uloadrvvm1x5dirvvmf8qi */

    case 331:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22128; /* pred_indexed_uloadrvvm1x5dirvvmf4hi */

    case 332:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22130; /* pred_indexed_uloadrvvm1x5dirvvmf2si */

    case 333:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22132; /* pred_indexed_uloadrvvm1x5dirvvm1di */

    case 334:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22134; /* pred_indexed_uloadrvvm1x6dirvvmf8qi */

    case 335:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22136; /* pred_indexed_uloadrvvm1x6dirvvmf4hi */

    case 336:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22138; /* pred_indexed_uloadrvvm1x6dirvvmf2si */

    case 337:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22140; /* pred_indexed_uloadrvvm1x6dirvvm1di */

    case 338:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22142; /* pred_indexed_uloadrvvm1x7dirvvmf8qi */

    case 339:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22144; /* pred_indexed_uloadrvvm1x7dirvvmf4hi */

    case 340:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22146; /* pred_indexed_uloadrvvm1x7dirvvmf2si */

    case 341:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22148; /* pred_indexed_uloadrvvm1x7dirvvm1di */

    case 342:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22150; /* pred_indexed_uloadrvvm1x8dirvvmf8qi */

    case 343:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22152; /* pred_indexed_uloadrvvm1x8dirvvmf4hi */

    case 344:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22154; /* pred_indexed_uloadrvvm1x8dirvvmf2si */

    case 345:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22156; /* pred_indexed_uloadrvvm1x8dirvvm1di */

    case 346:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22158; /* pred_indexed_uloadrvvmf4x2bfrvvmf8qi */

    case 347:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22160; /* pred_indexed_uloadrvvmf4x2bfrvvmf4hi */

    case 348:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22162; /* pred_indexed_uloadrvvmf4x2bfrvvmf2si */

    case 349:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22164; /* pred_indexed_uloadrvvmf4x2bfrvvm1di */

    case 350:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22166; /* pred_indexed_uloadrvvmf4x3bfrvvmf8qi */

    case 351:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22168; /* pred_indexed_uloadrvvmf4x3bfrvvmf4hi */

    case 352:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22170; /* pred_indexed_uloadrvvmf4x3bfrvvmf2si */

    case 353:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22172; /* pred_indexed_uloadrvvmf4x3bfrvvm1di */

    case 354:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22174; /* pred_indexed_uloadrvvmf4x4bfrvvmf8qi */

    case 355:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22176; /* pred_indexed_uloadrvvmf4x4bfrvvmf4hi */

    case 356:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22178; /* pred_indexed_uloadrvvmf4x4bfrvvmf2si */

    case 357:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22180; /* pred_indexed_uloadrvvmf4x4bfrvvm1di */

    case 358:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22182; /* pred_indexed_uloadrvvmf4x5bfrvvmf8qi */

    case 359:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22184; /* pred_indexed_uloadrvvmf4x5bfrvvmf4hi */

    case 360:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22186; /* pred_indexed_uloadrvvmf4x5bfrvvmf2si */

    case 361:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22188; /* pred_indexed_uloadrvvmf4x5bfrvvm1di */

    case 362:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22190; /* pred_indexed_uloadrvvmf4x6bfrvvmf8qi */

    case 363:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22192; /* pred_indexed_uloadrvvmf4x6bfrvvmf4hi */

    case 364:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22194; /* pred_indexed_uloadrvvmf4x6bfrvvmf2si */

    case 365:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22196; /* pred_indexed_uloadrvvmf4x6bfrvvm1di */

    case 366:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22198; /* pred_indexed_uloadrvvmf4x7bfrvvmf8qi */

    case 367:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22200; /* pred_indexed_uloadrvvmf4x7bfrvvmf4hi */

    case 368:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22202; /* pred_indexed_uloadrvvmf4x7bfrvvmf2si */

    case 369:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22204; /* pred_indexed_uloadrvvmf4x7bfrvvm1di */

    case 370:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22206; /* pred_indexed_uloadrvvmf4x8bfrvvmf8qi */

    case 371:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22208; /* pred_indexed_uloadrvvmf4x8bfrvvmf4hi */

    case 372:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22210; /* pred_indexed_uloadrvvmf4x8bfrvvmf2si */

    case 373:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22212; /* pred_indexed_uloadrvvmf4x8bfrvvm1di */

    case 374:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22214; /* pred_indexed_uloadrvvmf4x2hfrvvmf8qi */

    case 375:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22216; /* pred_indexed_uloadrvvmf4x2hfrvvmf4hi */

    case 376:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22218; /* pred_indexed_uloadrvvmf4x2hfrvvmf2si */

    case 377:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22220; /* pred_indexed_uloadrvvmf4x2hfrvvm1di */

    case 378:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22222; /* pred_indexed_uloadrvvmf4x3hfrvvmf8qi */

    case 379:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22224; /* pred_indexed_uloadrvvmf4x3hfrvvmf4hi */

    case 380:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22226; /* pred_indexed_uloadrvvmf4x3hfrvvmf2si */

    case 381:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22228; /* pred_indexed_uloadrvvmf4x3hfrvvm1di */

    case 382:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22230; /* pred_indexed_uloadrvvmf4x4hfrvvmf8qi */

    case 383:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22232; /* pred_indexed_uloadrvvmf4x4hfrvvmf4hi */

    case 384:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22234; /* pred_indexed_uloadrvvmf4x4hfrvvmf2si */

    case 385:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22236; /* pred_indexed_uloadrvvmf4x4hfrvvm1di */

    case 386:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22238; /* pred_indexed_uloadrvvmf4x5hfrvvmf8qi */

    case 387:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22240; /* pred_indexed_uloadrvvmf4x5hfrvvmf4hi */

    case 388:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22242; /* pred_indexed_uloadrvvmf4x5hfrvvmf2si */

    case 389:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22244; /* pred_indexed_uloadrvvmf4x5hfrvvm1di */

    case 390:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22246; /* pred_indexed_uloadrvvmf4x6hfrvvmf8qi */

    case 391:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22248; /* pred_indexed_uloadrvvmf4x6hfrvvmf4hi */

    case 392:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22250; /* pred_indexed_uloadrvvmf4x6hfrvvmf2si */

    case 393:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22252; /* pred_indexed_uloadrvvmf4x6hfrvvm1di */

    case 394:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22254; /* pred_indexed_uloadrvvmf4x7hfrvvmf8qi */

    case 395:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22256; /* pred_indexed_uloadrvvmf4x7hfrvvmf4hi */

    case 396:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22258; /* pred_indexed_uloadrvvmf4x7hfrvvmf2si */

    case 397:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22260; /* pred_indexed_uloadrvvmf4x7hfrvvm1di */

    case 398:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22262; /* pred_indexed_uloadrvvmf4x8hfrvvmf8qi */

    case 399:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22264; /* pred_indexed_uloadrvvmf4x8hfrvvmf4hi */

    case 400:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22266; /* pred_indexed_uloadrvvmf4x8hfrvvmf2si */

    case 401:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22268; /* pred_indexed_uloadrvvmf4x8hfrvvm1di */

    case 402:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22270; /* pred_indexed_uloadrvvmf2x2sfrvvmf8qi */

    case 403:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22272; /* pred_indexed_uloadrvvmf2x2sfrvvmf4hi */

    case 404:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22274; /* pred_indexed_uloadrvvmf2x2sfrvvmf2si */

    case 405:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22276; /* pred_indexed_uloadrvvmf2x2sfrvvm1di */

    case 406:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22278; /* pred_indexed_uloadrvvmf2x3sfrvvmf8qi */

    case 407:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22280; /* pred_indexed_uloadrvvmf2x3sfrvvmf4hi */

    case 408:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22282; /* pred_indexed_uloadrvvmf2x3sfrvvmf2si */

    case 409:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22284; /* pred_indexed_uloadrvvmf2x3sfrvvm1di */

    case 410:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22286; /* pred_indexed_uloadrvvmf2x4sfrvvmf8qi */

    case 411:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22288; /* pred_indexed_uloadrvvmf2x4sfrvvmf4hi */

    case 412:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22290; /* pred_indexed_uloadrvvmf2x4sfrvvmf2si */

    case 413:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22292; /* pred_indexed_uloadrvvmf2x4sfrvvm1di */

    case 414:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22294; /* pred_indexed_uloadrvvmf2x5sfrvvmf8qi */

    case 415:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22296; /* pred_indexed_uloadrvvmf2x5sfrvvmf4hi */

    case 416:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22298; /* pred_indexed_uloadrvvmf2x5sfrvvmf2si */

    case 417:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22300; /* pred_indexed_uloadrvvmf2x5sfrvvm1di */

    case 418:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22302; /* pred_indexed_uloadrvvmf2x6sfrvvmf8qi */

    case 419:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22304; /* pred_indexed_uloadrvvmf2x6sfrvvmf4hi */

    case 420:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22306; /* pred_indexed_uloadrvvmf2x6sfrvvmf2si */

    case 421:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22308; /* pred_indexed_uloadrvvmf2x6sfrvvm1di */

    case 422:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22310; /* pred_indexed_uloadrvvmf2x7sfrvvmf8qi */

    case 423:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22312; /* pred_indexed_uloadrvvmf2x7sfrvvmf4hi */

    case 424:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22314; /* pred_indexed_uloadrvvmf2x7sfrvvmf2si */

    case 425:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22316; /* pred_indexed_uloadrvvmf2x7sfrvvm1di */

    case 426:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22318; /* pred_indexed_uloadrvvmf2x8sfrvvmf8qi */

    case 427:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22320; /* pred_indexed_uloadrvvmf2x8sfrvvmf4hi */

    case 428:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22322; /* pred_indexed_uloadrvvmf2x8sfrvvmf2si */

    case 429:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22324; /* pred_indexed_uloadrvvmf2x8sfrvvm1di */

    case 430:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22326; /* pred_indexed_uloadrvvm1x2dfrvvmf8qi */

    case 431:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22328; /* pred_indexed_uloadrvvm1x2dfrvvmf4hi */

    case 432:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22330; /* pred_indexed_uloadrvvm1x2dfrvvmf2si */

    case 433:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22332; /* pred_indexed_uloadrvvm1x2dfrvvm1di */

    case 434:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22334; /* pred_indexed_uloadrvvm1x3dfrvvmf8qi */

    case 435:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22336; /* pred_indexed_uloadrvvm1x3dfrvvmf4hi */

    case 436:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22338; /* pred_indexed_uloadrvvm1x3dfrvvmf2si */

    case 437:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22340; /* pred_indexed_uloadrvvm1x3dfrvvm1di */

    case 438:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22342; /* pred_indexed_uloadrvvm1x4dfrvvmf8qi */

    case 439:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22344; /* pred_indexed_uloadrvvm1x4dfrvvmf4hi */

    case 440:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22346; /* pred_indexed_uloadrvvm1x4dfrvvmf2si */

    case 441:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22348; /* pred_indexed_uloadrvvm1x4dfrvvm1di */

    case 442:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22350; /* pred_indexed_uloadrvvm1x5dfrvvmf8qi */

    case 443:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22352; /* pred_indexed_uloadrvvm1x5dfrvvmf4hi */

    case 444:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22354; /* pred_indexed_uloadrvvm1x5dfrvvmf2si */

    case 445:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22356; /* pred_indexed_uloadrvvm1x5dfrvvm1di */

    case 446:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22358; /* pred_indexed_uloadrvvm1x6dfrvvmf8qi */

    case 447:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22360; /* pred_indexed_uloadrvvm1x6dfrvvmf4hi */

    case 448:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22362; /* pred_indexed_uloadrvvm1x6dfrvvmf2si */

    case 449:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22364; /* pred_indexed_uloadrvvm1x6dfrvvm1di */

    case 450:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22366; /* pred_indexed_uloadrvvm1x7dfrvvmf8qi */

    case 451:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22368; /* pred_indexed_uloadrvvm1x7dfrvvmf4hi */

    case 452:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22370; /* pred_indexed_uloadrvvm1x7dfrvvmf2si */

    case 453:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22372; /* pred_indexed_uloadrvvm1x7dfrvvm1di */

    case 454:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22374; /* pred_indexed_uloadrvvm1x8dfrvvmf8qi */

    case 455:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22376; /* pred_indexed_uloadrvvm1x8dfrvvmf4hi */

    case 456:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22378; /* pred_indexed_uloadrvvm1x8dfrvvmf2si */

    case 457:
      if (!(
#line 8487 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22380; /* pred_indexed_uloadrvvm1x8dfrvvm1di */

    case 458:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22382; /* pred_indexed_uloadrvvmf4x2qirvvmf4qi */

    case 459:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22478; /* pred_indexed_uloadrvvmf4x2qirvvmf2hi */

    case 460:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22574; /* pred_indexed_uloadrvvmf4x2qirvvm1si */

    case 461:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22670; /* pred_indexed_uloadrvvmf4x2qirvvm2di */

    case 462:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22384; /* pred_indexed_uloadrvvmf4x3qirvvmf4qi */

    case 463:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22480; /* pred_indexed_uloadrvvmf4x3qirvvmf2hi */

    case 464:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22576; /* pred_indexed_uloadrvvmf4x3qirvvm1si */

    case 465:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22672; /* pred_indexed_uloadrvvmf4x3qirvvm2di */

    case 466:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22386; /* pred_indexed_uloadrvvmf4x4qirvvmf4qi */

    case 467:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22482; /* pred_indexed_uloadrvvmf4x4qirvvmf2hi */

    case 468:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22578; /* pred_indexed_uloadrvvmf4x4qirvvm1si */

    case 469:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22674; /* pred_indexed_uloadrvvmf4x4qirvvm2di */

    case 470:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22388; /* pred_indexed_uloadrvvmf4x5qirvvmf4qi */

    case 471:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22484; /* pred_indexed_uloadrvvmf4x5qirvvmf2hi */

    case 472:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22580; /* pred_indexed_uloadrvvmf4x5qirvvm1si */

    case 473:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22676; /* pred_indexed_uloadrvvmf4x5qirvvm2di */

    case 474:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22390; /* pred_indexed_uloadrvvmf4x6qirvvmf4qi */

    case 475:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22486; /* pred_indexed_uloadrvvmf4x6qirvvmf2hi */

    case 476:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22582; /* pred_indexed_uloadrvvmf4x6qirvvm1si */

    case 477:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22678; /* pred_indexed_uloadrvvmf4x6qirvvm2di */

    case 478:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22392; /* pred_indexed_uloadrvvmf4x7qirvvmf4qi */

    case 479:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22488; /* pred_indexed_uloadrvvmf4x7qirvvmf2hi */

    case 480:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22584; /* pred_indexed_uloadrvvmf4x7qirvvm1si */

    case 481:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22680; /* pred_indexed_uloadrvvmf4x7qirvvm2di */

    case 482:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22394; /* pred_indexed_uloadrvvmf4x8qirvvmf4qi */

    case 483:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22490; /* pred_indexed_uloadrvvmf4x8qirvvmf2hi */

    case 484:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22586; /* pred_indexed_uloadrvvmf4x8qirvvm1si */

    case 485:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22682; /* pred_indexed_uloadrvvmf4x8qirvvm2di */

    case 486:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22396; /* pred_indexed_uloadrvvmf2x2hirvvmf4qi */

    case 487:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22492; /* pred_indexed_uloadrvvmf2x2hirvvmf2hi */

    case 488:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22588; /* pred_indexed_uloadrvvmf2x2hirvvm1si */

    case 489:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22684; /* pred_indexed_uloadrvvmf2x2hirvvm2di */

    case 490:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22398; /* pred_indexed_uloadrvvmf2x3hirvvmf4qi */

    case 491:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22494; /* pred_indexed_uloadrvvmf2x3hirvvmf2hi */

    case 492:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22590; /* pred_indexed_uloadrvvmf2x3hirvvm1si */

    case 493:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22686; /* pred_indexed_uloadrvvmf2x3hirvvm2di */

    case 494:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22400; /* pred_indexed_uloadrvvmf2x4hirvvmf4qi */

    case 495:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22496; /* pred_indexed_uloadrvvmf2x4hirvvmf2hi */

    case 496:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22592; /* pred_indexed_uloadrvvmf2x4hirvvm1si */

    case 497:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22688; /* pred_indexed_uloadrvvmf2x4hirvvm2di */

    case 498:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22402; /* pred_indexed_uloadrvvmf2x5hirvvmf4qi */

    case 499:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22498; /* pred_indexed_uloadrvvmf2x5hirvvmf2hi */

    case 500:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22594; /* pred_indexed_uloadrvvmf2x5hirvvm1si */

    case 501:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22690; /* pred_indexed_uloadrvvmf2x5hirvvm2di */

    case 502:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22404; /* pred_indexed_uloadrvvmf2x6hirvvmf4qi */

    case 503:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22500; /* pred_indexed_uloadrvvmf2x6hirvvmf2hi */

    case 504:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22596; /* pred_indexed_uloadrvvmf2x6hirvvm1si */

    case 505:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22692; /* pred_indexed_uloadrvvmf2x6hirvvm2di */

    case 506:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22406; /* pred_indexed_uloadrvvmf2x7hirvvmf4qi */

    case 507:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22502; /* pred_indexed_uloadrvvmf2x7hirvvmf2hi */

    case 508:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22598; /* pred_indexed_uloadrvvmf2x7hirvvm1si */

    case 509:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22694; /* pred_indexed_uloadrvvmf2x7hirvvm2di */

    case 510:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22408; /* pred_indexed_uloadrvvmf2x8hirvvmf4qi */

    case 511:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22504; /* pred_indexed_uloadrvvmf2x8hirvvmf2hi */

    case 512:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22600; /* pred_indexed_uloadrvvmf2x8hirvvm1si */

    case 513:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22696; /* pred_indexed_uloadrvvmf2x8hirvvm2di */

    case 514:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22410; /* pred_indexed_uloadrvvm1x2sirvvmf4qi */

    case 515:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22506; /* pred_indexed_uloadrvvm1x2sirvvmf2hi */

    case 516:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22602; /* pred_indexed_uloadrvvm1x2sirvvm1si */

    case 517:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22698; /* pred_indexed_uloadrvvm1x2sirvvm2di */

    case 518:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22412; /* pred_indexed_uloadrvvm1x3sirvvmf4qi */

    case 519:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22508; /* pred_indexed_uloadrvvm1x3sirvvmf2hi */

    case 520:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22604; /* pred_indexed_uloadrvvm1x3sirvvm1si */

    case 521:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22700; /* pred_indexed_uloadrvvm1x3sirvvm2di */

    case 522:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22414; /* pred_indexed_uloadrvvm1x4sirvvmf4qi */

    case 523:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22510; /* pred_indexed_uloadrvvm1x4sirvvmf2hi */

    case 524:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22606; /* pred_indexed_uloadrvvm1x4sirvvm1si */

    case 525:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22702; /* pred_indexed_uloadrvvm1x4sirvvm2di */

    case 526:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22416; /* pred_indexed_uloadrvvm1x5sirvvmf4qi */

    case 527:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22512; /* pred_indexed_uloadrvvm1x5sirvvmf2hi */

    case 528:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22608; /* pred_indexed_uloadrvvm1x5sirvvm1si */

    case 529:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22704; /* pred_indexed_uloadrvvm1x5sirvvm2di */

    case 530:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22418; /* pred_indexed_uloadrvvm1x6sirvvmf4qi */

    case 531:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22514; /* pred_indexed_uloadrvvm1x6sirvvmf2hi */

    case 532:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22610; /* pred_indexed_uloadrvvm1x6sirvvm1si */

    case 533:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22706; /* pred_indexed_uloadrvvm1x6sirvvm2di */

    case 534:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22420; /* pred_indexed_uloadrvvm1x7sirvvmf4qi */

    case 535:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22516; /* pred_indexed_uloadrvvm1x7sirvvmf2hi */

    case 536:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22612; /* pred_indexed_uloadrvvm1x7sirvvm1si */

    case 537:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22708; /* pred_indexed_uloadrvvm1x7sirvvm2di */

    case 538:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22422; /* pred_indexed_uloadrvvm1x8sirvvmf4qi */

    case 539:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22518; /* pred_indexed_uloadrvvm1x8sirvvmf2hi */

    case 540:
      if (!
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22614; /* pred_indexed_uloadrvvm1x8sirvvm1si */

    case 541:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22710; /* pred_indexed_uloadrvvm1x8sirvvm2di */

    case 542:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22424; /* pred_indexed_uloadrvvm2x2dirvvmf4qi */

    case 543:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22520; /* pred_indexed_uloadrvvm2x2dirvvmf2hi */

    case 544:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22616; /* pred_indexed_uloadrvvm2x2dirvvm1si */

    case 545:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22712; /* pred_indexed_uloadrvvm2x2dirvvm2di */

    case 546:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22426; /* pred_indexed_uloadrvvm2x3dirvvmf4qi */

    case 547:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22522; /* pred_indexed_uloadrvvm2x3dirvvmf2hi */

    case 548:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22618; /* pred_indexed_uloadrvvm2x3dirvvm1si */

    case 549:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22714; /* pred_indexed_uloadrvvm2x3dirvvm2di */

    case 550:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22428; /* pred_indexed_uloadrvvm2x4dirvvmf4qi */

    case 551:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22524; /* pred_indexed_uloadrvvm2x4dirvvmf2hi */

    case 552:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22620; /* pred_indexed_uloadrvvm2x4dirvvm1si */

    case 553:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22716; /* pred_indexed_uloadrvvm2x4dirvvm2di */

    case 554:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22430; /* pred_indexed_uloadrvvmf2x2bfrvvmf4qi */

    case 555:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22526; /* pred_indexed_uloadrvvmf2x2bfrvvmf2hi */

    case 556:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22622; /* pred_indexed_uloadrvvmf2x2bfrvvm1si */

    case 557:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22718; /* pred_indexed_uloadrvvmf2x2bfrvvm2di */

    case 558:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22432; /* pred_indexed_uloadrvvmf2x3bfrvvmf4qi */

    case 559:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22528; /* pred_indexed_uloadrvvmf2x3bfrvvmf2hi */

    case 560:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22624; /* pred_indexed_uloadrvvmf2x3bfrvvm1si */

    case 561:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22720; /* pred_indexed_uloadrvvmf2x3bfrvvm2di */

    case 562:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22434; /* pred_indexed_uloadrvvmf2x4bfrvvmf4qi */

    case 563:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22530; /* pred_indexed_uloadrvvmf2x4bfrvvmf2hi */

    case 564:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22626; /* pred_indexed_uloadrvvmf2x4bfrvvm1si */

    case 565:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22722; /* pred_indexed_uloadrvvmf2x4bfrvvm2di */

    case 566:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22436; /* pred_indexed_uloadrvvmf2x5bfrvvmf4qi */

    case 567:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22532; /* pred_indexed_uloadrvvmf2x5bfrvvmf2hi */

    case 568:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22628; /* pred_indexed_uloadrvvmf2x5bfrvvm1si */

    case 569:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22724; /* pred_indexed_uloadrvvmf2x5bfrvvm2di */

    case 570:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22438; /* pred_indexed_uloadrvvmf2x6bfrvvmf4qi */

    case 571:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22534; /* pred_indexed_uloadrvvmf2x6bfrvvmf2hi */

    case 572:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22630; /* pred_indexed_uloadrvvmf2x6bfrvvm1si */

    case 573:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22726; /* pred_indexed_uloadrvvmf2x6bfrvvm2di */

    case 574:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22440; /* pred_indexed_uloadrvvmf2x7bfrvvmf4qi */

    case 575:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22536; /* pred_indexed_uloadrvvmf2x7bfrvvmf2hi */

    case 576:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22632; /* pred_indexed_uloadrvvmf2x7bfrvvm1si */

    case 577:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22728; /* pred_indexed_uloadrvvmf2x7bfrvvm2di */

    case 578:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22442; /* pred_indexed_uloadrvvmf2x8bfrvvmf4qi */

    case 579:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22538; /* pred_indexed_uloadrvvmf2x8bfrvvmf2hi */

    case 580:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22634; /* pred_indexed_uloadrvvmf2x8bfrvvm1si */

    case 581:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22730; /* pred_indexed_uloadrvvmf2x8bfrvvm2di */

    case 582:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22444; /* pred_indexed_uloadrvvmf2x2hfrvvmf4qi */

    case 583:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22540; /* pred_indexed_uloadrvvmf2x2hfrvvmf2hi */

    case 584:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22636; /* pred_indexed_uloadrvvmf2x2hfrvvm1si */

    case 585:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22732; /* pred_indexed_uloadrvvmf2x2hfrvvm2di */

    case 586:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22446; /* pred_indexed_uloadrvvmf2x3hfrvvmf4qi */

    case 587:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22542; /* pred_indexed_uloadrvvmf2x3hfrvvmf2hi */

    case 588:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22638; /* pred_indexed_uloadrvvmf2x3hfrvvm1si */

    case 589:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22734; /* pred_indexed_uloadrvvmf2x3hfrvvm2di */

    case 590:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22448; /* pred_indexed_uloadrvvmf2x4hfrvvmf4qi */

    case 591:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22544; /* pred_indexed_uloadrvvmf2x4hfrvvmf2hi */

    case 592:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22640; /* pred_indexed_uloadrvvmf2x4hfrvvm1si */

    case 593:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22736; /* pred_indexed_uloadrvvmf2x4hfrvvm2di */

    case 594:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22450; /* pred_indexed_uloadrvvmf2x5hfrvvmf4qi */

    case 595:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22546; /* pred_indexed_uloadrvvmf2x5hfrvvmf2hi */

    case 596:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22642; /* pred_indexed_uloadrvvmf2x5hfrvvm1si */

    case 597:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22738; /* pred_indexed_uloadrvvmf2x5hfrvvm2di */

    case 598:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22452; /* pred_indexed_uloadrvvmf2x6hfrvvmf4qi */

    case 599:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22548; /* pred_indexed_uloadrvvmf2x6hfrvvmf2hi */

    case 600:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22644; /* pred_indexed_uloadrvvmf2x6hfrvvm1si */

    case 601:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22740; /* pred_indexed_uloadrvvmf2x6hfrvvm2di */

    case 602:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22454; /* pred_indexed_uloadrvvmf2x7hfrvvmf4qi */

    case 603:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22550; /* pred_indexed_uloadrvvmf2x7hfrvvmf2hi */

    case 604:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22646; /* pred_indexed_uloadrvvmf2x7hfrvvm1si */

    case 605:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22742; /* pred_indexed_uloadrvvmf2x7hfrvvm2di */

    case 606:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22456; /* pred_indexed_uloadrvvmf2x8hfrvvmf4qi */

    case 607:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22552; /* pred_indexed_uloadrvvmf2x8hfrvvmf2hi */

    case 608:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22648; /* pred_indexed_uloadrvvmf2x8hfrvvm1si */

    case 609:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22744; /* pred_indexed_uloadrvvmf2x8hfrvvm2di */

    case 610:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22458; /* pred_indexed_uloadrvvm1x2sfrvvmf4qi */

    case 611:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22554; /* pred_indexed_uloadrvvm1x2sfrvvmf2hi */

    case 612:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22650; /* pred_indexed_uloadrvvm1x2sfrvvm1si */

    case 613:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22746; /* pred_indexed_uloadrvvm1x2sfrvvm2di */

    case 614:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22460; /* pred_indexed_uloadrvvm1x3sfrvvmf4qi */

    case 615:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22556; /* pred_indexed_uloadrvvm1x3sfrvvmf2hi */

    case 616:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22652; /* pred_indexed_uloadrvvm1x3sfrvvm1si */

    case 617:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22748; /* pred_indexed_uloadrvvm1x3sfrvvm2di */

    case 618:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22462; /* pred_indexed_uloadrvvm1x4sfrvvmf4qi */

    case 619:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22558; /* pred_indexed_uloadrvvm1x4sfrvvmf2hi */

    case 620:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22654; /* pred_indexed_uloadrvvm1x4sfrvvm1si */

    case 621:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22750; /* pred_indexed_uloadrvvm1x4sfrvvm2di */

    case 622:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22464; /* pred_indexed_uloadrvvm1x5sfrvvmf4qi */

    case 623:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22560; /* pred_indexed_uloadrvvm1x5sfrvvmf2hi */

    case 624:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22656; /* pred_indexed_uloadrvvm1x5sfrvvm1si */

    case 625:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22752; /* pred_indexed_uloadrvvm1x5sfrvvm2di */

    case 626:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22466; /* pred_indexed_uloadrvvm1x6sfrvvmf4qi */

    case 627:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22562; /* pred_indexed_uloadrvvm1x6sfrvvmf2hi */

    case 628:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22658; /* pred_indexed_uloadrvvm1x6sfrvvm1si */

    case 629:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22754; /* pred_indexed_uloadrvvm1x6sfrvvm2di */

    case 630:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22468; /* pred_indexed_uloadrvvm1x7sfrvvmf4qi */

    case 631:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22564; /* pred_indexed_uloadrvvm1x7sfrvvmf2hi */

    case 632:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22660; /* pred_indexed_uloadrvvm1x7sfrvvm1si */

    case 633:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22756; /* pred_indexed_uloadrvvm1x7sfrvvm2di */

    case 634:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22470; /* pred_indexed_uloadrvvm1x8sfrvvmf4qi */

    case 635:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22566; /* pred_indexed_uloadrvvm1x8sfrvvmf2hi */

    case 636:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22662; /* pred_indexed_uloadrvvm1x8sfrvvm1si */

    case 637:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22758; /* pred_indexed_uloadrvvm1x8sfrvvm2di */

    case 638:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22472; /* pred_indexed_uloadrvvm2x2dfrvvmf4qi */

    case 639:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22568; /* pred_indexed_uloadrvvm2x2dfrvvmf2hi */

    case 640:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22664; /* pred_indexed_uloadrvvm2x2dfrvvm1si */

    case 641:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22760; /* pred_indexed_uloadrvvm2x2dfrvvm2di */

    case 642:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22474; /* pred_indexed_uloadrvvm2x3dfrvvmf4qi */

    case 643:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22570; /* pred_indexed_uloadrvvm2x3dfrvvmf2hi */

    case 644:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22666; /* pred_indexed_uloadrvvm2x3dfrvvm1si */

    case 645:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22762; /* pred_indexed_uloadrvvm2x3dfrvvm2di */

    case 646:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22476; /* pred_indexed_uloadrvvm2x4dfrvvmf4qi */

    case 647:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22572; /* pred_indexed_uloadrvvm2x4dfrvvmf2hi */

    case 648:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22668; /* pred_indexed_uloadrvvm2x4dfrvvm1si */

    case 649:
      if (!(
#line 8508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22764; /* pred_indexed_uloadrvvm2x4dfrvvm2di */

    case 650:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22766; /* pred_indexed_uloadrvvmf2x2qirvvmf2qi */

    case 651:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22838; /* pred_indexed_uloadrvvmf2x2qirvvm1hi */

    case 652:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22910; /* pred_indexed_uloadrvvmf2x2qirvvm2si */

    case 653:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22982; /* pred_indexed_uloadrvvmf2x2qirvvm4di */

    case 654:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22768; /* pred_indexed_uloadrvvmf2x3qirvvmf2qi */

    case 655:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22840; /* pred_indexed_uloadrvvmf2x3qirvvm1hi */

    case 656:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22912; /* pred_indexed_uloadrvvmf2x3qirvvm2si */

    case 657:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22984; /* pred_indexed_uloadrvvmf2x3qirvvm4di */

    case 658:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22770; /* pred_indexed_uloadrvvmf2x4qirvvmf2qi */

    case 659:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22842; /* pred_indexed_uloadrvvmf2x4qirvvm1hi */

    case 660:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22914; /* pred_indexed_uloadrvvmf2x4qirvvm2si */

    case 661:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22986; /* pred_indexed_uloadrvvmf2x4qirvvm4di */

    case 662:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22772; /* pred_indexed_uloadrvvmf2x5qirvvmf2qi */

    case 663:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22844; /* pred_indexed_uloadrvvmf2x5qirvvm1hi */

    case 664:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22916; /* pred_indexed_uloadrvvmf2x5qirvvm2si */

    case 665:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22988; /* pred_indexed_uloadrvvmf2x5qirvvm4di */

    case 666:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22774; /* pred_indexed_uloadrvvmf2x6qirvvmf2qi */

    case 667:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22846; /* pred_indexed_uloadrvvmf2x6qirvvm1hi */

    case 668:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22918; /* pred_indexed_uloadrvvmf2x6qirvvm2si */

    case 669:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22990; /* pred_indexed_uloadrvvmf2x6qirvvm4di */

    case 670:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22776; /* pred_indexed_uloadrvvmf2x7qirvvmf2qi */

    case 671:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22848; /* pred_indexed_uloadrvvmf2x7qirvvm1hi */

    case 672:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22920; /* pred_indexed_uloadrvvmf2x7qirvvm2si */

    case 673:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22992; /* pred_indexed_uloadrvvmf2x7qirvvm4di */

    case 674:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22778; /* pred_indexed_uloadrvvmf2x8qirvvmf2qi */

    case 675:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22850; /* pred_indexed_uloadrvvmf2x8qirvvm1hi */

    case 676:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22922; /* pred_indexed_uloadrvvmf2x8qirvvm2si */

    case 677:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22994; /* pred_indexed_uloadrvvmf2x8qirvvm4di */

    case 678:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22780; /* pred_indexed_uloadrvvm1x2hirvvmf2qi */

    case 679:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22852; /* pred_indexed_uloadrvvm1x2hirvvm1hi */

    case 680:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22924; /* pred_indexed_uloadrvvm1x2hirvvm2si */

    case 681:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22996; /* pred_indexed_uloadrvvm1x2hirvvm4di */

    case 682:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22782; /* pred_indexed_uloadrvvm1x3hirvvmf2qi */

    case 683:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22854; /* pred_indexed_uloadrvvm1x3hirvvm1hi */

    case 684:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22926; /* pred_indexed_uloadrvvm1x3hirvvm2si */

    case 685:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22998; /* pred_indexed_uloadrvvm1x3hirvvm4di */

    case 686:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22784; /* pred_indexed_uloadrvvm1x4hirvvmf2qi */

    case 687:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22856; /* pred_indexed_uloadrvvm1x4hirvvm1hi */

    case 688:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22928; /* pred_indexed_uloadrvvm1x4hirvvm2si */

    case 689:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23000; /* pred_indexed_uloadrvvm1x4hirvvm4di */

    case 690:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22786; /* pred_indexed_uloadrvvm1x5hirvvmf2qi */

    case 691:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22858; /* pred_indexed_uloadrvvm1x5hirvvm1hi */

    case 692:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22930; /* pred_indexed_uloadrvvm1x5hirvvm2si */

    case 693:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23002; /* pred_indexed_uloadrvvm1x5hirvvm4di */

    case 694:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22788; /* pred_indexed_uloadrvvm1x6hirvvmf2qi */

    case 695:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22860; /* pred_indexed_uloadrvvm1x6hirvvm1hi */

    case 696:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22932; /* pred_indexed_uloadrvvm1x6hirvvm2si */

    case 697:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23004; /* pred_indexed_uloadrvvm1x6hirvvm4di */

    case 698:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22790; /* pred_indexed_uloadrvvm1x7hirvvmf2qi */

    case 699:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22862; /* pred_indexed_uloadrvvm1x7hirvvm1hi */

    case 700:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22934; /* pred_indexed_uloadrvvm1x7hirvvm2si */

    case 701:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23006; /* pred_indexed_uloadrvvm1x7hirvvm4di */

    case 702:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22792; /* pred_indexed_uloadrvvm1x8hirvvmf2qi */

    case 703:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22864; /* pred_indexed_uloadrvvm1x8hirvvm1hi */

    case 704:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22936; /* pred_indexed_uloadrvvm1x8hirvvm2si */

    case 705:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23008; /* pred_indexed_uloadrvvm1x8hirvvm4di */

    case 706:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22794; /* pred_indexed_uloadrvvm2x2sirvvmf2qi */

    case 707:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22866; /* pred_indexed_uloadrvvm2x2sirvvm1hi */

    case 708:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22938; /* pred_indexed_uloadrvvm2x2sirvvm2si */

    case 709:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23010; /* pred_indexed_uloadrvvm2x2sirvvm4di */

    case 710:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22796; /* pred_indexed_uloadrvvm2x3sirvvmf2qi */

    case 711:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22868; /* pred_indexed_uloadrvvm2x3sirvvm1hi */

    case 712:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22940; /* pred_indexed_uloadrvvm2x3sirvvm2si */

    case 713:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23012; /* pred_indexed_uloadrvvm2x3sirvvm4di */

    case 714:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22798; /* pred_indexed_uloadrvvm2x4sirvvmf2qi */

    case 715:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22870; /* pred_indexed_uloadrvvm2x4sirvvm1hi */

    case 716:
      if (!
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22942; /* pred_indexed_uloadrvvm2x4sirvvm2si */

    case 717:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23014; /* pred_indexed_uloadrvvm2x4sirvvm4di */

    case 718:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22800; /* pred_indexed_uloadrvvm4x2dirvvmf2qi */

    case 719:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22872; /* pred_indexed_uloadrvvm4x2dirvvm1hi */

    case 720:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22944; /* pred_indexed_uloadrvvm4x2dirvvm2si */

    case 721:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23016; /* pred_indexed_uloadrvvm4x2dirvvm4di */

    case 722:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22802; /* pred_indexed_uloadrvvm1x2bfrvvmf2qi */

    case 723:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22874; /* pred_indexed_uloadrvvm1x2bfrvvm1hi */

    case 724:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22946; /* pred_indexed_uloadrvvm1x2bfrvvm2si */

    case 725:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23018; /* pred_indexed_uloadrvvm1x2bfrvvm4di */

    case 726:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22804; /* pred_indexed_uloadrvvm1x3bfrvvmf2qi */

    case 727:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22876; /* pred_indexed_uloadrvvm1x3bfrvvm1hi */

    case 728:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22948; /* pred_indexed_uloadrvvm1x3bfrvvm2si */

    case 729:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23020; /* pred_indexed_uloadrvvm1x3bfrvvm4di */

    case 730:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22806; /* pred_indexed_uloadrvvm1x4bfrvvmf2qi */

    case 731:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22878; /* pred_indexed_uloadrvvm1x4bfrvvm1hi */

    case 732:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22950; /* pred_indexed_uloadrvvm1x4bfrvvm2si */

    case 733:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23022; /* pred_indexed_uloadrvvm1x4bfrvvm4di */

    case 734:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22808; /* pred_indexed_uloadrvvm1x5bfrvvmf2qi */

    case 735:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22880; /* pred_indexed_uloadrvvm1x5bfrvvm1hi */

    case 736:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22952; /* pred_indexed_uloadrvvm1x5bfrvvm2si */

    case 737:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23024; /* pred_indexed_uloadrvvm1x5bfrvvm4di */

    case 738:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22810; /* pred_indexed_uloadrvvm1x6bfrvvmf2qi */

    case 739:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22882; /* pred_indexed_uloadrvvm1x6bfrvvm1hi */

    case 740:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22954; /* pred_indexed_uloadrvvm1x6bfrvvm2si */

    case 741:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23026; /* pred_indexed_uloadrvvm1x6bfrvvm4di */

    case 742:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22812; /* pred_indexed_uloadrvvm1x7bfrvvmf2qi */

    case 743:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22884; /* pred_indexed_uloadrvvm1x7bfrvvm1hi */

    case 744:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22956; /* pred_indexed_uloadrvvm1x7bfrvvm2si */

    case 745:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23028; /* pred_indexed_uloadrvvm1x7bfrvvm4di */

    case 746:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22814; /* pred_indexed_uloadrvvm1x8bfrvvmf2qi */

    case 747:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22886; /* pred_indexed_uloadrvvm1x8bfrvvm1hi */

    case 748:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22958; /* pred_indexed_uloadrvvm1x8bfrvvm2si */

    case 749:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23030; /* pred_indexed_uloadrvvm1x8bfrvvm4di */

    case 750:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22816; /* pred_indexed_uloadrvvm1x2hfrvvmf2qi */

    case 751:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22888; /* pred_indexed_uloadrvvm1x2hfrvvm1hi */

    case 752:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22960; /* pred_indexed_uloadrvvm1x2hfrvvm2si */

    case 753:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23032; /* pred_indexed_uloadrvvm1x2hfrvvm4di */

    case 754:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22818; /* pred_indexed_uloadrvvm1x3hfrvvmf2qi */

    case 755:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22890; /* pred_indexed_uloadrvvm1x3hfrvvm1hi */

    case 756:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22962; /* pred_indexed_uloadrvvm1x3hfrvvm2si */

    case 757:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23034; /* pred_indexed_uloadrvvm1x3hfrvvm4di */

    case 758:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22820; /* pred_indexed_uloadrvvm1x4hfrvvmf2qi */

    case 759:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22892; /* pred_indexed_uloadrvvm1x4hfrvvm1hi */

    case 760:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22964; /* pred_indexed_uloadrvvm1x4hfrvvm2si */

    case 761:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23036; /* pred_indexed_uloadrvvm1x4hfrvvm4di */

    case 762:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22822; /* pred_indexed_uloadrvvm1x5hfrvvmf2qi */

    case 763:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22894; /* pred_indexed_uloadrvvm1x5hfrvvm1hi */

    case 764:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22966; /* pred_indexed_uloadrvvm1x5hfrvvm2si */

    case 765:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23038; /* pred_indexed_uloadrvvm1x5hfrvvm4di */

    case 766:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22824; /* pred_indexed_uloadrvvm1x6hfrvvmf2qi */

    case 767:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22896; /* pred_indexed_uloadrvvm1x6hfrvvm1hi */

    case 768:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22968; /* pred_indexed_uloadrvvm1x6hfrvvm2si */

    case 769:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23040; /* pred_indexed_uloadrvvm1x6hfrvvm4di */

    case 770:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22826; /* pred_indexed_uloadrvvm1x7hfrvvmf2qi */

    case 771:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22898; /* pred_indexed_uloadrvvm1x7hfrvvm1hi */

    case 772:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22970; /* pred_indexed_uloadrvvm1x7hfrvvm2si */

    case 773:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23042; /* pred_indexed_uloadrvvm1x7hfrvvm4di */

    case 774:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22828; /* pred_indexed_uloadrvvm1x8hfrvvmf2qi */

    case 775:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22900; /* pred_indexed_uloadrvvm1x8hfrvvm1hi */

    case 776:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22972; /* pred_indexed_uloadrvvm1x8hfrvvm2si */

    case 777:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23044; /* pred_indexed_uloadrvvm1x8hfrvvm4di */

    case 778:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22830; /* pred_indexed_uloadrvvm2x2sfrvvmf2qi */

    case 779:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22902; /* pred_indexed_uloadrvvm2x2sfrvvm1hi */

    case 780:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22974; /* pred_indexed_uloadrvvm2x2sfrvvm2si */

    case 781:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23046; /* pred_indexed_uloadrvvm2x2sfrvvm4di */

    case 782:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22832; /* pred_indexed_uloadrvvm2x3sfrvvmf2qi */

    case 783:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22904; /* pred_indexed_uloadrvvm2x3sfrvvm1hi */

    case 784:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22976; /* pred_indexed_uloadrvvm2x3sfrvvm2si */

    case 785:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23048; /* pred_indexed_uloadrvvm2x3sfrvvm4di */

    case 786:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22834; /* pred_indexed_uloadrvvm2x4sfrvvmf2qi */

    case 787:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22906; /* pred_indexed_uloadrvvm2x4sfrvvm1hi */

    case 788:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22978; /* pred_indexed_uloadrvvm2x4sfrvvm2si */

    case 789:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23050; /* pred_indexed_uloadrvvm2x4sfrvvm4di */

    case 790:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22836; /* pred_indexed_uloadrvvm4x2dfrvvmf2qi */

    case 791:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22908; /* pred_indexed_uloadrvvm4x2dfrvvm1hi */

    case 792:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22980; /* pred_indexed_uloadrvvm4x2dfrvvm2si */

    case 793:
      if (!(
#line 8529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23052; /* pred_indexed_uloadrvvm4x2dfrvvm4di */

    case 794:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23054; /* pred_indexed_uloadrvvm1x2qirvvm1qi */

    case 795:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23056; /* pred_indexed_uloadrvvm1x2qirvvm2hi */

    case 796:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23058; /* pred_indexed_uloadrvvm1x2qirvvm4si */

    case 797:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23060; /* pred_indexed_uloadrvvm1x2qirvvm8di */

    case 798:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23062; /* pred_indexed_uloadrvvm1x3qirvvm1qi */

    case 799:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23064; /* pred_indexed_uloadrvvm1x3qirvvm2hi */

    case 800:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23066; /* pred_indexed_uloadrvvm1x3qirvvm4si */

    case 801:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23068; /* pred_indexed_uloadrvvm1x3qirvvm8di */

    case 802:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23070; /* pred_indexed_uloadrvvm1x4qirvvm1qi */

    case 803:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23072; /* pred_indexed_uloadrvvm1x4qirvvm2hi */

    case 804:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23074; /* pred_indexed_uloadrvvm1x4qirvvm4si */

    case 805:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23076; /* pred_indexed_uloadrvvm1x4qirvvm8di */

    case 806:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23078; /* pred_indexed_uloadrvvm1x5qirvvm1qi */

    case 807:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23080; /* pred_indexed_uloadrvvm1x5qirvvm2hi */

    case 808:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23082; /* pred_indexed_uloadrvvm1x5qirvvm4si */

    case 809:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23084; /* pred_indexed_uloadrvvm1x5qirvvm8di */

    case 810:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23086; /* pred_indexed_uloadrvvm1x6qirvvm1qi */

    case 811:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23088; /* pred_indexed_uloadrvvm1x6qirvvm2hi */

    case 812:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23090; /* pred_indexed_uloadrvvm1x6qirvvm4si */

    case 813:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23092; /* pred_indexed_uloadrvvm1x6qirvvm8di */

    case 814:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23094; /* pred_indexed_uloadrvvm1x7qirvvm1qi */

    case 815:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23096; /* pred_indexed_uloadrvvm1x7qirvvm2hi */

    case 816:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23098; /* pred_indexed_uloadrvvm1x7qirvvm4si */

    case 817:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23100; /* pred_indexed_uloadrvvm1x7qirvvm8di */

    case 818:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23102; /* pred_indexed_uloadrvvm1x8qirvvm1qi */

    case 819:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23104; /* pred_indexed_uloadrvvm1x8qirvvm2hi */

    case 820:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23106; /* pred_indexed_uloadrvvm1x8qirvvm4si */

    case 821:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23108; /* pred_indexed_uloadrvvm1x8qirvvm8di */

    case 822:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23110; /* pred_indexed_uloadrvvm2x2hirvvm1qi */

    case 823:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23112; /* pred_indexed_uloadrvvm2x2hirvvm2hi */

    case 824:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23114; /* pred_indexed_uloadrvvm2x2hirvvm4si */

    case 825:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23116; /* pred_indexed_uloadrvvm2x2hirvvm8di */

    case 826:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23118; /* pred_indexed_uloadrvvm2x3hirvvm1qi */

    case 827:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23120; /* pred_indexed_uloadrvvm2x3hirvvm2hi */

    case 828:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23122; /* pred_indexed_uloadrvvm2x3hirvvm4si */

    case 829:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23124; /* pred_indexed_uloadrvvm2x3hirvvm8di */

    case 830:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23126; /* pred_indexed_uloadrvvm2x4hirvvm1qi */

    case 831:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23128; /* pred_indexed_uloadrvvm2x4hirvvm2hi */

    case 832:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23130; /* pred_indexed_uloadrvvm2x4hirvvm4si */

    case 833:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23132; /* pred_indexed_uloadrvvm2x4hirvvm8di */

    case 834:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23134; /* pred_indexed_uloadrvvm4x2sirvvm1qi */

    case 835:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23136; /* pred_indexed_uloadrvvm4x2sirvvm2hi */

    case 836:
      if (!
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23138; /* pred_indexed_uloadrvvm4x2sirvvm4si */

    case 837:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23140; /* pred_indexed_uloadrvvm4x2sirvvm8di */

    case 838:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23142; /* pred_indexed_uloadrvvm2x2bfrvvm1qi */

    case 839:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23144; /* pred_indexed_uloadrvvm2x2bfrvvm2hi */

    case 840:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23146; /* pred_indexed_uloadrvvm2x2bfrvvm4si */

    case 841:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23148; /* pred_indexed_uloadrvvm2x2bfrvvm8di */

    case 842:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23150; /* pred_indexed_uloadrvvm2x3bfrvvm1qi */

    case 843:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23152; /* pred_indexed_uloadrvvm2x3bfrvvm2hi */

    case 844:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23154; /* pred_indexed_uloadrvvm2x3bfrvvm4si */

    case 845:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23156; /* pred_indexed_uloadrvvm2x3bfrvvm8di */

    case 846:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23158; /* pred_indexed_uloadrvvm2x4bfrvvm1qi */

    case 847:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23160; /* pred_indexed_uloadrvvm2x4bfrvvm2hi */

    case 848:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23162; /* pred_indexed_uloadrvvm2x4bfrvvm4si */

    case 849:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23164; /* pred_indexed_uloadrvvm2x4bfrvvm8di */

    case 850:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23166; /* pred_indexed_uloadrvvm2x2hfrvvm1qi */

    case 851:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23168; /* pred_indexed_uloadrvvm2x2hfrvvm2hi */

    case 852:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23170; /* pred_indexed_uloadrvvm2x2hfrvvm4si */

    case 853:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23172; /* pred_indexed_uloadrvvm2x2hfrvvm8di */

    case 854:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23174; /* pred_indexed_uloadrvvm2x3hfrvvm1qi */

    case 855:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23176; /* pred_indexed_uloadrvvm2x3hfrvvm2hi */

    case 856:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23178; /* pred_indexed_uloadrvvm2x3hfrvvm4si */

    case 857:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23180; /* pred_indexed_uloadrvvm2x3hfrvvm8di */

    case 858:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23182; /* pred_indexed_uloadrvvm2x4hfrvvm1qi */

    case 859:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23184; /* pred_indexed_uloadrvvm2x4hfrvvm2hi */

    case 860:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23186; /* pred_indexed_uloadrvvm2x4hfrvvm4si */

    case 861:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23188; /* pred_indexed_uloadrvvm2x4hfrvvm8di */

    case 862:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23190; /* pred_indexed_uloadrvvm4x2sfrvvm1qi */

    case 863:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23192; /* pred_indexed_uloadrvvm4x2sfrvvm2hi */

    case 864:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23194; /* pred_indexed_uloadrvvm4x2sfrvvm4si */

    case 865:
      if (!(
#line 8550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23196; /* pred_indexed_uloadrvvm4x2sfrvvm8di */

    case 866:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23198; /* pred_indexed_uloadrvvm2x2qirvvm2qi */

    case 867:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23200; /* pred_indexed_uloadrvvm2x2qirvvm4hi */

    case 868:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23202; /* pred_indexed_uloadrvvm2x2qirvvm8si */

    case 869:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23204; /* pred_indexed_uloadrvvm2x3qirvvm2qi */

    case 870:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23206; /* pred_indexed_uloadrvvm2x3qirvvm4hi */

    case 871:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23208; /* pred_indexed_uloadrvvm2x3qirvvm8si */

    case 872:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23210; /* pred_indexed_uloadrvvm2x4qirvvm2qi */

    case 873:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23212; /* pred_indexed_uloadrvvm2x4qirvvm4hi */

    case 874:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23214; /* pred_indexed_uloadrvvm2x4qirvvm8si */

    case 875:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23216; /* pred_indexed_uloadrvvm4x2hirvvm2qi */

    case 876:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23218; /* pred_indexed_uloadrvvm4x2hirvvm4hi */

    case 877:
      if (!
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23220; /* pred_indexed_uloadrvvm4x2hirvvm8si */

    case 878:
      if (!(
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23222; /* pred_indexed_uloadrvvm4x2bfrvvm2qi */

    case 879:
      if (!(
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23224; /* pred_indexed_uloadrvvm4x2bfrvvm4hi */

    case 880:
      if (!(
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23226; /* pred_indexed_uloadrvvm4x2bfrvvm8si */

    case 881:
      if (!(
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23228; /* pred_indexed_uloadrvvm4x2hfrvvm2qi */

    case 882:
      if (!(
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23230; /* pred_indexed_uloadrvvm4x2hfrvvm4hi */

    case 883:
      if (!(
#line 8571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23232; /* pred_indexed_uloadrvvm4x2hfrvvm8si */

    case 884:
      if (!
#line 8592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23234; /* pred_indexed_uloadrvvm4x2qirvvm4qi */

    case 885:
      if (!
#line 8592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23236; /* pred_indexed_uloadrvvm4x2qirvvm8hi */

    default:
      return -1;
    }
}

 int
recog_899 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern503 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5513; /* pred_umodrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5530; /* pred_umodrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5547; /* pred_umodrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5564; /* pred_umodrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5581; /* pred_umodrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5598; /* pred_umodrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5615; /* pred_umodrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5632; /* pred_umodrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5649; /* pred_umodrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5666; /* pred_umodrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5683; /* pred_umodrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5700; /* pred_umodrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5717; /* pred_umodrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5734; /* pred_umodrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5751; /* pred_umodrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5768; /* pred_umodrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5785; /* pred_umodrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5802; /* pred_umodrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5819; /* pred_umodrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5836; /* pred_umodrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5853; /* pred_umodrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5870; /* pred_umodrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5887; /* pred_umodv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5904; /* pred_umodv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5921; /* pred_umodv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5938; /* pred_umodv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5955; /* pred_umodv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5972; /* pred_umodv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5989; /* pred_umodv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6006; /* pred_umodv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6023; /* pred_umodv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6040; /* pred_umodv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6057; /* pred_umodv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6074; /* pred_umodv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6091; /* pred_umodv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6108; /* pred_umodv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6125; /* pred_umodv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6142; /* pred_umodv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6159; /* pred_umodv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6176; /* pred_umodv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6193; /* pred_umodv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6210; /* pred_umodv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6227; /* pred_umodv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6244; /* pred_umodv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6261; /* pred_umodv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6278; /* pred_umodv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6295; /* pred_umodv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6312; /* pred_umodv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6329; /* pred_umodv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6346; /* pred_umodv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6363; /* pred_umodv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6380; /* pred_umodv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6397; /* pred_umodv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6414; /* pred_umodv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6431; /* pred_umodv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6448; /* pred_umodv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6465; /* pred_umodv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6482; /* pred_umodv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6499; /* pred_umodv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6516; /* pred_umodv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6533; /* pred_umodv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6550; /* pred_umodv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6567; /* pred_umodv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6584; /* pred_umodv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6601; /* pred_umodv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6618; /* pred_umodv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6635; /* pred_umodv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6652; /* pred_umodv512di */

    case 68:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7347; /* pred_umodrvvm8qi_scalar */

    case 69:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7352; /* pred_umodrvvm4qi_scalar */

    case 70:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7357; /* pred_umodrvvm2qi_scalar */

    case 71:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7362; /* pred_umodrvvm1qi_scalar */

    case 72:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7367; /* pred_umodrvvmf2qi_scalar */

    case 73:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7372; /* pred_umodrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7377; /* pred_umodrvvmf8qi_scalar */

    case 75:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7382; /* pred_umodrvvm8hi_scalar */

    case 76:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7387; /* pred_umodrvvm4hi_scalar */

    case 77:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7392; /* pred_umodrvvm2hi_scalar */

    case 78:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7397; /* pred_umodrvvm1hi_scalar */

    case 79:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7402; /* pred_umodrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7407; /* pred_umodrvvmf4hi_scalar */

    case 81:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7412; /* pred_umodrvvm8si_scalar */

    case 82:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7417; /* pred_umodrvvm4si_scalar */

    case 83:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7422; /* pred_umodrvvm2si_scalar */

    case 84:
      if (!
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7427; /* pred_umodrvvm1si_scalar */

    case 85:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7432; /* pred_umodrvvmf2si_scalar */

    case 86:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7437; /* pred_umodv1qi_scalar */

    case 87:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7442; /* pred_umodv2qi_scalar */

    case 88:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7447; /* pred_umodv4qi_scalar */

    case 89:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7452; /* pred_umodv8qi_scalar */

    case 90:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7457; /* pred_umodv16qi_scalar */

    case 91:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7462; /* pred_umodv32qi_scalar */

    case 92:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7467; /* pred_umodv64qi_scalar */

    case 93:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7472; /* pred_umodv128qi_scalar */

    case 94:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7477; /* pred_umodv256qi_scalar */

    case 95:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7482; /* pred_umodv512qi_scalar */

    case 96:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7487; /* pred_umodv1024qi_scalar */

    case 97:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7492; /* pred_umodv2048qi_scalar */

    case 98:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7497; /* pred_umodv4096qi_scalar */

    case 99:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7502; /* pred_umodv1hi_scalar */

    case 100:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7507; /* pred_umodv2hi_scalar */

    case 101:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7512; /* pred_umodv4hi_scalar */

    case 102:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7517; /* pred_umodv8hi_scalar */

    case 103:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7522; /* pred_umodv16hi_scalar */

    case 104:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7527; /* pred_umodv32hi_scalar */

    case 105:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7532; /* pred_umodv64hi_scalar */

    case 106:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7537; /* pred_umodv128hi_scalar */

    case 107:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7542; /* pred_umodv256hi_scalar */

    case 108:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7547; /* pred_umodv512hi_scalar */

    case 109:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7552; /* pred_umodv1024hi_scalar */

    case 110:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7557; /* pred_umodv2048hi_scalar */

    case 111:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7562; /* pred_umodv1si_scalar */

    case 112:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7567; /* pred_umodv2si_scalar */

    case 113:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7572; /* pred_umodv4si_scalar */

    case 114:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7577; /* pred_umodv8si_scalar */

    case 115:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7582; /* pred_umodv16si_scalar */

    case 116:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7587; /* pred_umodv32si_scalar */

    case 117:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7592; /* pred_umodv64si_scalar */

    case 118:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7597; /* pred_umodv128si_scalar */

    case 119:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7602; /* pred_umodv256si_scalar */

    case 120:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7607; /* pred_umodv512si_scalar */

    case 121:
      if (!(
#line 2802 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7612; /* pred_umodv1024si_scalar */

    case 122:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7923; /* *pred_umodrvvm8di_scalar */

    case 123:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7928; /* *pred_umodrvvm4di_scalar */

    case 124:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7933; /* *pred_umodrvvm2di_scalar */

    case 125:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7938; /* *pred_umodrvvm1di_scalar */

    case 126:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7943; /* *pred_umodv1di_scalar */

    case 127:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7948; /* *pred_umodv2di_scalar */

    case 128:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7953; /* *pred_umodv4di_scalar */

    case 129:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7958; /* *pred_umodv8di_scalar */

    case 130:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7963; /* *pred_umodv16di_scalar */

    case 131:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7968; /* *pred_umodv32di_scalar */

    case 132:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7973; /* *pred_umodv64di_scalar */

    case 133:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7978; /* *pred_umodv128di_scalar */

    case 134:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7983; /* *pred_umodv256di_scalar */

    case 135:
      if (!(
#line 2955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7988; /* *pred_umodv512di_scalar */

    case 136:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7993; /* *pred_umodrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7998; /* *pred_umodrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8003; /* *pred_umodrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8008; /* *pred_umodrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8013; /* *pred_umodv1di_extended_scalar */

    case 141:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8018; /* *pred_umodv2di_extended_scalar */

    case 142:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8023; /* *pred_umodv4di_extended_scalar */

    case 143:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8028; /* *pred_umodv8di_extended_scalar */

    case 144:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8033; /* *pred_umodv16di_extended_scalar */

    case 145:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8038; /* *pred_umodv32di_extended_scalar */

    case 146:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8043; /* *pred_umodv64di_extended_scalar */

    case 147:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8048; /* *pred_umodv128di_extended_scalar */

    case 148:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8053; /* *pred_umodv256di_extended_scalar */

    case 149:
      if (!(
#line 2977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8058; /* *pred_umodv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_909 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10888; /* pred_ussubrvvm8qi */

        case 1:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10892; /* pred_ussubrvvm4qi */

        case 2:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10896; /* pred_ussubrvvm2qi */

        case 3:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10900; /* pred_ussubrvvm1qi */

        case 4:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10904; /* pred_ussubrvvm8hi */

        case 5:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10908; /* pred_ussubrvvm4hi */

        case 6:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10912; /* pred_ussubrvvm2hi */

        case 7:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10916; /* pred_ussubrvvm1hi */

        case 8:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10920; /* pred_ussubrvvm8si */

        case 9:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10924; /* pred_ussubrvvm4si */

        case 10:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10928; /* pred_ussubrvvm2si */

        case 11:
          if (!
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10932; /* pred_ussubrvvm1si */

        case 12:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10936; /* pred_ussubrvvm8di */

        case 13:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10940; /* pred_ussubrvvm4di */

        case 14:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10944; /* pred_ussubrvvm2di */

        case 15:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10948; /* pred_ussubrvvm1di */

        case 16:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10952; /* pred_ussubrvvmf2qi */

        case 17:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10956; /* pred_ussubrvvmf4qi */

        case 18:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10960; /* pred_ussubrvvmf8qi */

        case 19:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10964; /* pred_ussubrvvmf2hi */

        case 20:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10968; /* pred_ussubrvvmf4hi */

        case 21:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10972; /* pred_ussubrvvmf2si */

        case 22:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 10976; /* pred_ussubv1qi */

        case 23:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 10980; /* pred_ussubv2qi */

        case 24:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 10984; /* pred_ussubv4qi */

        case 25:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 10988; /* pred_ussubv8qi */

        case 26:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 10992; /* pred_ussubv16qi */

        case 27:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 10996; /* pred_ussubv32qi */

        case 28:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11000; /* pred_ussubv64qi */

        case 29:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11004; /* pred_ussubv128qi */

        case 30:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11008; /* pred_ussubv256qi */

        case 31:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11012; /* pred_ussubv512qi */

        case 32:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11016; /* pred_ussubv1024qi */

        case 33:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11020; /* pred_ussubv2048qi */

        case 34:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11024; /* pred_ussubv4096qi */

        case 35:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11028; /* pred_ussubv1hi */

        case 36:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11032; /* pred_ussubv2hi */

        case 37:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11036; /* pred_ussubv4hi */

        case 38:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11040; /* pred_ussubv8hi */

        case 39:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11044; /* pred_ussubv16hi */

        case 40:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11048; /* pred_ussubv32hi */

        case 41:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11052; /* pred_ussubv64hi */

        case 42:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11056; /* pred_ussubv128hi */

        case 43:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11060; /* pred_ussubv256hi */

        case 44:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11064; /* pred_ussubv512hi */

        case 45:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11068; /* pred_ussubv1024hi */

        case 46:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11072; /* pred_ussubv2048hi */

        case 47:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11076; /* pred_ussubv1si */

        case 48:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11080; /* pred_ussubv2si */

        case 49:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11084; /* pred_ussubv4si */

        case 50:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11088; /* pred_ussubv8si */

        case 51:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11092; /* pred_ussubv16si */

        case 52:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11096; /* pred_ussubv32si */

        case 53:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11100; /* pred_ussubv64si */

        case 54:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11104; /* pred_ussubv128si */

        case 55:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11108; /* pred_ussubv256si */

        case 56:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11112; /* pred_ussubv512si */

        case 57:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11116; /* pred_ussubv1024si */

        case 58:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11120; /* pred_ussubv1di */

        case 59:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11124; /* pred_ussubv2di */

        case 60:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11128; /* pred_ussubv4di */

        case 61:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11132; /* pred_ussubv8di */

        case 62:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11136; /* pred_ussubv16di */

        case 63:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11140; /* pred_ussubv32di */

        case 64:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11144; /* pred_ussubv64di */

        case 65:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11148; /* pred_ussubv128di */

        case 66:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11152; /* pred_ussubv256di */

        case 67:
          if (!(
#line 4328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11156; /* pred_ussubv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern605 (x2))
        {
        case 0:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11266; /* pred_ussubrvvm8qi_scalar */

        case 1:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11268; /* pred_ussubrvvm4qi_scalar */

        case 2:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11270; /* pred_ussubrvvm2qi_scalar */

        case 3:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11272; /* pred_ussubrvvm1qi_scalar */

        case 4:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11274; /* pred_ussubrvvmf2qi_scalar */

        case 5:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11276; /* pred_ussubrvvmf4qi_scalar */

        case 6:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11278; /* pred_ussubrvvmf8qi_scalar */

        case 7:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11280; /* pred_ussubrvvm8hi_scalar */

        case 8:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11282; /* pred_ussubrvvm4hi_scalar */

        case 9:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11284; /* pred_ussubrvvm2hi_scalar */

        case 10:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11286; /* pred_ussubrvvm1hi_scalar */

        case 11:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11288; /* pred_ussubrvvmf2hi_scalar */

        case 12:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11290; /* pred_ussubrvvmf4hi_scalar */

        case 13:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11292; /* pred_ussubrvvm8si_scalar */

        case 14:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11294; /* pred_ussubrvvm4si_scalar */

        case 15:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11296; /* pred_ussubrvvm2si_scalar */

        case 16:
          if (!
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11298; /* pred_ussubrvvm1si_scalar */

        case 17:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11300; /* pred_ussubrvvmf2si_scalar */

        case 18:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 11302; /* pred_ussubv1qi_scalar */

        case 19:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 11304; /* pred_ussubv2qi_scalar */

        case 20:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 11306; /* pred_ussubv4qi_scalar */

        case 21:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 11308; /* pred_ussubv8qi_scalar */

        case 22:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 11310; /* pred_ussubv16qi_scalar */

        case 23:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 11312; /* pred_ussubv32qi_scalar */

        case 24:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11314; /* pred_ussubv64qi_scalar */

        case 25:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11316; /* pred_ussubv128qi_scalar */

        case 26:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11318; /* pred_ussubv256qi_scalar */

        case 27:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11320; /* pred_ussubv512qi_scalar */

        case 28:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11322; /* pred_ussubv1024qi_scalar */

        case 29:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11324; /* pred_ussubv2048qi_scalar */

        case 30:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11326; /* pred_ussubv4096qi_scalar */

        case 31:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11328; /* pred_ussubv1hi_scalar */

        case 32:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11330; /* pred_ussubv2hi_scalar */

        case 33:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11332; /* pred_ussubv4hi_scalar */

        case 34:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11334; /* pred_ussubv8hi_scalar */

        case 35:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11336; /* pred_ussubv16hi_scalar */

        case 36:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11338; /* pred_ussubv32hi_scalar */

        case 37:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11340; /* pred_ussubv64hi_scalar */

        case 38:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11342; /* pred_ussubv128hi_scalar */

        case 39:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11344; /* pred_ussubv256hi_scalar */

        case 40:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11346; /* pred_ussubv512hi_scalar */

        case 41:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11348; /* pred_ussubv1024hi_scalar */

        case 42:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11350; /* pred_ussubv2048hi_scalar */

        case 43:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11352; /* pred_ussubv1si_scalar */

        case 44:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11354; /* pred_ussubv2si_scalar */

        case 45:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11356; /* pred_ussubv4si_scalar */

        case 46:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11358; /* pred_ussubv8si_scalar */

        case 47:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11360; /* pred_ussubv16si_scalar */

        case 48:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11362; /* pred_ussubv32si_scalar */

        case 49:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11364; /* pred_ussubv64si_scalar */

        case 50:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11366; /* pred_ussubv128si_scalar */

        case 51:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11368; /* pred_ussubv256si_scalar */

        case 52:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11370; /* pred_ussubv512si_scalar */

        case 53:
          if (!(
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11372; /* pred_ussubv1024si_scalar */

        case 54:
          if (!(
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11390; /* *pred_ussubrvvm8di_scalar */

        case 55:
          if (!(
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11392; /* *pred_ussubrvvm4di_scalar */

        case 56:
          if (!(
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11394; /* *pred_ussubrvvm2di_scalar */

        case 57:
          if (!(
#line 4509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11396; /* *pred_ussubrvvm1di_scalar */

        case 58:
          if (!(
#line 4531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11398; /* *pred_ussubrvvm8di_extended_scalar */

        case 59:
          if (!(
#line 4531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11400; /* *pred_ussubrvvm4di_extended_scalar */

        case 60:
          if (!(
#line 4531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11402; /* *pred_ussubrvvm2di_extended_scalar */

        case 61:
          if (!(
#line 4531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11404; /* *pred_ussubrvvm1di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_921 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x3;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 4);
      operands[7] = x8;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      return recog_413 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 4);
      operands[7] = x8;
      x10 = XEXP (x3, 0);
      operands[3] = x10;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      res = recog_414 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern687 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4217; /* *pred_broadcastrvvm8di_extended_scalar */

        case E_RVVM4DImode:
          if (pattern687 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4218; /* *pred_broadcastrvvm4di_extended_scalar */

        case E_RVVM2DImode:
          if (pattern687 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4219; /* *pred_broadcastrvvm2di_extended_scalar */

        case E_RVVM1DImode:
          if (pattern687 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4220; /* *pred_broadcastrvvm1di_extended_scalar */

        case E_V1DImode:
          if (pattern687 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4221; /* *pred_broadcastv1di_extended_scalar */

        case E_V2DImode:
          if (pattern687 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4222; /* *pred_broadcastv2di_extended_scalar */

        case E_V4DImode:
          if (pattern687 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 4223; /* *pred_broadcastv4di_extended_scalar */

        case E_V8DImode:
          if (pattern687 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 4224; /* *pred_broadcastv8di_extended_scalar */

        case E_V16DImode:
          if (pattern687 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 4225; /* *pred_broadcastv16di_extended_scalar */

        case E_V32DImode:
          if (pattern687 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 4226; /* *pred_broadcastv32di_extended_scalar */

        case E_V64DImode:
          if (pattern687 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 4227; /* *pred_broadcastv64di_extended_scalar */

        case E_V128DImode:
          if (pattern687 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 4228; /* *pred_broadcastv128di_extended_scalar */

        case E_V256DImode:
          if (pattern687 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 4229; /* *pred_broadcastv256di_extended_scalar */

        case E_V512DImode:
          if (pattern687 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 2318 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 4230; /* *pred_broadcastv512di_extended_scalar */

        default:
          return -1;
        }

    case CONST_VECTOR:
      return recog_892 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_894 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_895 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_893 (x1, insn, pnum_clobbers);

    case AND:
      return recog_898 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_905 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_906 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_891 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_888 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_887 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_889 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_904 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_890 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_903 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_897 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_901 (x1, insn, pnum_clobbers);

    case UDIV:
      return recog_900 (x1, insn, pnum_clobbers);

    case MOD:
      return recog_902 (x1, insn, pnum_clobbers);

    case UMOD:
      return recog_899 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_919 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_908 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_917 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_916 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_915 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_911 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_920 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_910 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_909 (x1, insn, pnum_clobbers);

    case VEC_SERIES:
      return recog_907 (x1, insn, pnum_clobbers);

    case ABS:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 4);
      operands[7] = x8;
      switch (pattern575 (x2))
        {
        case 0:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16263; /* pred_absrvvm8hf */

        case 1:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16265; /* pred_absrvvm4hf */

        case 2:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16267; /* pred_absrvvm2hf */

        case 3:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16269; /* pred_absrvvm1hf */

        case 4:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16271; /* pred_absrvvmf2hf */

        case 5:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16273; /* pred_absrvvmf4hf */

        case 6:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16275; /* pred_absrvvm8sf */

        case 7:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16277; /* pred_absrvvm4sf */

        case 8:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16279; /* pred_absrvvm2sf */

        case 9:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16281; /* pred_absrvvm1sf */

        case 10:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16283; /* pred_absrvvmf2sf */

        case 11:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16285; /* pred_absrvvm8df */

        case 12:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16287; /* pred_absrvvm4df */

        case 13:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16289; /* pred_absrvvm2df */

        case 14:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16291; /* pred_absrvvm1df */

        case 15:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 16293; /* pred_absv1hf */

        case 16:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 16295; /* pred_absv2hf */

        case 17:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 16297; /* pred_absv4hf */

        case 18:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 16299; /* pred_absv8hf */

        case 19:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 16301; /* pred_absv16hf */

        case 20:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16303; /* pred_absv32hf */

        case 21:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16305; /* pred_absv64hf */

        case 22:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16307; /* pred_absv128hf */

        case 23:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16309; /* pred_absv256hf */

        case 24:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16311; /* pred_absv512hf */

        case 25:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16313; /* pred_absv1024hf */

        case 26:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16315; /* pred_absv2048hf */

        case 27:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16317; /* pred_absv1sf */

        case 28:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16319; /* pred_absv2sf */

        case 29:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16321; /* pred_absv4sf */

        case 30:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16323; /* pred_absv8sf */

        case 31:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16325; /* pred_absv16sf */

        case 32:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16327; /* pred_absv32sf */

        case 33:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16329; /* pred_absv64sf */

        case 34:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16331; /* pred_absv128sf */

        case 35:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16333; /* pred_absv256sf */

        case 36:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16335; /* pred_absv512sf */

        case 37:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16337; /* pred_absv1024sf */

        case 38:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16339; /* pred_absv1df */

        case 39:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16341; /* pred_absv2df */

        case 40:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16343; /* pred_absv4df */

        case 41:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16345; /* pred_absv8df */

        case 42:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16347; /* pred_absv16df */

        case 43:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16349; /* pred_absv32df */

        case 44:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16351; /* pred_absv64df */

        case 45:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16353; /* pred_absv128df */

        case 46:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16355; /* pred_absv256df */

        case 47:
          if (!(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16357; /* pred_absv512df */

        default:
          return -1;
        }

    case FIX:
      return recog_912 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_913 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern508 (x2))
        {
        case 0:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17687; /* pred_widen_floatrvvm8hf */

        case 1:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17689; /* pred_widen_floatrvvm4hf */

        case 2:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17691; /* pred_widen_floatrvvm2hf */

        case 3:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17693; /* pred_widen_floatrvvm1hf */

        case 4:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17695; /* pred_widen_floatrvvmf2hf */

        case 5:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17697; /* pred_widen_floatrvvmf4hf */

        case 6:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17699; /* pred_widen_floatrvvm8sf */

        case 7:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17701; /* pred_widen_floatrvvm4sf */

        case 8:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17703; /* pred_widen_floatrvvm2sf */

        case 9:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17705; /* pred_widen_floatrvvm1sf */

        case 10:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17707; /* pred_widen_floatrvvmf2sf */

        case 11:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17709; /* pred_widen_floatrvvm8df */

        case 12:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17711; /* pred_widen_floatrvvm4df */

        case 13:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17713; /* pred_widen_floatrvvm2df */

        case 14:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17715; /* pred_widen_floatrvvm1df */

        case 15:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17717; /* pred_widen_floatv1hf */

        case 16:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17719; /* pred_widen_floatv2hf */

        case 17:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17721; /* pred_widen_floatv4hf */

        case 18:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 17723; /* pred_widen_floatv8hf */

        case 19:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 17725; /* pred_widen_floatv16hf */

        case 20:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17727; /* pred_widen_floatv32hf */

        case 21:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17729; /* pred_widen_floatv64hf */

        case 22:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17731; /* pred_widen_floatv128hf */

        case 23:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17733; /* pred_widen_floatv256hf */

        case 24:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17735; /* pred_widen_floatv512hf */

        case 25:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17737; /* pred_widen_floatv1024hf */

        case 26:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17739; /* pred_widen_floatv2048hf */

        case 27:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17741; /* pred_widen_floatv1sf */

        case 28:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17743; /* pred_widen_floatv2sf */

        case 29:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17745; /* pred_widen_floatv4sf */

        case 30:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17747; /* pred_widen_floatv8sf */

        case 31:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17749; /* pred_widen_floatv16sf */

        case 32:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17751; /* pred_widen_floatv32sf */

        case 33:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17753; /* pred_widen_floatv64sf */

        case 34:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17755; /* pred_widen_floatv128sf */

        case 35:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17757; /* pred_widen_floatv256sf */

        case 36:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17759; /* pred_widen_floatv512sf */

        case 37:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17761; /* pred_widen_floatv1024sf */

        case 38:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17763; /* pred_widen_floatv1df */

        case 39:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17765; /* pred_widen_floatv2df */

        case 40:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17767; /* pred_widen_floatv4df */

        case 41:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17769; /* pred_widen_floatv8df */

        case 42:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17771; /* pred_widen_floatv16df */

        case 43:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17773; /* pred_widen_floatv32df */

        case 44:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17775; /* pred_widen_floatv64df */

        case 45:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17777; /* pred_widen_floatv128df */

        case 46:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17779; /* pred_widen_floatv256df */

        case 47:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17781; /* pred_widen_floatv512df */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern508 (x2))
        {
        case 0:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17688; /* pred_widen_floatunsrvvm8hf */

        case 1:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17690; /* pred_widen_floatunsrvvm4hf */

        case 2:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17692; /* pred_widen_floatunsrvvm2hf */

        case 3:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17694; /* pred_widen_floatunsrvvm1hf */

        case 4:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17696; /* pred_widen_floatunsrvvmf2hf */

        case 5:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17698; /* pred_widen_floatunsrvvmf4hf */

        case 6:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17700; /* pred_widen_floatunsrvvm8sf */

        case 7:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17702; /* pred_widen_floatunsrvvm4sf */

        case 8:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17704; /* pred_widen_floatunsrvvm2sf */

        case 9:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17706; /* pred_widen_floatunsrvvm1sf */

        case 10:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17708; /* pred_widen_floatunsrvvmf2sf */

        case 11:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17710; /* pred_widen_floatunsrvvm8df */

        case 12:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17712; /* pred_widen_floatunsrvvm4df */

        case 13:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17714; /* pred_widen_floatunsrvvm2df */

        case 14:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17716; /* pred_widen_floatunsrvvm1df */

        case 15:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17718; /* pred_widen_floatunsv1hf */

        case 16:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17720; /* pred_widen_floatunsv2hf */

        case 17:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17722; /* pred_widen_floatunsv4hf */

        case 18:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 17724; /* pred_widen_floatunsv8hf */

        case 19:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 17726; /* pred_widen_floatunsv16hf */

        case 20:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17728; /* pred_widen_floatunsv32hf */

        case 21:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17730; /* pred_widen_floatunsv64hf */

        case 22:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17732; /* pred_widen_floatunsv128hf */

        case 23:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17734; /* pred_widen_floatunsv256hf */

        case 24:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17736; /* pred_widen_floatunsv512hf */

        case 25:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17738; /* pred_widen_floatunsv1024hf */

        case 26:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17740; /* pred_widen_floatunsv2048hf */

        case 27:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17742; /* pred_widen_floatunsv1sf */

        case 28:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17744; /* pred_widen_floatunsv2sf */

        case 29:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17746; /* pred_widen_floatunsv4sf */

        case 30:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17748; /* pred_widen_floatunsv8sf */

        case 31:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17750; /* pred_widen_floatunsv16sf */

        case 32:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17752; /* pred_widen_floatunsv32sf */

        case 33:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17754; /* pred_widen_floatunsv64sf */

        case 34:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17756; /* pred_widen_floatunsv128sf */

        case 35:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17758; /* pred_widen_floatunsv256sf */

        case 36:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17760; /* pred_widen_floatunsv512sf */

        case 37:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17762; /* pred_widen_floatunsv1024sf */

        case 38:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17764; /* pred_widen_floatunsv1df */

        case 39:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17766; /* pred_widen_floatunsv2df */

        case 40:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17768; /* pred_widen_floatunsv4df */

        case 41:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17770; /* pred_widen_floatunsv8df */

        case 42:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17772; /* pred_widen_floatunsv16df */

        case 43:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17774; /* pred_widen_floatunsv32df */

        case 44:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17776; /* pred_widen_floatunsv64df */

        case 45:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17778; /* pred_widen_floatunsv128df */

        case 46:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17780; /* pred_widen_floatunsv256df */

        case 47:
          if (!(
#line 7608 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17782; /* pred_widen_floatunsv512df */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_918 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_914 (x1, insn, pnum_clobbers);

    case ROTATERT:
      return recog_896 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_939 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15254; /* *pred_mul_addrvvm8hf_undef */
}

 int
recog_940 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15256; /* *pred_mul_addrvvm4hf_undef */
}

 int
recog_942 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15260; /* *pred_mul_addrvvm1hf_undef */
}

 int
recog_945 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15266; /* *pred_mul_addrvvm8sf_undef */
}

 int
recog_950 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15276; /* *pred_mul_addrvvm8df_undef */
}

 int
recog_955 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15286; /* *pred_mul_addv2hf_undef */
}

 int
recog_960 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15296; /* *pred_mul_addv64hf_undef */
}

 int
recog_965 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15306; /* *pred_mul_addv2048hf_undef */
}

 int
recog_970 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15316; /* *pred_mul_addv16sf_undef */
}

 int
recog_975 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15326; /* *pred_mul_addv512sf_undef */
}

 int
recog_980 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15336; /* *pred_mul_addv8df_undef */
}

 int
recog_985 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15346; /* *pred_mul_addv256df_undef */
}

 int
recog_990 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16765; /* pred_widen_mul_addrvvm4sf_scalar */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33778; /* pred_widen_bf16_mul_rvvm4sf_scalar */

    default:
      return -1;
    }
}

 int
recog_995 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16705; /* pred_widen_mul_addrvvm4sf */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 101 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33773; /* pred_widen_bf16_mul_rvvm4sf */

    default:
      return -1;
    }
}

 int
recog_1000 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_983 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15438; /* *pred_maddv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15534; /* *pred_maccv64df */
}

 int
recog_1005 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_978 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15428; /* *pred_maddv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15524; /* *pred_maccv2df */
}

 int
recog_1010 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_973 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15418; /* *pred_maddv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15514; /* *pred_maccv128sf */
}

 int
recog_1015 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_968 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15408; /* *pred_maddv4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15504; /* *pred_maccv4sf */
}

 int
recog_1020 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_963 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15398; /* *pred_maddv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15494; /* *pred_maccv512hf */
}

 int
recog_1025 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_958 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15388; /* *pred_maddv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15484; /* *pred_maccv16hf */
}

 int
recog_1031 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_952 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15376; /* *pred_maddrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15472; /* *pred_maccrvvm2df */
}

 int
recog_1037 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_946 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15364; /* *pred_maddrvvm4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15460; /* *pred_maccrvvm4sf */
}

 int
recog_1043 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_940 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15352; /* *pred_maddrvvm4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15448; /* *pred_maccrvvm4hf */
}

 int
recog_1050 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15744; /* *pred_mul_neg_addrvvmf4hf_undef */
}

 int
recog_1060 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15764; /* *pred_mul_neg_addv1hf_undef */
}

 int
recog_1068 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15780; /* *pred_mul_neg_addv256hf_undef */
}

 int
recog_1077 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15798; /* *pred_mul_neg_addv32sf_undef */
}

 int
recog_1086 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15816; /* *pred_mul_neg_addv8df_undef */
}

 int
recog_1095 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1090 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15920; /* *pred_nmsubv128df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 16016; /* *pred_nmsacv128df */
}

 int
recog_1105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1080 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 15900; /* *pred_nmsubv256sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15996; /* *pred_nmsacv256sf */
}

 int
recog_1115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1070 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15880; /* *pred_nmsubv1024hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15976; /* *pred_nmsacv1024hf */
}

 int
recog_1125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1060 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15860; /* *pred_nmsubv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15956; /* *pred_nmsacv1hf */
}

 int
recog_1135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1050 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15840; /* *pred_nmsubrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15936; /* *pred_nmsacrvvmf4hf */
}

 int
recog_1145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15257; /* *pred_mul_subrvvm4hf_undef */
}

 int
recog_1152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15271; /* *pred_mul_subrvvm2sf_undef */
}

 int
recog_1159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15285; /* *pred_mul_subv1hf_undef */
}

 int
recog_1166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15299; /* *pred_mul_subv128hf_undef */
}

 int
recog_1173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15313; /* *pred_mul_subv4sf_undef */
}

 int
recog_1180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15327; /* *pred_mul_subv512sf_undef */
}

 int
recog_1187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15341; /* *pred_mul_subv32df_undef */
}

 int
recog_1194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1189 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15441; /* *pred_msubv128df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15537; /* *pred_msacv128df */
}

 int
recog_1201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1182 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15427; /* *pred_msubv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15523; /* *pred_msacv1df */
}

 int
recog_1208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1175 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15413; /* *pred_msubv16sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15509; /* *pred_msacv16sf */
}

 int
recog_1215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1168 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15399; /* *pred_msubv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15495; /* *pred_msacv512hf */
}

 int
recog_1222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1161 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15385; /* *pred_msubv4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15481; /* *pred_msacv4hf */
}

 int
recog_1229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1154 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return 15371; /* *pred_msubrvvmf2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15467; /* *pred_msacrvvmf2sf */
}

 int
recog_1236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1147 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15357; /* *pred_msubrvvm1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15453; /* *pred_msacrvvm1hf */
}

 int
recog_1243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15741; /* *pred_mul_neg_subrvvm1hf_undef */
}

 int
recog_1250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15755; /* *pred_mul_neg_subrvvmf2sf_undef */
}

 int
recog_1257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15769; /* *pred_mul_neg_subv4hf_undef */
}

 int
recog_1264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15783; /* *pred_mul_neg_subv512hf_undef */
}

 int
recog_1271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15797; /* *pred_mul_neg_subv16sf_undef */
}

 int
recog_1278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15811; /* *pred_mul_neg_subv1df_undef */
}

 int
recog_1285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15825; /* *pred_mul_neg_subv128df_undef */
}

 int
recog_1292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1283 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15917; /* *pred_nmaddv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 16013; /* *pred_nmaccv32df */
}

 int
recog_1299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1276 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15903; /* *pred_nmaddv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15999; /* *pred_nmaccv512sf */
}

 int
recog_1306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1269 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15889; /* *pred_nmaddv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15985; /* *pred_nmaccv4sf */
}

 int
recog_1313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1262 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15875; /* *pred_nmaddv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15971; /* *pred_nmaccv128hf */
}

 int
recog_1320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1255 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15861; /* *pred_nmaddv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15957; /* *pred_nmaccv1hf */
}

 int
recog_1329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1246 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15843; /* *pred_nmaddrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15939; /* *pred_nmaccrvvm8sf */
}

 int
recog_1337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern588 (x2))
    {
    case 0:
      return recog_1335 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1334 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1333 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1332 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1331 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1330 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1329 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1328 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1327 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1326 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1325 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1324 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1323 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1322 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1321 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1320 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1319 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1318 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1317 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1316 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1315 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1314 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1313 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1312 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1311 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1310 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1309 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1308 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1307 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1306 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1305 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1304 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1303 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1302 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1301 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1300 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1299 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1298 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1297 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1296 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1295 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1294 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1293 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1292 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1291 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1290 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1289 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1288 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16023; /* *pred_nmaddrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16119; /* *pred_nmaccrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16025; /* *pred_nmaddrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16121; /* *pred_nmaccrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16027; /* *pred_nmaddrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16123; /* *pred_nmaccrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16029; /* *pred_nmaddrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16125; /* *pred_nmaccrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16031; /* *pred_nmaddrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16127; /* *pred_nmaccrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return 16033; /* *pred_nmaddrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16129; /* *pred_nmaccrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16035; /* *pred_nmaddrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16131; /* *pred_nmaccrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16037; /* *pred_nmaddrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16133; /* *pred_nmaccrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16039; /* *pred_nmaddrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16135; /* *pred_nmaccrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16041; /* *pred_nmaddrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16137; /* *pred_nmaccrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return 16043; /* *pred_nmaddrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16139; /* *pred_nmaccrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16045; /* *pred_nmaddrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16141; /* *pred_nmaccrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16047; /* *pred_nmaddrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16143; /* *pred_nmaccrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16049; /* *pred_nmaddrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16145; /* *pred_nmaccrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16051; /* *pred_nmaddrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16147; /* *pred_nmaccrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 16053; /* *pred_nmaddv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16149; /* *pred_nmaccv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 16055; /* *pred_nmaddv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16151; /* *pred_nmaccv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 16057; /* *pred_nmaddv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16153; /* *pred_nmaccv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 16059; /* *pred_nmaddv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16155; /* *pred_nmaccv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 16061; /* *pred_nmaddv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16157; /* *pred_nmaccv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 16063; /* *pred_nmaddv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16159; /* *pred_nmaccv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 16065; /* *pred_nmaddv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16161; /* *pred_nmaccv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 16067; /* *pred_nmaddv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16163; /* *pred_nmaccv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 16069; /* *pred_nmaddv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16165; /* *pred_nmaccv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 16071; /* *pred_nmaddv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16167; /* *pred_nmaccv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 16073; /* *pred_nmaddv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16169; /* *pred_nmaccv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 16075; /* *pred_nmaddv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16171; /* *pred_nmaccv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16077; /* *pred_nmaddv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16173; /* *pred_nmaccv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16079; /* *pred_nmaddv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16175; /* *pred_nmaccv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16081; /* *pred_nmaddv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16177; /* *pred_nmaccv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16083; /* *pred_nmaddv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16179; /* *pred_nmaccv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 16085; /* *pred_nmaddv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16181; /* *pred_nmaccv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 16087; /* *pred_nmaddv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16183; /* *pred_nmaccv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 16089; /* *pred_nmaddv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16185; /* *pred_nmaccv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 16091; /* *pred_nmaddv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16187; /* *pred_nmaccv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 16093; /* *pred_nmaddv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16189; /* *pred_nmaccv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 16095; /* *pred_nmaddv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16191; /* *pred_nmaccv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 16097; /* *pred_nmaddv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16193; /* *pred_nmaccv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16099; /* *pred_nmaddv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16195; /* *pred_nmaccv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16101; /* *pred_nmaddv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16197; /* *pred_nmaccv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16103; /* *pred_nmaddv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16199; /* *pred_nmaccv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 16105; /* *pred_nmaddv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16201; /* *pred_nmaccv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 16107; /* *pred_nmaddv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16203; /* *pred_nmaccv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 16109; /* *pred_nmaddv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16205; /* *pred_nmaccv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 16111; /* *pred_nmaddv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16207; /* *pred_nmaccv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 16113; /* *pred_nmaddv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16209; /* *pred_nmaccv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 16115; /* *pred_nmaddv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16211; /* *pred_nmaccv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 16117; /* *pred_nmaddv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16213; /* *pred_nmaccv512df_scalar */

    case 96:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16824; /* pred_widen_mul_neg_subrvvm8sf */

    case 97:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16826; /* pred_widen_mul_neg_subrvvm4sf */

    case 98:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16828; /* pred_widen_mul_neg_subrvvm2sf */

    case 99:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16830; /* pred_widen_mul_neg_subrvvm1sf */

    case 100:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16832; /* pred_widen_mul_neg_subrvvmf2sf */

    case 101:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16834; /* pred_widen_mul_neg_subrvvm8df */

    case 102:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16836; /* pred_widen_mul_neg_subrvvm4df */

    case 103:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16838; /* pred_widen_mul_neg_subrvvm2df */

    case 104:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16840; /* pred_widen_mul_neg_subrvvm1df */

    case 105:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16842; /* pred_widen_mul_neg_subv1sf */

    case 106:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16844; /* pred_widen_mul_neg_subv2sf */

    case 107:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16846; /* pred_widen_mul_neg_subv4sf */

    case 108:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16848; /* pred_widen_mul_neg_subv8sf */

    case 109:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16850; /* pred_widen_mul_neg_subv16sf */

    case 110:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16852; /* pred_widen_mul_neg_subv32sf */

    case 111:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16854; /* pred_widen_mul_neg_subv64sf */

    case 112:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16856; /* pred_widen_mul_neg_subv128sf */

    case 113:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16858; /* pred_widen_mul_neg_subv256sf */

    case 114:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16860; /* pred_widen_mul_neg_subv512sf */

    case 115:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16862; /* pred_widen_mul_neg_subv1024sf */

    case 116:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16864; /* pred_widen_mul_neg_subv1df */

    case 117:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16866; /* pred_widen_mul_neg_subv2df */

    case 118:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16868; /* pred_widen_mul_neg_subv4df */

    case 119:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16870; /* pred_widen_mul_neg_subv8df */

    case 120:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16872; /* pred_widen_mul_neg_subv16df */

    case 121:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16874; /* pred_widen_mul_neg_subv32df */

    case 122:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16876; /* pred_widen_mul_neg_subv64df */

    case 123:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16878; /* pred_widen_mul_neg_subv128df */

    case 124:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16880; /* pred_widen_mul_neg_subv256df */

    case 125:
      if (!(
#line 7234 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16882; /* pred_widen_mul_neg_subv512df */

    case 126:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16884; /* pred_widen_mul_neg_subrvvm8sf_scalar */

    case 127:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16886; /* pred_widen_mul_neg_subrvvm4sf_scalar */

    case 128:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16888; /* pred_widen_mul_neg_subrvvm2sf_scalar */

    case 129:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16890; /* pred_widen_mul_neg_subrvvm1sf_scalar */

    case 130:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16892; /* pred_widen_mul_neg_subrvvmf2sf_scalar */

    case 131:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16894; /* pred_widen_mul_neg_subrvvm8df_scalar */

    case 132:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16896; /* pred_widen_mul_neg_subrvvm4df_scalar */

    case 133:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16898; /* pred_widen_mul_neg_subrvvm2df_scalar */

    case 134:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16900; /* pred_widen_mul_neg_subrvvm1df_scalar */

    case 135:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16902; /* pred_widen_mul_neg_subv1sf_scalar */

    case 136:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16904; /* pred_widen_mul_neg_subv2sf_scalar */

    case 137:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16906; /* pred_widen_mul_neg_subv4sf_scalar */

    case 138:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16908; /* pred_widen_mul_neg_subv8sf_scalar */

    case 139:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16910; /* pred_widen_mul_neg_subv16sf_scalar */

    case 140:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16912; /* pred_widen_mul_neg_subv32sf_scalar */

    case 141:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16914; /* pred_widen_mul_neg_subv64sf_scalar */

    case 142:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16916; /* pred_widen_mul_neg_subv128sf_scalar */

    case 143:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16918; /* pred_widen_mul_neg_subv256sf_scalar */

    case 144:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16920; /* pred_widen_mul_neg_subv512sf_scalar */

    case 145:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16922; /* pred_widen_mul_neg_subv1024sf_scalar */

    case 146:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16924; /* pred_widen_mul_neg_subv1df_scalar */

    case 147:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16926; /* pred_widen_mul_neg_subv2df_scalar */

    case 148:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16928; /* pred_widen_mul_neg_subv4df_scalar */

    case 149:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16930; /* pred_widen_mul_neg_subv8df_scalar */

    case 150:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16932; /* pred_widen_mul_neg_subv16df_scalar */

    case 151:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16934; /* pred_widen_mul_neg_subv32df_scalar */

    case 152:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16936; /* pred_widen_mul_neg_subv64df_scalar */

    case 153:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16938; /* pred_widen_mul_neg_subv128df_scalar */

    case 154:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16940; /* pred_widen_mul_neg_subv256df_scalar */

    case 155:
      if (!(
#line 7264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16942; /* pred_widen_mul_neg_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128QImode:
      if (!register_operand (operands[3], E_V128QImode)
          || !vector_neg_arith_operand (operands[4], E_V128QImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12660; /* *pred_ltgev128qi_merge_tie_mask */

    case E_V128HImode:
      if (!register_operand (operands[3], E_V128HImode)
          || !vector_neg_arith_operand (operands[4], E_V128HImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12673; /* *pred_ltgev128hi_merge_tie_mask */

    case E_V128SImode:
      if (!register_operand (operands[3], E_V128SImode)
          || !vector_neg_arith_operand (operands[4], E_V128SImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12685; /* *pred_ltgev128si_merge_tie_mask */

    case E_V128DImode:
      if (!register_operand (operands[3], E_V128DImode)
          || !vector_neg_arith_operand (operands[4], E_V128DImode)
          || !(
#line 4851 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12696; /* *pred_ltgev128di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1387 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || !vector_neg_arith_operand (operands[5], E_V128QImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12728; /* *pred_ltgev128qi */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12796; /* *pred_ltgev128qi_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || !vector_neg_arith_operand (operands[5], E_V128HImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12741; /* *pred_ltgev128hi */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12809; /* *pred_ltgev128hi_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || !vector_neg_arith_operand (operands[5], E_V128SImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12753; /* *pred_ltgev128si */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12821; /* *pred_ltgev128si_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || !vector_neg_arith_operand (operands[5], E_V128DImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12764; /* *pred_ltgev128di */
      if (!(
#line 4896 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12832; /* *pred_ltgev128di_narrow */

    default:
      return -1;
    }
}

 int
recog_1402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || GET_MODE (x9) != E_RVVM2QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12837; /* *pred_cmprvvm2qi_scalar_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || GET_MODE (x9) != E_RVVM4HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12843; /* *pred_cmprvvm4hi_scalar_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || GET_MODE (x9) != E_RVVM8SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12848; /* *pred_cmprvvm8si_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12855; /* *pred_cmpv4qi_scalar_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12868; /* *pred_cmpv4hi_scalar_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12880; /* *pred_cmpv4si_scalar_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13003; /* *pred_cmpv4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12862; /* *pred_cmpv512qi_scalar_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12875; /* *pred_cmpv512hi_scalar_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12887; /* *pred_cmpv512si_scalar_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13010; /* *pred_cmpv512di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1411 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16QImode:
      if (!register_operand (operands[4], E_V16QImode)
          || GET_MODE (x9) != E_V16QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16QImode)) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 12911; /* *pred_cmpv16qi_scalar */
      if (!(
#line 4982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16QImode)) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12965; /* *pred_cmpv16qi_scalar_narrow */

    case E_V16HImode:
      if (!register_operand (operands[4], E_V16HImode)
          || GET_MODE (x9) != E_V16HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HImode)) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12924; /* *pred_cmpv16hi_scalar */
      if (!(
#line 4982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HImode)) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12978; /* *pred_cmpv16hi_scalar_narrow */

    case E_V16SImode:
      if (!register_operand (operands[4], E_V16SImode)
          || GET_MODE (x9) != E_V16SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SImode)) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12936; /* *pred_cmpv16si_scalar */
      if (!(
#line 4982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SImode)) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12990; /* *pred_cmpv16si_scalar_narrow */

    case E_V16DImode:
      if (!register_operand (operands[4], E_V16DImode)
          || GET_MODE (x9) != E_V16DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode)) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 13019; /* *pred_cmpv16di_scalar */
      if (!(
#line 5092 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode)) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13033; /* *pred_cmpv16di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16992; /* *pred_cmprvvm4hf_narrow_merge_tie_mask */

    case E_RVVM8SFmode:
      if (!register_operand (operands[3], E_RVVM8SFmode)
          || !register_operand (operands[4], E_RVVM8SFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16997; /* *pred_cmprvvm8sf_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[3], E_RVVM1HFmode)
          || !register_operand (operands[4], E_RVVM1HFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16994; /* *pred_cmprvvm1hf_narrow_merge_tie_mask */

    case E_RVVM2SFmode:
      if (!register_operand (operands[3], E_RVVM2SFmode)
          || !register_operand (operands[4], E_RVVM2SFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16999; /* *pred_cmprvvm2sf_narrow_merge_tie_mask */

    case E_RVVM4DFmode:
      if (!register_operand (operands[3], E_RVVM4DFmode)
          || !register_operand (operands[4], E_RVVM4DFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17003; /* *pred_cmprvvm4df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[3], E_V2HFmode)
          || !register_operand (operands[4], E_V2HFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17007; /* *pred_cmpv2hf_narrow_merge_tie_mask */

    case E_V2SFmode:
      if (!register_operand (operands[3], E_V2SFmode)
          || !register_operand (operands[4], E_V2SFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17019; /* *pred_cmpv2sf_narrow_merge_tie_mask */

    case E_V2DFmode:
      if (!register_operand (operands[3], E_V2DFmode)
          || !register_operand (operands[4], E_V2DFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17030; /* *pred_cmpv2df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[3], E_V64HFmode)
          || !register_operand (operands[4], E_V64HFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17012; /* *pred_cmpv64hf_narrow_merge_tie_mask */

    case E_V64SFmode:
      if (!register_operand (operands[3], E_V64SFmode)
          || !register_operand (operands[4], E_V64SFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17024; /* *pred_cmpv64sf_narrow_merge_tie_mask */

    case E_V64DFmode:
      if (!register_operand (operands[3], E_V64DFmode)
          || !register_operand (operands[4], E_V64DFmode)
          || !(
#line 7330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17035; /* *pred_cmpv64df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode)
          || GET_MODE (x9) != E_RVVM4HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17088; /* *pred_cmprvvm4hf_scalar_merge_tie_mask */

    case E_RVVM8SFmode:
      if (!register_operand (operands[3], E_RVVM8SFmode)
          || GET_MODE (x9) != E_RVVM8SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17093; /* *pred_cmprvvm8sf_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[3], E_V1HFmode)
          || GET_MODE (x9) != E_V1HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17102; /* *pred_cmpv1hf_scalar_merge_tie_mask */

    case E_V1SFmode:
      if (!register_operand (operands[3], E_V1SFmode)
          || GET_MODE (x9) != E_V1SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17114; /* *pred_cmpv1sf_scalar_merge_tie_mask */

    case E_V1DFmode:
      if (!register_operand (operands[3], E_V1DFmode)
          || GET_MODE (x9) != E_V1DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17125; /* *pred_cmpv1df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[3], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17107; /* *pred_cmpv32hf_scalar_merge_tie_mask */

    case E_V32SFmode:
      if (!register_operand (operands[3], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17119; /* *pred_cmpv32sf_scalar_merge_tie_mask */

    case E_V32DFmode:
      if (!register_operand (operands[3], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17130; /* *pred_cmpv32df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1461 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[4], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HFmode)) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 17159; /* *pred_cmpv512hf_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HFmode)) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17207; /* *pred_cmpv512hf_scalar_narrow */

    case E_V512SFmode:
      if (!register_operand (operands[4], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SFmode)) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 17171; /* *pred_cmpv512sf_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SFmode)) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17219; /* *pred_cmpv512sf_scalar_narrow */

    case E_V512DFmode:
      if (!register_operand (operands[4], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DFmode)) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 17182; /* *pred_cmpv512df_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DFmode)) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17230; /* *pred_cmpv512df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern625 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) == 0
          && (
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17087; /* *pred_cmprvvm8hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern626 (x2, 
E_RVVMF2BImode, 
E_RVVM8HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HFmode)) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17135; /* *pred_cmprvvm8hf_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HFmode)) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17183; /* *pred_cmprvvm8hf_scalar_narrow */

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1447 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[4], E_RVVM4HFmode)
              || GET_MODE (x9) != E_RVVM4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HFmode)) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17136; /* *pred_cmprvvm4hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HFmode)) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17184; /* *pred_cmprvvm4hf_scalar_narrow */

        case E_RVVM8SFmode:
          if (!register_operand (operands[4], E_RVVM8SFmode)
              || GET_MODE (x9) != E_RVVM8SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SFmode)) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17141; /* *pred_cmprvvm8sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SFmode)) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17189; /* *pred_cmprvvm8sf_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1448 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[4], E_RVVM2HFmode)
              || GET_MODE (x9) != E_RVVM2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HFmode)) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17137; /* *pred_cmprvvm2hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HFmode)) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17185; /* *pred_cmprvvm2hf_scalar_narrow */

        case E_RVVM4SFmode:
          if (!register_operand (operands[4], E_RVVM4SFmode)
              || GET_MODE (x9) != E_RVVM4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SFmode)) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17142; /* *pred_cmprvvm4sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SFmode)) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17190; /* *pred_cmprvvm4sf_scalar_narrow */

        case E_RVVM8DFmode:
          if (!register_operand (operands[4], E_RVVM8DFmode)
              || GET_MODE (x9) != E_RVVM8DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DFmode)) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17146; /* *pred_cmprvvm8df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DFmode)) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17194; /* *pred_cmprvvm8df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1449 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[4], E_RVVM1HFmode)
              || GET_MODE (x9) != E_RVVM1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HFmode)) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17138; /* *pred_cmprvvm1hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HFmode)) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17186; /* *pred_cmprvvm1hf_scalar_narrow */

        case E_RVVM2SFmode:
          if (!register_operand (operands[4], E_RVVM2SFmode)
              || GET_MODE (x9) != E_RVVM2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SFmode)) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17143; /* *pred_cmprvvm2sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SFmode)) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17191; /* *pred_cmprvvm2sf_scalar_narrow */

        case E_RVVM4DFmode:
          if (!register_operand (operands[4], E_RVVM4DFmode)
              || GET_MODE (x9) != E_RVVM4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DFmode)) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17147; /* *pred_cmprvvm4df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DFmode)) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17195; /* *pred_cmprvvm4df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1450 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[4], E_RVVMF2HFmode)
              || GET_MODE (x9) != E_RVVMF2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HFmode)) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17139; /* *pred_cmprvvmf2hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HFmode)) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17187; /* *pred_cmprvvmf2hf_scalar_narrow */

        case E_RVVM1SFmode:
          if (!register_operand (operands[4], E_RVVM1SFmode)
              || GET_MODE (x9) != E_RVVM1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SFmode)) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17144; /* *pred_cmprvvm1sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SFmode)) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17192; /* *pred_cmprvvm1sf_scalar_narrow */

        case E_RVVM2DFmode:
          if (!register_operand (operands[4], E_RVVM2DFmode)
              || GET_MODE (x9) != E_RVVM2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DFmode)) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17148; /* *pred_cmprvvm2df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DFmode)) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17196; /* *pred_cmprvvm2df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1451 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[4], E_RVVMF4HFmode)
              || GET_MODE (x9) != E_RVVMF4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HFmode)) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return 17140; /* *pred_cmprvvmf4hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HFmode)) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17188; /* *pred_cmprvvmf4hf_scalar_narrow */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[4], E_RVVMF2SFmode)
              || GET_MODE (x9) != E_RVVMF2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SFmode)) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return 17145; /* *pred_cmprvvmf2sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SFmode)) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17193; /* *pred_cmprvvmf2sf_scalar_narrow */

        case E_RVVM1DFmode:
          if (!register_operand (operands[4], E_RVVM1DFmode)
              || GET_MODE (x9) != E_RVVM1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DFmode)) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17149; /* *pred_cmprvvm1df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DFmode)) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17197; /* *pred_cmprvvm1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1452 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[4], E_V1HFmode)
              || GET_MODE (x9) != E_V1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HFmode)) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return 17150; /* *pred_cmpv1hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HFmode)) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17198; /* *pred_cmpv1hf_scalar_narrow */

        case E_V1SFmode:
          if (!register_operand (operands[4], E_V1SFmode)
              || GET_MODE (x9) != E_V1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SFmode)) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17162; /* *pred_cmpv1sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SFmode)) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17210; /* *pred_cmpv1sf_scalar_narrow */

        case E_V1DFmode:
          if (!register_operand (operands[4], E_V1DFmode)
              || GET_MODE (x9) != E_V1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DFmode)) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17173; /* *pred_cmpv1df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DFmode)) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17221; /* *pred_cmpv1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1453 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[4], E_V2HFmode)
              || GET_MODE (x9) != E_V2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HFmode)) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return 17151; /* *pred_cmpv2hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HFmode)) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17199; /* *pred_cmpv2hf_scalar_narrow */

        case E_V2SFmode:
          if (!register_operand (operands[4], E_V2SFmode)
              || GET_MODE (x9) != E_V2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SFmode)) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17163; /* *pred_cmpv2sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SFmode)) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17211; /* *pred_cmpv2sf_scalar_narrow */

        case E_V2DFmode:
          if (!register_operand (operands[4], E_V2DFmode)
              || GET_MODE (x9) != E_V2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DFmode)) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17174; /* *pred_cmpv2df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DFmode)) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17222; /* *pred_cmpv2df_scalar_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V4BImode))
        {
          res = recog_1454 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[4], E_V4HFmode)
              || GET_MODE (x9) != E_V4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HFmode)) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return 17152; /* *pred_cmpv4hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HFmode)) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17200; /* *pred_cmpv4hf_scalar_narrow */

        case E_V4SFmode:
          if (!register_operand (operands[4], E_V4SFmode)
              || GET_MODE (x9) != E_V4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SFmode)) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17164; /* *pred_cmpv4sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SFmode)) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17212; /* *pred_cmpv4sf_scalar_narrow */

        case E_V4DFmode:
          if (!register_operand (operands[4], E_V4DFmode)
              || GET_MODE (x9) != E_V4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DFmode)) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17175; /* *pred_cmpv4df_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DFmode)) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17223; /* *pred_cmpv4df_scalar_narrow */

        default:
          return -1;
        }

    case E_V8BImode:
      return recog_1469 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1468 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1467 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1466 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1464 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1465 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1463 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1462 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[4], E_V1024HFmode)
              || GET_MODE (x9) != E_V1024HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HFmode)) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return 17160; /* *pred_cmpv1024hf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HFmode)) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17208; /* *pred_cmpv1024hf_scalar_narrow */

        case E_V1024SFmode:
          if (!register_operand (operands[4], E_V1024SFmode)
              || GET_MODE (x9) != E_V1024SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SFmode)) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return 17172; /* *pred_cmpv1024sf_scalar */
          if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SFmode)) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17220; /* *pred_cmpv1024sf_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern625 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) == 0
          && (
#line 7393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17113; /* *pred_cmpv2048hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern626 (x2, 
E_V2048BImode, 
E_V2048HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HFmode)) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17161; /* *pred_cmpv2048hf_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HFmode)) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17209; /* *pred_cmpv2048hf_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode)
              || !
#line 2007 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN))
            return -1;
          return 134; /* extendhfsf2 */

        case E_BFmode:
          if (!register_operand (operands[1], E_BFmode)
              || !
#line 2016 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZFBFMIN))
            return -1;
          return 135; /* extendbfsf2 */

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 2025 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))
            return -1;
          return 136; /* extendsfdf2 */

        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode)
              || !
#line 2034 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_ZFHMIN && TARGET_DOUBLE_FLOAT) ||
   (TARGET_ZHINXMIN && TARGET_ZDINX)))
            return -1;
          return 137; /* extendhfdf2 */

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26335; /* extendrvvm4hfrvvm8sf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26336; /* extendrvvm2hfrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26337; /* extendrvvm1hfrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26338; /* extendrvvmf2hfrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26339; /* extendrvvmf4hfrvvmf2sf2 */

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26340; /* extendrvvm4sfrvvm8df2 */

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26341; /* extendrvvm2sfrvvm4df2 */

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26342; /* extendrvvm1sfrvvm2df2 */

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26343; /* extendrvvmf2sfrvvm1df2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26344; /* extendv1hfv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26345; /* extendv2hfv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26346; /* extendv4hfv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26347; /* extendv8hfv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26348; /* extendv16hfv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26349; /* extendv32hfv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26350; /* extendv64hfv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26351; /* extendv128hfv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26352; /* extendv256hfv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26353; /* extendv512hfv512sf2 */

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26354; /* extendv1024hfv1024sf2 */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26355; /* extendv1sfv1df2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26356; /* extendv2sfv2df2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26357; /* extendv4sfv4df2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26358; /* extendv8sfv8df2 */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26359; /* extendv16sfv16df2 */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26360; /* extendv32sfv32df2 */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26361; /* extendv64sfv64df2 */

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26362; /* extendv128sfv128df2 */

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26363; /* extendv256sfv256df2 */

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 850 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26364; /* extendv512sfv512df2 */

    default:
      return -1;
    }
}

 int
recog_1486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (!
#line 1693 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 102; /* smaxsf3 */

    case 1:
      if (!(
#line 1693 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 103; /* smaxdf3 */

    case 2:
      if (!(
#line 1693 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 104; /* smaxhf3 */

    case 3:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 572; /* *smaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 614 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33927; /* riscv_cv_alu_max */

    case 4:
      if (!(
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 576; /* *smaxdi3 */

    case 5:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24546; /* smaxrvvm8qi3 */

    case 6:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24560; /* smaxrvvm4qi3 */

    case 7:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24574; /* smaxrvvm2qi3 */

    case 8:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24588; /* smaxrvvm1qi3 */

    case 9:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24602; /* smaxrvvm8hi3 */

    case 10:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24616; /* smaxrvvm4hi3 */

    case 11:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24630; /* smaxrvvm2hi3 */

    case 12:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24644; /* smaxrvvm1hi3 */

    case 13:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24658; /* smaxrvvm8si3 */

    case 14:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24672; /* smaxrvvm4si3 */

    case 15:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24686; /* smaxrvvm2si3 */

    case 16:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24700; /* smaxrvvm1si3 */

    case 17:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24714; /* smaxrvvm8di3 */

    case 18:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24728; /* smaxrvvm4di3 */

    case 19:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24742; /* smaxrvvm2di3 */

    case 20:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24756; /* smaxrvvm1di3 */

    case 21:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24770; /* smaxrvvmf2qi3 */

    case 22:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24784; /* smaxrvvmf4qi3 */

    case 23:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24798; /* smaxrvvmf8qi3 */

    case 24:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24812; /* smaxrvvmf2hi3 */

    case 25:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24826; /* smaxrvvmf4hi3 */

    case 26:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24840; /* smaxrvvmf2si3 */

    case 27:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24854; /* smaxv1qi3 */

    case 28:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24868; /* smaxv2qi3 */

    case 29:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24882; /* smaxv4qi3 */

    case 30:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24896; /* smaxv8qi3 */

    case 31:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24910; /* smaxv16qi3 */

    case 32:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24924; /* smaxv32qi3 */

    case 33:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24938; /* smaxv64qi3 */

    case 34:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24952; /* smaxv128qi3 */

    case 35:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24966; /* smaxv256qi3 */

    case 36:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24980; /* smaxv512qi3 */

    case 37:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24994; /* smaxv1024qi3 */

    case 38:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25008; /* smaxv2048qi3 */

    case 39:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25022; /* smaxv4096qi3 */

    case 40:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25036; /* smaxv1hi3 */

    case 41:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25050; /* smaxv2hi3 */

    case 42:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25064; /* smaxv4hi3 */

    case 43:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25078; /* smaxv8hi3 */

    case 44:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25092; /* smaxv16hi3 */

    case 45:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25106; /* smaxv32hi3 */

    case 46:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25120; /* smaxv64hi3 */

    case 47:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25134; /* smaxv128hi3 */

    case 48:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25148; /* smaxv256hi3 */

    case 49:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25162; /* smaxv512hi3 */

    case 50:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25176; /* smaxv1024hi3 */

    case 51:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25190; /* smaxv2048hi3 */

    case 52:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25204; /* smaxv1si3 */

    case 53:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25218; /* smaxv2si3 */

    case 54:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25232; /* smaxv4si3 */

    case 55:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25246; /* smaxv8si3 */

    case 56:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25260; /* smaxv16si3 */

    case 57:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25274; /* smaxv32si3 */

    case 58:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25288; /* smaxv64si3 */

    case 59:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25302; /* smaxv128si3 */

    case 60:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25316; /* smaxv256si3 */

    case 61:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25330; /* smaxv512si3 */

    case 62:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25344; /* smaxv1024si3 */

    case 63:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25358; /* smaxv1di3 */

    case 64:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25372; /* smaxv2di3 */

    case 65:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25386; /* smaxv4di3 */

    case 66:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25400; /* smaxv8di3 */

    case 67:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25414; /* smaxv16di3 */

    case 68:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25428; /* smaxv32di3 */

    case 69:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25442; /* smaxv64di3 */

    case 70:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25456; /* smaxv128di3 */

    case 71:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25470; /* smaxv256di3 */

    case 72:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25484; /* smaxv512di3 */

    case 73:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27699; /* smaxrvvm8hf3 */

    case 74:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27701; /* smaxrvvm4hf3 */

    case 75:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27703; /* smaxrvvm2hf3 */

    case 76:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27705; /* smaxrvvm1hf3 */

    case 77:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27707; /* smaxrvvmf2hf3 */

    case 78:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27709; /* smaxrvvmf4hf3 */

    case 79:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27711; /* smaxrvvm8sf3 */

    case 80:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27713; /* smaxrvvm4sf3 */

    case 81:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27715; /* smaxrvvm2sf3 */

    case 82:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27717; /* smaxrvvm1sf3 */

    case 83:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27719; /* smaxrvvmf2sf3 */

    case 84:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27721; /* smaxrvvm8df3 */

    case 85:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27723; /* smaxrvvm4df3 */

    case 86:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27725; /* smaxrvvm2df3 */

    case 87:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27727; /* smaxrvvm1df3 */

    case 88:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27729; /* smaxv1hf3 */

    case 89:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27731; /* smaxv2hf3 */

    case 90:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27733; /* smaxv4hf3 */

    case 91:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27735; /* smaxv8hf3 */

    case 92:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27737; /* smaxv16hf3 */

    case 93:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27739; /* smaxv32hf3 */

    case 94:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27741; /* smaxv64hf3 */

    case 95:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27743; /* smaxv128hf3 */

    case 96:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27745; /* smaxv256hf3 */

    case 97:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27747; /* smaxv512hf3 */

    case 98:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27749; /* smaxv1024hf3 */

    case 99:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27751; /* smaxv2048hf3 */

    case 100:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27753; /* smaxv1sf3 */

    case 101:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27755; /* smaxv2sf3 */

    case 102:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27757; /* smaxv4sf3 */

    case 103:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27759; /* smaxv8sf3 */

    case 104:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27761; /* smaxv16sf3 */

    case 105:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27763; /* smaxv32sf3 */

    case 106:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27765; /* smaxv64sf3 */

    case 107:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27767; /* smaxv128sf3 */

    case 108:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27769; /* smaxv256sf3 */

    case 109:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27771; /* smaxv512sf3 */

    case 110:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27773; /* smaxv1024sf3 */

    case 111:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27775; /* smaxv1df3 */

    case 112:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27777; /* smaxv2df3 */

    case 113:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27779; /* smaxv4df3 */

    case 114:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27781; /* smaxv8df3 */

    case 115:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27783; /* smaxv16df3 */

    case 116:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27785; /* smaxv32df3 */

    case 117:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27787; /* smaxv64df3 */

    case 118:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27789; /* smaxv128df3 */

    case 119:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27791; /* smaxv256df3 */

    case 120:
      if (!(
#line 1581 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27793; /* smaxv512df3 */

    default:
      return -1;
    }
}

 int
recog_1494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 573; /* *umaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 625 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33928; /* riscv_cv_alu_maxu */

    case 1:
      if (!(
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 577; /* *umaxdi3 */

    case 2:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24547; /* umaxrvvm8qi3 */

    case 3:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24561; /* umaxrvvm4qi3 */

    case 4:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24575; /* umaxrvvm2qi3 */

    case 5:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24589; /* umaxrvvm1qi3 */

    case 6:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24603; /* umaxrvvm8hi3 */

    case 7:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24617; /* umaxrvvm4hi3 */

    case 8:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24631; /* umaxrvvm2hi3 */

    case 9:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24645; /* umaxrvvm1hi3 */

    case 10:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24659; /* umaxrvvm8si3 */

    case 11:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24673; /* umaxrvvm4si3 */

    case 12:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24687; /* umaxrvvm2si3 */

    case 13:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24701; /* umaxrvvm1si3 */

    case 14:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24715; /* umaxrvvm8di3 */

    case 15:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24729; /* umaxrvvm4di3 */

    case 16:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24743; /* umaxrvvm2di3 */

    case 17:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24757; /* umaxrvvm1di3 */

    case 18:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24771; /* umaxrvvmf2qi3 */

    case 19:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24785; /* umaxrvvmf4qi3 */

    case 20:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24799; /* umaxrvvmf8qi3 */

    case 21:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24813; /* umaxrvvmf2hi3 */

    case 22:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24827; /* umaxrvvmf4hi3 */

    case 23:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24841; /* umaxrvvmf2si3 */

    case 24:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24855; /* umaxv1qi3 */

    case 25:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24869; /* umaxv2qi3 */

    case 26:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24883; /* umaxv4qi3 */

    case 27:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24897; /* umaxv8qi3 */

    case 28:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24911; /* umaxv16qi3 */

    case 29:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24925; /* umaxv32qi3 */

    case 30:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24939; /* umaxv64qi3 */

    case 31:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24953; /* umaxv128qi3 */

    case 32:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24967; /* umaxv256qi3 */

    case 33:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24981; /* umaxv512qi3 */

    case 34:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24995; /* umaxv1024qi3 */

    case 35:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25009; /* umaxv2048qi3 */

    case 36:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25023; /* umaxv4096qi3 */

    case 37:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25037; /* umaxv1hi3 */

    case 38:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25051; /* umaxv2hi3 */

    case 39:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25065; /* umaxv4hi3 */

    case 40:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25079; /* umaxv8hi3 */

    case 41:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25093; /* umaxv16hi3 */

    case 42:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25107; /* umaxv32hi3 */

    case 43:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25121; /* umaxv64hi3 */

    case 44:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25135; /* umaxv128hi3 */

    case 45:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25149; /* umaxv256hi3 */

    case 46:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25163; /* umaxv512hi3 */

    case 47:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25177; /* umaxv1024hi3 */

    case 48:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25191; /* umaxv2048hi3 */

    case 49:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25205; /* umaxv1si3 */

    case 50:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25219; /* umaxv2si3 */

    case 51:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25233; /* umaxv4si3 */

    case 52:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25247; /* umaxv8si3 */

    case 53:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25261; /* umaxv16si3 */

    case 54:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25275; /* umaxv32si3 */

    case 55:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25289; /* umaxv64si3 */

    case 56:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25303; /* umaxv128si3 */

    case 57:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25317; /* umaxv256si3 */

    case 58:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25331; /* umaxv512si3 */

    case 59:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25345; /* umaxv1024si3 */

    case 60:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25359; /* umaxv1di3 */

    case 61:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25373; /* umaxv2di3 */

    case 62:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25387; /* umaxv4di3 */

    case 63:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25401; /* umaxv8di3 */

    case 64:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25415; /* umaxv16di3 */

    case 65:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25429; /* umaxv32di3 */

    case 66:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25443; /* umaxv64di3 */

    case 67:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25457; /* umaxv128di3 */

    case 68:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25471; /* umaxv256di3 */

    case 69:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25485; /* umaxv512di3 */

    default:
      return -1;
    }
}

 int
recog_1501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_107 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (const_int_operand (operands[2], E_DImode)
          && GET_CODE (x4) == SUBREG
          && known_eq (SUBREG_BYTE (x4), 0)
          && GET_MODE (x4) == E_DImode)
        {
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) == E_SImode)
            {
              switch (GET_CODE (x6))
                {
                case CLZ:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && ((INTVAL (operands[2]) & 0x3f) == 0x3f)))
                    return 534; /* *clzdisi2_sext */
                  break;

                case CTZ:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && ((INTVAL (operands[2]) & 0x3f) == 0x3f)))
                    return 535; /* *ctzdisi2_sext */
                  break;

                case POPCOUNT:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && ((INTVAL (operands[2]) & 0x3f) == 0x3f)))
                    return 536; /* *popcountdisi2_sext */
                  break;

                default:
                  break;
                }
            }
        }
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          if (not_single_bit_mask_operand (operands[2], E_DImode)
              && (
#line 840 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 630; /* *bclridi */
          if (const_nottwobits_not_arith_operand (operands[2], E_DImode))
            {
              if ((
#line 849 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 632; /* *bclridi_nottwobits */
              if (
#line 869 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (~UINTVAL (operands[2])) > 33))
                return 633; /* *bclridisi_nottwobits */
            }
        }
      if (GET_CODE (x4) == SUBREG
          && known_eq (SUBREG_BYTE (x4), 0)
          && GET_MODE (x4) == E_DImode)
        {
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) == LSHIFTRT
              && GET_MODE (x6) == E_SImode
              && x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (register_operand (operands[1], E_SImode))
                {
                  x8 = XEXP (x6, 1);
                  operands[2] = x8;
                  if (register_operand (operands[2], E_QImode)
                      && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return 639; /* *bextdisi */
                }
            }
        }
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x5;
      if (not_uimm_extra_bit_or_nottwobits (operands[2], E_DImode)
          && (
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !not_single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return 649; /* *andidi_extrabit */
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1067 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBA
   && !paradoxical_subreg_p (operands[1])
   /* Only profitable if synthesis takes more than one insn.  */
   && riscv_const_insns (operands[2], false) != 1
   /* We need the upper half to be zero.  */
   && (INTVAL (operands[2]) & HOST_WIDE_INT_C (0xffffffff00000000)) == 0
   /* And the the adjusted constant must either be something we can
      implement with andi or bclri.  */
   && ((SMALL_OPERAND (sext_hwi (INTVAL (operands[2]), 32))
        || (TARGET_ZBS && popcount_hwi (INTVAL (operands[2])) == 31))
       && INTVAL (operands[2]) != 0x7fffffff)))
        return -1;
      return 650; /* *bitmanip.md:1063 */

    case ASHIFT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (pattern230 (x3))
        {
        case 0:
          if (immediate_operand (operands[2], E_VOIDmode)
              && (
#line 2992 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return 323; /* and_shift_reversesi */
          break;

        case 1:
          if (immediate_operand (operands[2], E_VOIDmode)
              && (
#line 2992 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 326; /* and_shift_reversedi */
          if (immediate_operand (operands[2], E_QImode))
            {
              if (pnum_clobbers != NULL
                  && 
#line 3138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)))
                {
                  *pnum_clobbers = 1;
                  return 337; /* zero_extendsidi2_shifted */
                }
              if (
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && (INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff))
                return 514; /* *slliuw */
            }
          break;

        default:
          break;
        }
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || XWINT (x5, 0) != 65280L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern229 (x3, 
E_SImode) != 0
              || !(
#line 136 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 673; /* *riscv_packh_si_2 */

        case E_DImode:
          if (pattern229 (x3, 
E_DImode) != 0
              || !(
#line 136 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 674; /* *riscv_packh_di_2 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          return recog_108 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          switch (pattern260 (x3, pnum_clobbers))
            {
            case 0:
              if ((
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 611; /* *bitmanip.md:724 */
                }
              if (!(
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 613; /* *bitmanip.md:724 */

            case 1:
              if ((
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 615; /* *bitmanip.md:752 */
                }
              if (!(
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 617; /* *bitmanip.md:752 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern260 (x3, pnum_clobbers))
            {
            case 0:
              if ((
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 612; /* *bitmanip.md:724 */
                }
              if (!(
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 614; /* *bitmanip.md:724 */

            case 1:
              if ((
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 616; /* *bitmanip.md:752 */
                }
              if (!(
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 618; /* *bitmanip.md:752 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern262 (x3))
            {
            case 0:
              if (!(
#line 943 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 637; /* *bextseqzdisi */

            case 1:
              if (!(
#line 943 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 638; /* *bextseqzdisi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (pattern292 (x3))
        {
        case 0:
          if (!(
#line 832 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 627; /* *bclrsi */

        case 1:
          if (!(
#line 832 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 628; /* *bclrdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (x3))
    {
    case LT:
      if (GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 3043 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 332; /* *lshrsi3_zero_extend_3 */
        }
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern269 (x3))
        {
        case 0:
          if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 429; /* slt_sisi3 */
          break;

        case 1:
          if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 431; /* slt_disi3 */
          break;

        case 2:
          if (
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 433; /* slt_didi3 */
          break;

        default:
          break;
        }
      break;

    case EQ:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (pattern105 (x3))
            {
            case 0:
              if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                return 411; /* *seq_zero_sisi */
              break;

            case 1:
              if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 412; /* *seq_zero_disi */
              break;

            case 2:
              if (
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 413; /* *seq_zero_didi */
              break;

            default:
              break;
            }
        }
      break;

    case GT:
      switch (pattern220 (x3))
        {
        case 0:
          if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 417; /* *sgt_sisi */
          break;

        case 1:
          if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 419; /* *sgt_disi */
          break;

        case 2:
          if (
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 421; /* *sgt_didi */
          break;

        default:
          break;
        }
      break;

    case GE:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          switch (pattern105 (x3))
            {
            case 0:
              if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                return 423; /* *sge_sisi */
              break;

            case 1:
              if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 425; /* *sge_disi */
              break;

            case 2:
              if (
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 427; /* *sge_didi */
              break;

            default:
              break;
            }
        }
      break;

    case LE:
      switch (pattern221 (x3))
        {
        case 0:
          if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 435; /* *sle_sisi */
          break;

        case 1:
          if (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 437; /* *sle_disi */
          break;

        case 2:
          if (
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 439; /* *sle_didi */
          break;

        case 3:
          if (
#line 570 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return 33923; /* riscv_cv_alu_slet */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern339 (
E_SImode))
        {
        case 0:
          if (!(
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 387; /* *cstoresfsi4 */

        case 1:
          if (!(
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 389; /* *cstoredfsi4 */

        case 2:
          if (!(
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 391; /* *cstorehfsi4 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern339 (
E_DImode))
        {
        case 0:
          if (!(
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 388; /* *cstoresfdi4 */

        case 1:
          if (!(
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 390; /* *cstoredfdi4 */

        case 2:
          if (!(
#line 3528 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 392; /* *cstorehfdi4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1514 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !
#line 3780 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!is_zicfilp_p ()))
        return -1;
      return 444; /* tablejumpsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !(
#line 3780 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!is_zicfilp_p ()) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 445; /* tablejumpdi */

    default:
      return -1;
    }
}

 int
recog_1518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern416 (
E_SImode) != 0
          || !
#line 424 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, SImode)))
        return -1;
      return 915; /* *th_mempair_store_si2 */

    case E_DImode:
      if (pattern416 (
E_DImode) != 0
          || !(
#line 424 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, DImode)) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 916; /* *th_mempair_store_di2 */

    default:
      return -1;
    }
}

 int
recog_1520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_1516 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_1517 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) == SET)
    {
      res = recog_1518 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (x5))
    {
    case USE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8QImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2758; /* *movrvvm8qi_reg_whole_vtype */

        case E_RVVM4QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4QImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2759; /* *movrvvm4qi_reg_whole_vtype */

        case E_RVVM2QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2QImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2760; /* *movrvvm2qi_reg_whole_vtype */

        case E_RVVM1QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1QImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2761; /* *movrvvm1qi_reg_whole_vtype */

        case E_RVVM8HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2762; /* *movrvvm8hi_reg_whole_vtype */

        case E_RVVM4HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2763; /* *movrvvm4hi_reg_whole_vtype */

        case E_RVVM2HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2764; /* *movrvvm2hi_reg_whole_vtype */

        case E_RVVM1HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2765; /* *movrvvm1hi_reg_whole_vtype */

        case E_RVVM8BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8BFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2766; /* *movrvvm8bf_reg_whole_vtype */

        case E_RVVM4BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4BFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2767; /* *movrvvm4bf_reg_whole_vtype */

        case E_RVVM2BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2BFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2768; /* *movrvvm2bf_reg_whole_vtype */

        case E_RVVM1BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1BFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2769; /* *movrvvm1bf_reg_whole_vtype */

        case E_RVVM8HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2770; /* *movrvvm8hf_reg_whole_vtype */

        case E_RVVM4HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2771; /* *movrvvm4hf_reg_whole_vtype */

        case E_RVVM2HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2772; /* *movrvvm2hf_reg_whole_vtype */

        case E_RVVM1HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2773; /* *movrvvm1hf_reg_whole_vtype */

        case E_RVVM8SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2774; /* *movrvvm8si_reg_whole_vtype */

        case E_RVVM4SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2775; /* *movrvvm4si_reg_whole_vtype */

        case E_RVVM2SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2776; /* *movrvvm2si_reg_whole_vtype */

        case E_RVVM1SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SImode)
              || !
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2777; /* *movrvvm1si_reg_whole_vtype */

        case E_RVVM8SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2778; /* *movrvvm8sf_reg_whole_vtype */

        case E_RVVM4SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2779; /* *movrvvm4sf_reg_whole_vtype */

        case E_RVVM2SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2780; /* *movrvvm2sf_reg_whole_vtype */

        case E_RVVM1SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2781; /* *movrvvm1sf_reg_whole_vtype */

        case E_RVVM8DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DImode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2782; /* *movrvvm8di_reg_whole_vtype */

        case E_RVVM4DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DImode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2783; /* *movrvvm4di_reg_whole_vtype */

        case E_RVVM2DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DImode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2784; /* *movrvvm2di_reg_whole_vtype */

        case E_RVVM1DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DImode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2785; /* *movrvvm1di_reg_whole_vtype */

        case E_RVVM8DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2786; /* *movrvvm8df_reg_whole_vtype */

        case E_RVVM4DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2787; /* *movrvvm4df_reg_whole_vtype */

        case E_RVVM2DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2788; /* *movrvvm2df_reg_whole_vtype */

        case E_RVVM1DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2789; /* *movrvvm1df_reg_whole_vtype */

        default:
          return -1;
        }

    case CLOBBER:
      return recog_1519 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 2
          || !register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x5, 0, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[4] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 83:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          if (GET_MODE (x9) != E_SImode
              || !register_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          operands[5] = x10;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          switch (pattern577 (x9))
            {
            case 0:
              if (!
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 760; /* subword_atomic_fetch_strong_add */

            case 1:
              if (!
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 761; /* subword_atomic_fetch_strong_or */

            case 2:
              if (!
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 762; /* subword_atomic_fetch_strong_xor */

            case 3:
              if (!
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 763; /* subword_atomic_fetch_strong_and */

            case 4:
              if (!
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 764; /* subword_atomic_fetch_strong_nand */

            default:
              return -1;
            }

        case 86:
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          operands[2] = x9;
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[4], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!scratch_operand (operands[5], E_SImode)
              || !
#line 493 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
            return -1;
          return 779; /* subword_atomic_exchange_strong */

        default:
          return -1;
        }

    case CLOBBER:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      return recog_1529 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_1530 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG
          || pattern226 (x1, 
9) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 8)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x10) != SET
          || pattern553 (x10, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x11) != SET)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PLUS)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 2)
        return -1;
      x14 = XEXP (x11, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x12, 1);
      operands[0] = x15;
      if (!stack_push_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern736 (x1))
        {
        case 0:
          if (pattern739 (x1, 
E_SImode) != 0
              || !(
#line 1142 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33881; /* gpr_multi_push_up_to_s1_si */

        case 1:
          if (pattern739 (x1, 
E_DImode) != 0
              || !(
#line 1142 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33882; /* gpr_multi_push_up_to_s1_di */

        default:
          return -1;
        }

    case PLUS:
      x16 = XEXP (x3, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 2)
        return -1;
      x17 = XEXP (x2, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern394 (x4) != 0)
        return -1;
      x18 = XEXP (x3, 1);
      operands[0] = x18;
      x5 = XEXP (x4, 1);
      x19 = XEXP (x5, 0);
      x20 = XEXP (x19, 1);
      switch (XWINT (x20, 0))
        {
        case -4L:
          switch (pattern479 (x1, 
E_SImode, 
-12, 
-8))
            {
            case 0:
              if (!(
#line 59 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33809; /* gpr_multi_pop_up_to_s1_si */

            case 1:
              if (!(
#line 363 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33829; /* gpr_multi_popret_up_to_ra_si */

            default:
              return -1;
            }

        case -8L:
          switch (pattern479 (x1, 
E_DImode, 
-24, 
-16))
            {
            case 0:
              if (!(
#line 59 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33810; /* gpr_multi_pop_up_to_s1_di */

            case 1:
              if (!(
#line 363 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33830; /* gpr_multi_popret_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (pattern119 (x1, 
CLOBBER, 
28) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != RETURN
          || !
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
        return -1;
      return 900; /* th_int_pop */

    case SET:
      if (pattern120 (x1, 
23, 
24, 
25, 
26, 
27) != 0
          || pattern745 (x1, 
18, 
19, 
20, 
21, 
22) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 11);
      if (pattern767 (x4) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 9)
        return -1;
      x6 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 8)
        return -1;
      x12 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 1);
      if (GET_CODE (x13) != MEM)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XEXP (x12, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 1)
        return -1;
      x18 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x18) != SET)
        return -1;
      x19 = XEXP (x18, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x18, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 10)
        return -1;
      x21 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x21) != USE)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 10)
        return -1;
      x23 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != USE)
        return -1;
      x24 = XEXP (x3, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 1
          || GET_MODE (x24) != E_SImode)
        return -1;
      x25 = XEXP (x2, 1);
      x26 = XEXP (x25, 1);
      operands[0] = x26;
      if (!stack_pop_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern775 (x1))
        {
        case 0:
          if (XWINT (x10, 0) != -48L
              || XWINT (x16, 0) != -52L
              || pattern798 (x1, 
E_SImode) != 0
              || !(
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33875; /* gpr_multi_popretz_up_to_s11_si */

        case 1:
          if (XWINT (x10, 0) != -96L
              || XWINT (x16, 0) != -104L
              || pattern798 (x1, 
E_DImode) != 0
              || !(
#line 1100 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33876; /* gpr_multi_popretz_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern376 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern730 (x1))
        {
        case 0:
          switch (pattern738 (x1, 
E_SImode, 
-28, 
-24, 
-20, 
-16))
            {
            case 0:
              if (!(
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33817; /* gpr_multi_pop_up_to_s5_si */

            case 1:
              if (!(
#line 445 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33837; /* gpr_multi_popret_up_to_s3_si */

            case 2:
              if (!(
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33857; /* gpr_multi_popretz_up_to_s1_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern738 (x1, 
E_DImode, 
-56, 
-48, 
-40, 
-32))
            {
            case 0:
              if (!(
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33818; /* gpr_multi_pop_up_to_s5_di */

            case 1:
              if (!(
#line 445 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33838; /* gpr_multi_popret_up_to_s3_di */

            case 2:
              if (!(
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33858; /* gpr_multi_popretz_up_to_s1_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 21)
        return -1;
      x6 = XEXP (x2, 0);
      if (pattern330 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 20)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MEM)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x1, 0, 2);
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 19)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != MEM)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != PLUS)
        return -1;
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x1, 0, 3);
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 18)
        return -1;
      x21 = XEXP (x19, 0);
      if (GET_CODE (x21) != MEM)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 2)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != CONST_INT
          || pattern737 (x1, 
9) != 0
          || pattern741 (x1, 
8) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (pattern540 (x25, 
1) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x26) != SET)
        return -1;
      x27 = XEXP (x26, 1);
      if (GET_CODE (x27) != PLUS)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 2)
        return -1;
      x30 = XEXP (x27, 1);
      operands[0] = x30;
      if (!stack_push_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern760 (x1))
        {
        case 0:
          if (pattern765 (x1, 
E_SImode) != 0
              || !(
#line 1240 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33889; /* gpr_multi_push_up_to_s5_si */

        case 1:
          if (pattern765 (x1, 
E_DImode) != 0
              || !(
#line 1240 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33890; /* gpr_multi_push_up_to_s5_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x2) != SET)
    return -1;
  switch (pattern396 (x1, 
23, 
24))
    {
    case 0:
      x3 = XVECEXP (x1, 0, 6);
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 2)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      switch (pattern743 (x1))
        {
        case 0:
          if (XWINT (x7, 0) != -24L)
            return -1;
          switch (pattern755 (x1, 
-28, 
E_SImode, 
-32))
            {
            case 0:
              if (pattern779 (x1, 
9) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern791 (x12) != 0
                  || !(
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33823; /* gpr_multi_pop_up_to_s8_si */

            case 1:
              if (!(
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33843; /* gpr_multi_popret_up_to_s6_si */

            case 2:
              if (!(
#line 848 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33863; /* gpr_multi_popretz_up_to_s4_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x7, 0) != -48L)
            return -1;
          switch (pattern755 (x1, 
-56, 
E_DImode, 
-64))
            {
            case 0:
              x13 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x13) != SET)
                return -1;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != MEM
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 2
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XEXP (x15, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 9
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x19 = XEXP (x10, 1);
              if (GET_CODE (x19) != MEM
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 2
                  || GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x20, 1);
              if (GET_CODE (x22) != CONST_INT
                  || XWINT (x22, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern792 (x12) != 0
                  || !(
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33824; /* gpr_multi_pop_up_to_s8_di */

            case 1:
              if (!(
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33844; /* gpr_multi_popret_up_to_s6_di */

            case 2:
              if (!(
#line 848 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33864; /* gpr_multi_popretz_up_to_s4_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern541 (x1, 
18, 
19, 
20, 
21, 
22) != 0
          || pattern753 (x1, 
9) != 0
          || pattern763 (x1, 
1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x12) != SET)
        return -1;
      x23 = XEXP (x12, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 2)
        return -1;
      x25 = XEXP (x12, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x23, 1);
      operands[0] = x26;
      if (!stack_push_up_to_s8_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern770 (x1))
        {
        case 0:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -40L
              || pattern777 (x1, 
E_SImode) != 0
              || !(
#line 1345 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33895; /* gpr_multi_push_up_to_s8_si */

        case 1:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -80L
              || pattern777 (x1, 
E_DImode) != 0
              || !(
#line 1345 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33896; /* gpr_multi_push_up_to_s8_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode)
    return -1;
  switch (pattern756 (x1))
    {
    case 0:
      x7 = XVECEXP (x1, 0, 8);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (XWINT (x10, 0) != -32L)
        return -1;
      switch (pattern768 (x1, 
E_SImode))
        {
        case 0:
          x11 = XEXP (x2, 1);
          if (pattern778 (x11) != 0
              || REGNO (x3) != 8)
            return -1;
          x12 = XVECEXP (x1, 0, 10);
          if (pattern791 (x12) != 0
              || !(
#line 615 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33847; /* gpr_multi_popret_up_to_s8_si */

        case 1:
          if (!(
#line 919 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33867; /* gpr_multi_popretz_up_to_s6_si */

        default:
          return -1;
        }

    case 1:
      x7 = XVECEXP (x1, 0, 8);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (XWINT (x10, 0) != -64L)
        return -1;
      switch (pattern768 (x1, 
E_DImode))
        {
        case 0:
          x11 = XEXP (x2, 1);
          if (pattern781 (x11) != 0
              || REGNO (x3) != 8)
            return -1;
          x12 = XVECEXP (x1, 0, 10);
          if (pattern792 (x12) != 0
              || !(
#line 615 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33848; /* gpr_multi_popret_up_to_s8_di */

        case 1:
          if (!(
#line 919 "../../gcc-15.1.1-20250425/gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33868; /* gpr_multi_popretz_up_to_s6_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_1475 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_1478 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_1490 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_1509 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_1505 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_1493 (x1, insn, pnum_clobbers);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      return recog_31 (x1, insn, pnum_clobbers);

    case UDIV:
      return recog_1500 (x1, insn, pnum_clobbers);

    case MOD:
      return recog_1499 (x1, insn, pnum_clobbers);

    case UMOD:
      return recog_1498 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_1507 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_1511 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_1506 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_1483 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_1487 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_1486 (x1, insn, pnum_clobbers);

    case AND:
      return recog_1501 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_1491 (x1, insn, pnum_clobbers);

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_110 (x1, insn, pnum_clobbers);

        case ASHIFT:
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern231 (x2))
                {
                case 0:
                  if (!(
#line 2992 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 325; /* xor_shift_reversesi */

                case 1:
                  if (!(
#line 2992 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 328; /* xor_shift_reversedi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x6, 0) != 1L)
                return -1;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              switch (pattern292 (x2))
                {
                case 0:
                  if ((
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 579; /* *binvsi */
                  break;

                case 1:
                  if ((
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 581; /* *binvdi */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x7) != SUBREG)
                return -1;
              switch (pattern336 (x2))
                {
                case 0:
                  if (!(
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 583; /* *binvsi_mask */

                case 1:
                  if (!(
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 585; /* *binvdi_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern199 (x2, pnum_clobbers))
            {
            case 0:
              if ((
#line 686 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 596; /* *bitmanip.md:675 */
                }
              if (!(
#line 686 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 600; /* *bitmanip.md:675 */

            case 1:
              if ((
#line 712 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 604; /* *bitmanip.md:701 */
                }
              if (!(
#line 712 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 608; /* *bitmanip.md:701 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern199 (x2, pnum_clobbers))
            {
            case 0:
              if ((
#line 686 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 598; /* *bitmanip.md:675 */
                }
              if (!(
#line 686 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 602; /* *bitmanip.md:675 */

            case 1:
              if ((
#line 712 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 606; /* *bitmanip.md:701 */
                }
              if (!(
#line 712 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 610; /* *bitmanip.md:701 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_1492 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_1481 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_1508 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_1482 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_1504 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_1485 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_1484 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_1480 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_1479 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern326 (x2, 
E_SImode) != 0
              || !
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 272; /* *lowsi */

        case E_DImode:
          if (pattern326 (x2, 
E_DImode) != 0
              || !
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 273; /* *lowdi */

        default:
          return -1;
        }

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_379 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern270 (x2))
            {
            case 0:
              return 302; /* *ashlsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 308; /* *ashlsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 305; /* *ashldi3_mask_1 */

            case 3:
              if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 311; /* *ashldi3_mask_1 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_QImode))
            {
              switch (pattern338 (x2))
                {
                case 0:
                  if ((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 586; /* *bsetsi_1 */
                  break;

                case 1:
                  if ((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 587; /* *bsetdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_QImode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != AND)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern421 (x2, 
E_SImode) != 0
                  || !const_si_mask_operand (operands[2], E_VOIDmode)
                  || !(
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 619; /* *bsetsi_1_mask */

            case E_DImode:
              if (pattern421 (x2, 
E_DImode) != 0
                  || !const_di_mask_operand (operands[2], E_VOIDmode)
                  || !(
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 620; /* *bsetdi_1_mask */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          return recog_380 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern104 (x1, 
SIGN_EXTEND))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_381 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern270 (x2))
            {
            case 0:
              return 303; /* *ashrsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 309; /* *ashrsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 306; /* *ashrdi3_mask_1 */

            case 3:
              if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 312; /* *ashrdi3_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33909; /* riscv_cv_mac_mulsN */

        case 2:
          if (!
#line 281 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33910; /* riscv_cv_mac_mulhhsN */

        case 3:
          if (!
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33913; /* riscv_cv_mac_mulsRN */

        case 4:
          if (!
#line 433 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33917; /* riscv_cv_mac_macsN */

        case 5:
          if (!
#line 377 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33914; /* riscv_cv_mac_mulhhsRN */

        case 6:
          if (!
#line 453 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33918; /* riscv_cv_mac_machhsN */

        case 7:
          if (!
#line 530 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33921; /* riscv_cv_mac_macsRN */

        case 8:
          if (!
#line 557 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33922; /* riscv_cv_mac_machhsRN */

        case 9:
          if (!
#line 709 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33935; /* riscv_cv_alu_addN */

        case 10:
          if (!
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33937; /* riscv_cv_alu_addRN */

        case 11:
          if (!
#line 826 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33941; /* riscv_cv_alu_subRN */

        case 12:
          if (!
#line 787 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33939; /* riscv_cv_alu_subN */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern104 (x1, 
ZERO_EXTEND))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_382 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern270 (x2))
            {
            case 0:
              return 304; /* *lshrsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 310; /* *lshrsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 307; /* *lshrdi3_mask_1 */

            case 3:
              if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 313; /* *lshrdi3_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33907; /* riscv_cv_mac_muluN */

        case 2:
          if (!
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33908; /* riscv_cv_mac_mulhhuN */

        case 3:
          if (!
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33911; /* riscv_cv_mac_muluRN */

        case 4:
          if (!
#line 395 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33915; /* riscv_cv_mac_macuN */

        case 5:
          if (!
#line 329 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33912; /* riscv_cv_mac_mulhhuRN */

        case 6:
          if (!
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33916; /* riscv_cv_mac_machhuN */

        case 7:
          if (!
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33919; /* riscv_cv_mac_macuRN */

        case 8:
          if (!
#line 505 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 33920; /* riscv_cv_mac_machhuRN */

        case 9:
          if (!
#line 725 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33936; /* riscv_cv_alu_adduN */

        case 10:
          if (!
#line 771 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33938; /* riscv_cv_alu_adduRN */

        case 11:
          if (!
#line 849 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33942; /* riscv_cv_alu_subuRN */

        case 12:
          if (!
#line 803 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33940; /* riscv_cv_alu_subuN */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (
#line 3029 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_64BIT && (INTVAL (operands[3]) > 0)
    && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return 330; /* *lshrsi3_extend_2 */
          if (pnum_clobbers != NULL
              && (
#line 3064 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 335; /* *extractdi3 */
            }
          if (!(
#line 53 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 873; /* *th_extdi4 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 3064 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            {
              *pnum_clobbers = 1;
              return 333; /* *extractsi3 */
            }
          if (!
#line 53 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB))
            return -1;
          return 872; /* *th_extsi4 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          res = recog_383 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (XWINT (x5, 0) == 1L)
        {
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              if (register_operand (operands[2], E_QImode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern407 (x2, 
E_SImode) == 0
                          && (
#line 907 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                        return 634; /* *bextsi */
                      break;

                    case E_DImode:
                      if (pattern407 (x2, 
E_DImode) == 0
                          && (
#line 907 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 635; /* *bextdi */
                      break;

                    default:
                      break;
                    }
                }
              break;

            case REG:
            case SUBREG:
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern393 (x2, 
E_SImode) == 0
                      && (
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 640; /* *bextsi */
                  break;

                case E_DImode:
                  if (pattern393 (x2, 
E_DImode) == 0
                      && (
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 641; /* *bextdi */
                  break;

                default:
                  break;
                }
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x11;
              if (immediate_operand (operands[2], E_VOIDmode))
                {
                  switch (pattern107 (x2))
                    {
                    case 0:
                      if ((
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                        return 642; /* *bexti */
                      break;

                    case 1:
                      if ((
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 643; /* *bexti */
                      break;

                    default:
                      break;
                    }
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x11 = XEXP (x2, 2);
          operands[3] = x11;
          if (const_int_operand (operands[3], E_VOIDmode))
            {
              switch (pattern107 (x2))
                {
                case 0:
                  if (
#line 88 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB
   && (UINTVAL (operands[2]) + UINTVAL (operands[3])
       <= GET_MODE_BITSIZE (SImode))))
                    return 880; /* *th_extusi4 */
                  break;

                case 1:
                  if ((
#line 88 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB
   && (UINTVAL (operands[2]) + UINTVAL (operands[3])
       <= GET_MODE_BITSIZE (DImode))) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 881; /* *th_extudi4 */
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (pattern107 (x2))
        {
        case 0:
          if (!(
#line 151 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 891; /* *th_tstsi3 */

        case 1:
          if (!(
#line 151 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 892; /* *th_tstdi3 */

        default:
          return -1;
        }

    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      return recog_1510 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_1476 (x1, insn, pnum_clobbers);

    case NE:
      switch (pattern106 (x1, 
0))
        {
        case 0:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 414; /* *sne_zero_sisi */

        case 1:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 415; /* *sne_zero_disi */

        case 2:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 416; /* *sne_zero_didi */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern220 (x2))
        {
        case 0:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 418; /* *sgtu_sisi */

        case 1:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 420; /* *sgtu_disi */

        case 2:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 422; /* *sgtu_didi */

        default:
          return -1;
        }

    case GEU:
      switch (pattern106 (x1, 
1))
        {
        case 0:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 424; /* *sgeu_sisi */

        case 1:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 426; /* *sgeu_disi */

        case 2:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 428; /* *sgeu_didi */

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern269 (x2))
        {
        case 0:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 430; /* sltu_sisi3 */

        case 1:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 432; /* sltu_disi3 */

        case 2:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 434; /* sltu_didi3 */

        default:
          return -1;
        }

    case LEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern221 (x2))
        {
        case 0:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 436; /* *sleu_sisi */

        case 1:
          if (!
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 438; /* *sleu_disi */

        case 2:
          if (!
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 440; /* *sleu_didi */

        case 3:
          if (!
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 33924; /* riscv_cv_alu_sletu */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_1489 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_1496 (x1, insn, pnum_clobbers);

    case CTZ:
      return recog_1497 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      return recog_1477 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern107 (x2))
        {
        case 0:
          if (arith_operand (operands[2], E_QImode)
              && 
#line 344 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return 548; /* *rotrsi3 */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || SImode == SImode)))
            return 870; /* *th_srrisi3 */
          break;

        case 1:
          if (arith_operand (operands[2], E_QImode)
              && 
#line 372 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return 549; /* *rotrdi3 */
          if (const_int_operand (operands[2], E_VOIDmode)
              && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || DImode == SImode)) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 871; /* *th_srridi3 */
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x5, E_VOIDmode))
        return -1;
      switch (pattern270 (x2))
        {
        case 0:
          if (!
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return -1;
          return 555; /* *rotrsi3_mask */

        case 1:
          if (!(
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 559; /* *rotrsi3_mask */

        case 2:
          if (!(
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 557; /* *rotrdi3_mask */

        case 3:
          if (!(
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 561; /* *rotrdi3_mask */

        default:
          return -1;
        }

    case ROTATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (register_operand (operands[2], E_QImode))
        {
          switch (pattern107 (x2))
            {
            case 0:
              if (
#line 388 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
                return 551; /* *rotlsi3 */
              break;

            case 1:
              if (
#line 414 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
                return 552; /* rotldi3 */
              break;

            default:
              break;
            }
        }
      if (!subreg_lowpart_operator (x5, E_VOIDmode))
        return -1;
      switch (pattern270 (x2))
        {
        case 0:
          if (!
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return -1;
          return 554; /* *rotlsi3_mask */

        case 1:
          if (!(
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 558; /* *rotlsi3_mask */

        case 2:
          if (!(
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 556; /* *rotldi3_mask */

        case 3:
          if (!(
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 560; /* *rotldi3_mask */

        default:
          return -1;
        }

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern107 (x2))
        {
        case 0:
          if ((
#line 493 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return 568; /* *bswapsi2 */
          if (!
#line 129 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || SImode == SImode)))
            return -1;
          return 887; /* th_revsi2 */

        case 1:
          if ((
#line 493 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 569; /* *bswapdi2 */
          if (!(
#line 129 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || DImode == SImode)) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 888; /* th_revdi2 */

        default:
          return -1;
        }

    case UMIN:
      return recog_1495 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_1494 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_1488 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      return recog_1503 (x1, insn, pnum_clobbers);

    case UMUL_HIGHPART:
      return recog_1502 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern285 (x2, 
E_HImode))
        {
        case 0:
          if ((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1988 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_8 (insn, operands);
          if ((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_191 (insn, operands);
          break;

        case 1:
          if ((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1988 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_11 (insn, operands);
          if ((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_194 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_SImode:
      switch (pattern285 (x2, 
E_SImode))
        {
        case 0:
          if ((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1988 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_9 (insn, operands);
          if ((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_192 (insn, operands);
          break;

        case 1:
          if ((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1988 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_12 (insn, operands);
          if ((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_195 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern285 (x2, 
E_DImode))
        {
        case 0:
          if (((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1988 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_10 (insn, operands);
          if (((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_193 (insn, operands);
          break;

        case 1:
          if (((
#line 1984 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1988 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_13 (insn, operands);
          if (((
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 559 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_196 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM8HImode:
      if (register_operand (operands[0], E_RVVM8HImode)
          && GET_MODE (x2) == E_RVVM8HImode
          && register_operand (operands[1], E_RVVM4QImode)
          && (
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4149 (insn, operands);
      break;

    case E_RVVM4HImode:
      if (register_operand (operands[0], E_RVVM4HImode)
          && GET_MODE (x2) == E_RVVM4HImode
          && register_operand (operands[1], E_RVVM2QImode)
          && (
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4151 (insn, operands);
      break;

    case E_RVVM2HImode:
      if (register_operand (operands[0], E_RVVM2HImode)
          && GET_MODE (x2) == E_RVVM2HImode
          && register_operand (operands[1], E_RVVM1QImode)
          && (
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4153 (insn, operands);
      break;

    case E_RVVM1HImode:
      if (register_operand (operands[0], E_RVVM1HImode)
          && GET_MODE (x2) == E_RVVM1HImode
          && register_operand (operands[1], E_RVVMF2QImode)
          && (
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4155 (insn, operands);
      break;

    case E_RVVMF2HImode:
      if (register_operand (operands[0], E_RVVMF2HImode)
          && GET_MODE (x2) == E_RVVMF2HImode
          && register_operand (operands[1], E_RVVMF4QImode)
          && (
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4157 (insn, operands);
      break;

    case E_RVVMF4HImode:
      if (register_operand (operands[0], E_RVVMF4HImode)
          && GET_MODE (x2) == E_RVVMF4HImode
          && register_operand (operands[1], E_RVVMF8QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4159 (insn, operands);
      break;

    case E_RVVM8SImode:
      switch (pattern296 (x2))
        {
        case 0:
          if ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4161 (insn, operands);
          break;

        case 1:
          if ((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4245 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM4SImode:
      switch (pattern297 (x2))
        {
        case 0:
          if ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4163 (insn, operands);
          break;

        case 1:
          if ((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4247 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM2SImode:
      switch (pattern298 (x2))
        {
        case 0:
          if ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4165 (insn, operands);
          break;

        case 1:
          if ((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4249 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM1SImode:
      switch (pattern299 (x2))
        {
        case 0:
          if ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4167 (insn, operands);
          break;

        case 1:
          if ((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4251 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVMF2SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4169 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4253 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM8DImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4171 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4255 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4305 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM4DImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4173 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4257 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4307 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM2DImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4175 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4259 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4309 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM1DImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4177 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4261 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4311 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1HImode:
      if (register_operand (operands[0], E_V1HImode)
          && GET_MODE (x2) == E_V1HImode
          && register_operand (operands[1], E_V1QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4179 (insn, operands);
      break;

    case E_V2HImode:
      if (register_operand (operands[0], E_V2HImode)
          && GET_MODE (x2) == E_V2HImode
          && register_operand (operands[1], E_V2QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4181 (insn, operands);
      break;

    case E_V4HImode:
      if (register_operand (operands[0], E_V4HImode)
          && GET_MODE (x2) == E_V4HImode
          && register_operand (operands[1], E_V4QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4183 (insn, operands);
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && GET_MODE (x2) == E_V8HImode
          && register_operand (operands[1], E_V8QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4185 (insn, operands);
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && GET_MODE (x2) == E_V16HImode
          && register_operand (operands[1], E_V16QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4187 (insn, operands);
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && GET_MODE (x2) == E_V32HImode
          && register_operand (operands[1], E_V32QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4189 (insn, operands);
      break;

    case E_V64HImode:
      if (register_operand (operands[0], E_V64HImode)
          && GET_MODE (x2) == E_V64HImode
          && register_operand (operands[1], E_V64QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4191 (insn, operands);
      break;

    case E_V128HImode:
      if (register_operand (operands[0], E_V128HImode)
          && GET_MODE (x2) == E_V128HImode
          && register_operand (operands[1], E_V128QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4193 (insn, operands);
      break;

    case E_V256HImode:
      if (register_operand (operands[0], E_V256HImode)
          && GET_MODE (x2) == E_V256HImode
          && register_operand (operands[1], E_V256QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4195 (insn, operands);
      break;

    case E_V512HImode:
      if (register_operand (operands[0], E_V512HImode)
          && GET_MODE (x2) == E_V512HImode
          && register_operand (operands[1], E_V512QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4197 (insn, operands);
      break;

    case E_V1024HImode:
      if (register_operand (operands[0], E_V1024HImode)
          && GET_MODE (x2) == E_V1024HImode
          && register_operand (operands[1], E_V1024QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4199 (insn, operands);
      break;

    case E_V2048HImode:
      if (register_operand (operands[0], E_V2048HImode)
          && GET_MODE (x2) == E_V2048HImode
          && register_operand (operands[1], E_V2048QImode)
          && ((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4201 (insn, operands);
      break;

    case E_V1SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4203 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4263 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V2SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4205 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4265 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V4SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4207 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4267 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V8SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4209 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4269 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V16SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4211 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4271 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V32SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4213 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4273 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V64SImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4215 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4275 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V128SImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4217 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4277 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V256SImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4219 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4279 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V512SImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4221 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4281 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1024SImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4223 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4283 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4225 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4285 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4313 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V2DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4227 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4287 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4315 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V4DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4229 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4289 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4317 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V8DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4231 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4291 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4319 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V16DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4233 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4293 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4321 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V32DImode:
      switch (pattern321 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4235 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4295 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4323 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V64DImode:
      switch (pattern322 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4237 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4297 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4325 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V128DImode:
      switch (pattern323 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4239 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4299 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4327 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V256DImode:
      switch (pattern324 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4241 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4301 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4329 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V512DImode:
      switch (pattern325 (x2))
        {
        case 0:
          if (((
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4243 (insn, operands);
          break;

        case 1:
          if (((
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4303 (insn, operands);
          break;

        case 2:
          if (((
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4331 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x3) != SUBREG
      || pattern237 (x2) != 0)
    return NULL;
  if (vector_length_operand (operands[1], E_SImode)
      && ((
#line 1828 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1830 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return gen_split_2307 (insn, operands);
  if (!vector_length_operand (operands[1], E_DImode)
      || !((
#line 1828 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1830 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2308 (insn, operands);
}

 rtx_insn *
split_117 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern451 (x2))
    {
    case 0:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_488 (insn, operands);

    case 1:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_489 (insn, operands);

    case 2:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_490 (insn, operands);

    case 3:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_491 (insn, operands);

    case 4:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_492 (insn, operands);

    case 5:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_493 (insn, operands);

    case 6:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_494 (insn, operands);

    case 7:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_495 (insn, operands);

    case 8:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_496 (insn, operands);

    case 9:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_497 (insn, operands);

    case 10:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_498 (insn, operands);

    case 11:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_499 (insn, operands);

    case 12:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_500 (insn, operands);

    case 13:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_501 (insn, operands);

    case 14:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_502 (insn, operands);

    case 15:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_503 (insn, operands);

    case 16:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_504 (insn, operands);

    case 17:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_505 (insn, operands);

    case 18:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_506 (insn, operands);

    case 19:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_507 (insn, operands);

    case 20:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_508 (insn, operands);

    case 21:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_509 (insn, operands);

    case 22:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_510 (insn, operands);

    case 23:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_511 (insn, operands);

    case 24:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_512 (insn, operands);

    case 25:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_513 (insn, operands);

    case 26:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_514 (insn, operands);

    case 27:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_515 (insn, operands);

    case 28:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_516 (insn, operands);

    case 29:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_517 (insn, operands);

    case 30:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_518 (insn, operands);

    case 31:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_519 (insn, operands);

    case 32:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_520 (insn, operands);

    case 33:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_521 (insn, operands);

    case 34:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_522 (insn, operands);

    case 35:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_523 (insn, operands);

    case 36:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_524 (insn, operands);

    case 37:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_525 (insn, operands);

    case 38:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_526 (insn, operands);

    case 39:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_527 (insn, operands);

    case 40:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_528 (insn, operands);

    case 41:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_529 (insn, operands);

    case 42:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_530 (insn, operands);

    case 43:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_531 (insn, operands);

    case 44:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_532 (insn, operands);

    case 45:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_533 (insn, operands);

    case 46:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_534 (insn, operands);

    case 47:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_535 (insn, operands);

    case 48:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_536 (insn, operands);

    case 49:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_537 (insn, operands);

    case 50:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_538 (insn, operands);

    case 51:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_539 (insn, operands);

    case 52:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_540 (insn, operands);

    case 53:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_541 (insn, operands);

    case 54:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_542 (insn, operands);

    case 55:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_543 (insn, operands);

    case 56:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_544 (insn, operands);

    case 57:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_545 (insn, operands);

    case 58:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_546 (insn, operands);

    case 59:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_547 (insn, operands);

    case 60:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_548 (insn, operands);

    case 61:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_549 (insn, operands);

    case 62:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_550 (insn, operands);

    case 63:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_551 (insn, operands);

    case 64:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_552 (insn, operands);

    case 65:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_553 (insn, operands);

    case 66:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_554 (insn, operands);

    case 67:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_555 (insn, operands);

    case 68:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_556 (insn, operands);

    case 69:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_557 (insn, operands);

    case 70:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_558 (insn, operands);

    case 71:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_559 (insn, operands);

    case 72:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_560 (insn, operands);

    case 73:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_561 (insn, operands);

    case 74:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_562 (insn, operands);

    case 75:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_563 (insn, operands);

    case 76:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_564 (insn, operands);

    case 77:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_565 (insn, operands);

    case 78:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_566 (insn, operands);

    case 79:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_567 (insn, operands);

    case 80:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_568 (insn, operands);

    case 81:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_569 (insn, operands);

    case 82:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_570 (insn, operands);

    case 83:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_571 (insn, operands);

    case 84:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_572 (insn, operands);

    case 85:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_573 (insn, operands);

    case 86:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_574 (insn, operands);

    case 87:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_575 (insn, operands);

    case 88:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_576 (insn, operands);

    case 89:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_577 (insn, operands);

    case 90:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_578 (insn, operands);

    case 91:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_579 (insn, operands);

    case 92:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_580 (insn, operands);

    case 93:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_581 (insn, operands);

    case 94:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_582 (insn, operands);

    case 95:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_583 (insn, operands);

    case 96:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_584 (insn, operands);

    case 97:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_585 (insn, operands);

    case 98:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_586 (insn, operands);

    case 99:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_587 (insn, operands);

    case 100:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_588 (insn, operands);

    case 101:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_589 (insn, operands);

    case 102:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_590 (insn, operands);

    case 103:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_591 (insn, operands);

    case 104:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_592 (insn, operands);

    case 105:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_593 (insn, operands);

    case 106:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_594 (insn, operands);

    case 107:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 293 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_595 (insn, operands);

    case 108:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_596 (insn, operands);

    case 109:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_597 (insn, operands);

    case 110:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_598 (insn, operands);

    case 111:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_599 (insn, operands);

    case 112:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_600 (insn, operands);

    case 113:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_601 (insn, operands);

    case 114:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_602 (insn, operands);

    case 115:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_603 (insn, operands);

    case 116:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_604 (insn, operands);

    case 117:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_605 (insn, operands);

    case 118:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_606 (insn, operands);

    case 119:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_607 (insn, operands);

    case 120:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_608 (insn, operands);

    case 121:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_609 (insn, operands);

    case 122:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_610 (insn, operands);

    case 123:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_611 (insn, operands);

    case 124:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_612 (insn, operands);

    case 125:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_613 (insn, operands);

    case 126:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_614 (insn, operands);

    case 127:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_615 (insn, operands);

    case 128:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_616 (insn, operands);

    case 129:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_617 (insn, operands);

    case 130:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_618 (insn, operands);

    case 131:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_619 (insn, operands);

    case 132:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_620 (insn, operands);

    case 133:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_621 (insn, operands);

    case 134:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_622 (insn, operands);

    case 135:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_623 (insn, operands);

    case 136:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_624 (insn, operands);

    case 137:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_625 (insn, operands);

    case 138:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_626 (insn, operands);

    case 139:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_627 (insn, operands);

    case 140:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_628 (insn, operands);

    case 141:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_629 (insn, operands);

    case 142:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_630 (insn, operands);

    case 143:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_631 (insn, operands);

    case 144:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_632 (insn, operands);

    case 145:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_633 (insn, operands);

    case 146:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_634 (insn, operands);

    case 147:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_635 (insn, operands);

    case 148:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_636 (insn, operands);

    case 149:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_637 (insn, operands);

    case 150:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_638 (insn, operands);

    case 151:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_639 (insn, operands);

    case 152:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_640 (insn, operands);

    case 153:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_641 (insn, operands);

    case 154:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_642 (insn, operands);

    case 155:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_643 (insn, operands);

    case 156:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_644 (insn, operands);

    case 157:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_645 (insn, operands);

    case 158:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_646 (insn, operands);

    case 159:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_647 (insn, operands);

    case 160:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_648 (insn, operands);

    case 161:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_649 (insn, operands);

    case 162:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_650 (insn, operands);

    case 163:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_651 (insn, operands);

    case 164:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_652 (insn, operands);

    case 165:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_653 (insn, operands);

    case 166:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_654 (insn, operands);

    case 167:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_655 (insn, operands);

    case 168:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_656 (insn, operands);

    case 169:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_657 (insn, operands);

    case 170:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_658 (insn, operands);

    case 171:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_659 (insn, operands);

    case 172:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_660 (insn, operands);

    case 173:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_661 (insn, operands);

    case 174:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_662 (insn, operands);

    case 175:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_663 (insn, operands);

    case 176:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_664 (insn, operands);

    case 177:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_665 (insn, operands);

    case 178:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_666 (insn, operands);

    case 179:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_667 (insn, operands);

    case 180:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_668 (insn, operands);

    case 181:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_669 (insn, operands);

    case 182:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_670 (insn, operands);

    case 183:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_671 (insn, operands);

    case 184:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_672 (insn, operands);

    case 185:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_673 (insn, operands);

    case 186:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_674 (insn, operands);

    case 187:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_675 (insn, operands);

    case 188:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_676 (insn, operands);

    case 189:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_677 (insn, operands);

    case 190:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_678 (insn, operands);

    case 191:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_679 (insn, operands);

    case 192:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_680 (insn, operands);

    case 193:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_681 (insn, operands);

    case 194:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_682 (insn, operands);

    case 195:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_683 (insn, operands);

    case 196:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_684 (insn, operands);

    case 197:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_685 (insn, operands);

    case 198:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_686 (insn, operands);

    case 199:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_687 (insn, operands);

    case 200:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_688 (insn, operands);

    case 201:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_689 (insn, operands);

    case 202:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_690 (insn, operands);

    case 203:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_691 (insn, operands);

    case 204:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_692 (insn, operands);

    case 205:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_693 (insn, operands);

    case 206:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_694 (insn, operands);

    case 207:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_695 (insn, operands);

    case 208:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_696 (insn, operands);

    case 209:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_697 (insn, operands);

    case 210:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_698 (insn, operands);

    case 211:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_699 (insn, operands);

    case 212:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_700 (insn, operands);

    case 213:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_701 (insn, operands);

    case 214:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_702 (insn, operands);

    case 215:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_703 (insn, operands);

    case 216:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_704 (insn, operands);

    case 217:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_705 (insn, operands);

    case 218:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_706 (insn, operands);

    case 219:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_707 (insn, operands);

    case 220:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_708 (insn, operands);

    case 221:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_709 (insn, operands);

    case 222:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_710 (insn, operands);

    case 223:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_711 (insn, operands);

    case 224:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_712 (insn, operands);

    case 225:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_713 (insn, operands);

    case 226:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_714 (insn, operands);

    case 227:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_715 (insn, operands);

    case 228:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_716 (insn, operands);

    case 229:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_717 (insn, operands);

    case 230:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_718 (insn, operands);

    case 231:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_719 (insn, operands);

    case 232:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_720 (insn, operands);

    case 233:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_721 (insn, operands);

    case 234:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_722 (insn, operands);

    case 235:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_723 (insn, operands);

    case 236:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_724 (insn, operands);

    case 237:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_725 (insn, operands);

    case 238:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_726 (insn, operands);

    case 239:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_727 (insn, operands);

    case 240:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_728 (insn, operands);

    case 241:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_729 (insn, operands);

    case 242:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_730 (insn, operands);

    case 243:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_731 (insn, operands);

    case 244:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_732 (insn, operands);

    case 245:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_733 (insn, operands);

    case 246:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_734 (insn, operands);

    case 247:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_735 (insn, operands);

    case 248:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_736 (insn, operands);

    case 249:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_737 (insn, operands);

    case 250:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_738 (insn, operands);

    case 251:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_739 (insn, operands);

    case 252:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_740 (insn, operands);

    case 253:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_741 (insn, operands);

    case 254:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_742 (insn, operands);

    case 255:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_743 (insn, operands);

    case 256:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_744 (insn, operands);

    case 257:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_745 (insn, operands);

    case 258:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_746 (insn, operands);

    case 259:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_747 (insn, operands);

    case 260:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_748 (insn, operands);

    case 261:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_749 (insn, operands);

    case 262:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_750 (insn, operands);

    case 263:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_751 (insn, operands);

    case 264:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_752 (insn, operands);

    case 265:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_753 (insn, operands);

    case 266:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_754 (insn, operands);

    case 267:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_755 (insn, operands);

    case 268:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_756 (insn, operands);

    case 269:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_757 (insn, operands);

    case 270:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_758 (insn, operands);

    case 271:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_759 (insn, operands);

    case 272:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_760 (insn, operands);

    case 273:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_761 (insn, operands);

    case 274:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_762 (insn, operands);

    case 275:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_763 (insn, operands);

    case 276:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_764 (insn, operands);

    case 277:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_765 (insn, operands);

    case 278:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_766 (insn, operands);

    case 279:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_767 (insn, operands);

    case 280:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_768 (insn, operands);

    case 281:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_769 (insn, operands);

    case 282:
      if (!((
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_770 (insn, operands);

    case 283:
      if (!(
#line 116 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_771 (insn, operands);

    case 284:
      if (!((
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_772 (insn, operands);

    case 285:
      if (!(
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_773 (insn, operands);

    case 286:
      if (!(
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_774 (insn, operands);

    case 287:
      if (!(
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_775 (insn, operands);

    case 288:
      if (!(
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_776 (insn, operands);

    case 289:
      if (!(
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_777 (insn, operands);

    case 290:
      if (!(
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_778 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_132 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (pattern266 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return NULL;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return NULL;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return NULL;
  x8 = XVECEXP (x3, 0, 4);
  operands[7] = x8;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return NULL;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  switch (XINT (x3, 1))
    {
    case 174:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_125 (x1, insn);

    case 175:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_126 (x1, insn);

    case 176:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_127 (x1, insn);

    case 177:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_128 (x1, insn);

    case 178:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_129 (x1, insn);

    case 179:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_130 (x1, insn);

    case 93:
      x10 = XEXP (x2, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x10;
          return split_131 (x1, insn);

        case VEC_DUPLICATE:
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern601 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2451 (insn, operands);

            case E_RVVM4QImode:
              if (pattern601 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2452 (insn, operands);

            case E_RVVM2QImode:
              if (pattern601 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2453 (insn, operands);

            case E_RVVM1QImode:
              if (pattern601 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2454 (insn, operands);

            case E_RVVM8HImode:
              if (pattern601 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2455 (insn, operands);

            case E_RVVM4HImode:
              if (pattern601 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2456 (insn, operands);

            case E_RVVM2HImode:
              if (pattern601 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2457 (insn, operands);

            case E_RVVM1HImode:
              if (pattern601 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2458 (insn, operands);

            case E_RVVM8SImode:
              if (pattern601 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2459 (insn, operands);

            case E_RVVM4SImode:
              if (pattern601 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2460 (insn, operands);

            case E_RVVM2SImode:
              if (pattern601 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2461 (insn, operands);

            case E_RVVM1SImode:
              if (pattern601 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
                  || !
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2462 (insn, operands);

            case E_RVVM8DImode:
              if (pattern601 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2463 (insn, operands);

            case E_RVVM4DImode:
              if (pattern601 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2464 (insn, operands);

            case E_RVVM2DImode:
              if (pattern601 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2465 (insn, operands);

            case E_RVVM1DImode:
              if (pattern601 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2466 (insn, operands);

            case E_RVVMF2QImode:
              if (pattern601 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2467 (insn, operands);

            case E_RVVMF4QImode:
              if (pattern601 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2468 (insn, operands);

            case E_RVVMF8QImode:
              if (pattern601 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2469 (insn, operands);

            case E_RVVMF2HImode:
              if (pattern601 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2470 (insn, operands);

            case E_RVVMF4HImode:
              if (pattern601 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2471 (insn, operands);

            case E_RVVMF2SImode:
              if (pattern601 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2472 (insn, operands);

            case E_V1QImode:
              if (pattern601 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return NULL;
              return gen_split_2473 (insn, operands);

            case E_V2QImode:
              if (pattern601 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return NULL;
              return gen_split_2474 (insn, operands);

            case E_V4QImode:
              if (pattern601 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return NULL;
              return gen_split_2475 (insn, operands);

            case E_V8QImode:
              if (pattern601 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return NULL;
              return gen_split_2476 (insn, operands);

            case E_V16QImode:
              if (pattern601 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return NULL;
              return gen_split_2477 (insn, operands);

            case E_V32QImode:
              if (pattern601 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return NULL;
              return gen_split_2478 (insn, operands);

            case E_V64QImode:
              if (pattern601 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2479 (insn, operands);

            case E_V128QImode:
              if (pattern601 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2480 (insn, operands);

            case E_V256QImode:
              if (pattern601 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2481 (insn, operands);

            case E_V512QImode:
              if (pattern601 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2482 (insn, operands);

            case E_V1024QImode:
              if (pattern601 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2483 (insn, operands);

            case E_V2048QImode:
              if (pattern601 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2484 (insn, operands);

            case E_V4096QImode:
              if (pattern601 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2485 (insn, operands);

            case E_V1HImode:
              if (pattern601 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return NULL;
              return gen_split_2486 (insn, operands);

            case E_V2HImode:
              if (pattern601 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return NULL;
              return gen_split_2487 (insn, operands);

            case E_V4HImode:
              if (pattern601 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return NULL;
              return gen_split_2488 (insn, operands);

            case E_V8HImode:
              if (pattern601 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return NULL;
              return gen_split_2489 (insn, operands);

            case E_V16HImode:
              if (pattern601 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return NULL;
              return gen_split_2490 (insn, operands);

            case E_V32HImode:
              if (pattern601 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2491 (insn, operands);

            case E_V64HImode:
              if (pattern601 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2492 (insn, operands);

            case E_V128HImode:
              if (pattern601 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2493 (insn, operands);

            case E_V256HImode:
              if (pattern601 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2494 (insn, operands);

            case E_V512HImode:
              if (pattern601 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2495 (insn, operands);

            case E_V1024HImode:
              if (pattern601 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2496 (insn, operands);

            case E_V2048HImode:
              if (pattern601 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2497 (insn, operands);

            case E_V1SImode:
              if (pattern601 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return NULL;
              return gen_split_2498 (insn, operands);

            case E_V2SImode:
              if (pattern601 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return NULL;
              return gen_split_2499 (insn, operands);

            case E_V4SImode:
              if (pattern601 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return NULL;
              return gen_split_2500 (insn, operands);

            case E_V8SImode:
              if (pattern601 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return NULL;
              return gen_split_2501 (insn, operands);

            case E_V16SImode:
              if (pattern601 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2502 (insn, operands);

            case E_V32SImode:
              if (pattern601 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2503 (insn, operands);

            case E_V64SImode:
              if (pattern601 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2504 (insn, operands);

            case E_V128SImode:
              if (pattern601 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2505 (insn, operands);

            case E_V256SImode:
              if (pattern601 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2506 (insn, operands);

            case E_V512SImode:
              if (pattern601 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2507 (insn, operands);

            case E_V1024SImode:
              if (pattern601 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2508 (insn, operands);

            case E_V1DImode:
              if (pattern601 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2509 (insn, operands);

            case E_V2DImode:
              if (pattern601 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2510 (insn, operands);

            case E_V4DImode:
              if (pattern601 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2511 (insn, operands);

            case E_V8DImode:
              if (pattern601 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2512 (insn, operands);

            case E_V16DImode:
              if (pattern601 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2513 (insn, operands);

            case E_V32DImode:
              if (pattern601 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2514 (insn, operands);

            case E_V64DImode:
              if (pattern601 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2515 (insn, operands);

            case E_V128DImode:
              if (pattern601 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2516 (insn, operands);

            case E_V256DImode:
              if (pattern601 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2517 (insn, operands);

            case E_V512DImode:
              if (pattern601 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0
                  || !(
#line 2220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2518 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_136 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      return split_134 (x1, insn);

    case MULT:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 0);
          operands[3] = x4;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          return split_135 (x1, insn);

        case FLOAT_EXTEND:
          switch (pattern289 (x2))
            {
            case 0:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9644 (insn, operands);

            case 1:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9645 (insn, operands);

            case 2:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9646 (insn, operands);

            case 3:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9647 (insn, operands);

            case 4:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9648 (insn, operands);

            case 5:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9649 (insn, operands);

            case 6:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9650 (insn, operands);

            case 7:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9651 (insn, operands);

            case 8:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9652 (insn, operands);

            case 9:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9653 (insn, operands);

            case 10:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9654 (insn, operands);

            case 11:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9655 (insn, operands);

            case 12:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9656 (insn, operands);

            case 13:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9657 (insn, operands);

            case 14:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9658 (insn, operands);

            case 15:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9659 (insn, operands);

            case 16:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9660 (insn, operands);

            case 17:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9661 (insn, operands);

            case 18:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9662 (insn, operands);

            case 19:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9663 (insn, operands);

            case 20:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9664 (insn, operands);

            case 21:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9665 (insn, operands);

            case 22:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9666 (insn, operands);

            case 23:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9667 (insn, operands);

            case 24:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9668 (insn, operands);

            case 25:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9669 (insn, operands);

            case 26:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9670 (insn, operands);

            case 27:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9671 (insn, operands);

            case 28:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9672 (insn, operands);

            case 29:
              if (!((
#line 1110 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9673 (insn, operands);

            case 30:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9674 (insn, operands);

            case 31:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9675 (insn, operands);

            case 32:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9676 (insn, operands);

            case 33:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9677 (insn, operands);

            case 34:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9678 (insn, operands);

            case 35:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9679 (insn, operands);

            case 36:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9680 (insn, operands);

            case 37:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9681 (insn, operands);

            case 38:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9682 (insn, operands);

            case 39:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9683 (insn, operands);

            case 40:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9684 (insn, operands);

            case 41:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9685 (insn, operands);

            case 42:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9686 (insn, operands);

            case 43:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9687 (insn, operands);

            case 44:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9688 (insn, operands);

            case 45:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9689 (insn, operands);

            case 46:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9690 (insn, operands);

            case 47:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9691 (insn, operands);

            case 48:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9692 (insn, operands);

            case 49:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9693 (insn, operands);

            case 50:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9694 (insn, operands);

            case 51:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9695 (insn, operands);

            case 52:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9696 (insn, operands);

            case 53:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9697 (insn, operands);

            case 54:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9698 (insn, operands);

            case 55:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9699 (insn, operands);

            case 56:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9700 (insn, operands);

            case 57:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9701 (insn, operands);

            case 58:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9702 (insn, operands);

            case 59:
              if (!((
#line 1134 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1136 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9703 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8420 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8422 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8424 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8426 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8428 (insn, operands);

        case 5:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8430 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8432 (insn, operands);

        case 7:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8434 (insn, operands);

        case 8:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8436 (insn, operands);

        case 9:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8438 (insn, operands);

        case 10:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8440 (insn, operands);

        case 11:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8442 (insn, operands);

        case 12:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8444 (insn, operands);

        case 13:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8446 (insn, operands);

        case 14:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8448 (insn, operands);

        case 15:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8450 (insn, operands);

        case 16:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8452 (insn, operands);

        case 17:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8454 (insn, operands);

        case 18:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8456 (insn, operands);

        case 19:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8458 (insn, operands);

        case 20:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8460 (insn, operands);

        case 21:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8462 (insn, operands);

        case 22:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8464 (insn, operands);

        case 23:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8466 (insn, operands);

        case 24:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8468 (insn, operands);

        case 25:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8470 (insn, operands);

        case 26:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8472 (insn, operands);

        case 27:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8474 (insn, operands);

        case 28:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8476 (insn, operands);

        case 29:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8478 (insn, operands);

        case 30:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8480 (insn, operands);

        case 31:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8482 (insn, operands);

        case 32:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8484 (insn, operands);

        case 33:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8486 (insn, operands);

        case 34:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8488 (insn, operands);

        case 35:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8490 (insn, operands);

        case 36:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8492 (insn, operands);

        case 37:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8494 (insn, operands);

        case 38:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8496 (insn, operands);

        case 39:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8498 (insn, operands);

        case 40:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8500 (insn, operands);

        case 41:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8502 (insn, operands);

        case 42:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8504 (insn, operands);

        case 43:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8506 (insn, operands);

        case 44:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8508 (insn, operands);

        case 45:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8510 (insn, operands);

        case 46:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8512 (insn, operands);

        case 47:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8514 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8421 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8423 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8425 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8427 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8429 (insn, operands);

        case 5:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8431 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8433 (insn, operands);

        case 7:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8435 (insn, operands);

        case 8:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8437 (insn, operands);

        case 9:
          if (!(
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8439 (insn, operands);

        case 10:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8441 (insn, operands);

        case 11:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8443 (insn, operands);

        case 12:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8445 (insn, operands);

        case 13:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8447 (insn, operands);

        case 14:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8449 (insn, operands);

        case 15:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8451 (insn, operands);

        case 16:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8453 (insn, operands);

        case 17:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8455 (insn, operands);

        case 18:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8457 (insn, operands);

        case 19:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8459 (insn, operands);

        case 20:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8461 (insn, operands);

        case 21:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8463 (insn, operands);

        case 22:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8465 (insn, operands);

        case 23:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8467 (insn, operands);

        case 24:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8469 (insn, operands);

        case 25:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8471 (insn, operands);

        case 26:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8473 (insn, operands);

        case 27:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8475 (insn, operands);

        case 28:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8477 (insn, operands);

        case 29:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8479 (insn, operands);

        case 30:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8481 (insn, operands);

        case 31:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8483 (insn, operands);

        case 32:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8485 (insn, operands);

        case 33:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8487 (insn, operands);

        case 34:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8489 (insn, operands);

        case 35:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8491 (insn, operands);

        case 36:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8493 (insn, operands);

        case 37:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8495 (insn, operands);

        case 38:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8497 (insn, operands);

        case 39:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8499 (insn, operands);

        case 40:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8501 (insn, operands);

        case 41:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8503 (insn, operands);

        case 42:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8505 (insn, operands);

        case 43:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8507 (insn, operands);

        case 44:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8509 (insn, operands);

        case 45:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8511 (insn, operands);

        case 46:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8513 (insn, operands);

        case 47:
          if (!((
#line 629 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8515 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      switch (pattern240 (x2))
        {
        case 0:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9020 (insn, operands);

        case 1:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9021 (insn, operands);

        case 2:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9022 (insn, operands);

        case 3:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9023 (insn, operands);

        case 4:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9024 (insn, operands);

        case 5:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9025 (insn, operands);

        case 6:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9026 (insn, operands);

        case 7:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9027 (insn, operands);

        case 8:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9028 (insn, operands);

        case 9:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9029 (insn, operands);

        case 10:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9030 (insn, operands);

        case 11:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9031 (insn, operands);

        case 12:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9032 (insn, operands);

        case 13:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9033 (insn, operands);

        case 14:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9034 (insn, operands);

        case 15:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9035 (insn, operands);

        case 16:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9036 (insn, operands);

        case 17:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9037 (insn, operands);

        case 18:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9038 (insn, operands);

        case 19:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9039 (insn, operands);

        case 20:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9040 (insn, operands);

        case 21:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9041 (insn, operands);

        case 22:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9042 (insn, operands);

        case 23:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9043 (insn, operands);

        case 24:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9044 (insn, operands);

        case 25:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9045 (insn, operands);

        case 26:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9046 (insn, operands);

        case 27:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9047 (insn, operands);

        case 28:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9048 (insn, operands);

        case 29:
          if (!((
#line 792 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 794 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9049 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_148 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern231 (x2))
            {
            case 0:
              if (!((
#line 2992 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 2997 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( 1)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!((
#line 2992 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2997 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( 1)))
                return NULL;
              return gen_split_44 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_DImode
              || pattern283 (x2, 
E_HImode) != 0)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode)
              || !
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
            return NULL;
          return gen_split_187 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern234 (x2))
        {
        case 0:
          if (!((
#line 1022 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_176 (insn, operands);

        case 1:
          if (!((
#line 1022 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 2:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2590 (insn, operands);

        case 3:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2604 (insn, operands);

        case 4:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        case 5:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2632 (insn, operands);

        case 6:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2646 (insn, operands);

        case 7:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2660 (insn, operands);

        case 8:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2674 (insn, operands);

        case 9:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2688 (insn, operands);

        case 10:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 11:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2716 (insn, operands);

        case 12:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2730 (insn, operands);

        case 13:
          if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2744 (insn, operands);

        case 14:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2758 (insn, operands);

        case 15:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2772 (insn, operands);

        case 16:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2786 (insn, operands);

        case 17:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2800 (insn, operands);

        case 18:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2814 (insn, operands);

        case 19:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2828 (insn, operands);

        case 20:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2842 (insn, operands);

        case 21:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2856 (insn, operands);

        case 22:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2870 (insn, operands);

        case 23:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2884 (insn, operands);

        case 24:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2898 (insn, operands);

        case 25:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2912 (insn, operands);

        case 26:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2926 (insn, operands);

        case 27:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2940 (insn, operands);

        case 28:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2954 (insn, operands);

        case 29:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2968 (insn, operands);

        case 30:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2982 (insn, operands);

        case 31:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2996 (insn, operands);

        case 32:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3010 (insn, operands);

        case 33:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3024 (insn, operands);

        case 34:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3038 (insn, operands);

        case 35:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3052 (insn, operands);

        case 36:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3066 (insn, operands);

        case 37:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3080 (insn, operands);

        case 38:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3094 (insn, operands);

        case 39:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3108 (insn, operands);

        case 40:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3122 (insn, operands);

        case 41:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3136 (insn, operands);

        case 42:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3150 (insn, operands);

        case 43:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3164 (insn, operands);

        case 44:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3178 (insn, operands);

        case 45:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3192 (insn, operands);

        case 46:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3206 (insn, operands);

        case 47:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3220 (insn, operands);

        case 48:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3234 (insn, operands);

        case 49:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3248 (insn, operands);

        case 50:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3262 (insn, operands);

        case 51:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3276 (insn, operands);

        case 52:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3290 (insn, operands);

        case 53:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3304 (insn, operands);

        case 54:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3318 (insn, operands);

        case 55:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3332 (insn, operands);

        case 56:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3346 (insn, operands);

        case 57:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3360 (insn, operands);

        case 58:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3374 (insn, operands);

        case 59:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3388 (insn, operands);

        case 60:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3402 (insn, operands);

        case 61:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3416 (insn, operands);

        case 62:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3430 (insn, operands);

        case 63:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3444 (insn, operands);

        case 64:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3458 (insn, operands);

        case 65:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3472 (insn, operands);

        case 66:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3486 (insn, operands);

        case 67:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3500 (insn, operands);

        case 68:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3514 (insn, operands);

        case 69:
          if (!((
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3528 (insn, operands);

        case 70:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3948 (insn, operands);

        case 71:
          if (!(
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3951 (insn, operands);

        case 72:
          if (!(
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3954 (insn, operands);

        case 73:
          if (!(
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3957 (insn, operands);

        case 74:
          if (!(
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3960 (insn, operands);

        case 75:
          if (!(
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3963 (insn, operands);

        case 76:
          if (!(
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3966 (insn, operands);

        case 77:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3969 (insn, operands);

        case 78:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3972 (insn, operands);

        case 79:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3975 (insn, operands);

        case 80:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3978 (insn, operands);

        case 81:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3981 (insn, operands);

        case 82:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3984 (insn, operands);

        case 83:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3987 (insn, operands);

        case 84:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3990 (insn, operands);

        case 85:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3993 (insn, operands);

        case 86:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3996 (insn, operands);

        case 87:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3999 (insn, operands);

        case 88:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4002 (insn, operands);

        case 89:
          if (!((
#line 558 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 560 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4005 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern343 (x2, 
E_RVVMF64BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10092 (insn, operands);

        case E_RVVMF32BImode:
          if (pattern343 (x2, 
E_RVVMF32BImode) != 0
              || !(
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10094 (insn, operands);

        case E_RVVMF16BImode:
          if (pattern343 (x2, 
E_RVVMF16BImode) != 0
              || !(
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10096 (insn, operands);

        case E_RVVMF8BImode:
          if (pattern343 (x2, 
E_RVVMF8BImode) != 0
              || !(
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10098 (insn, operands);

        case E_RVVMF4BImode:
          if (pattern343 (x2, 
E_RVVMF4BImode) != 0
              || !(
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10100 (insn, operands);

        case E_RVVMF2BImode:
          if (pattern343 (x2, 
E_RVVMF2BImode) != 0
              || !(
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10102 (insn, operands);

        case E_RVVM1BImode:
          if (pattern343 (x2, 
E_RVVM1BImode) != 0
              || !(
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10104 (insn, operands);

        case E_V1BImode:
          if (pattern343 (x2, 
E_V1BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10106 (insn, operands);

        case E_V2BImode:
          if (pattern343 (x2, 
E_V2BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10108 (insn, operands);

        case E_V4BImode:
          if (pattern343 (x2, 
E_V4BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10110 (insn, operands);

        case E_V8BImode:
          if (pattern343 (x2, 
E_V8BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10112 (insn, operands);

        case E_V16BImode:
          if (pattern343 (x2, 
E_V16BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10114 (insn, operands);

        case E_V32BImode:
          if (pattern343 (x2, 
E_V32BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10116 (insn, operands);

        case E_V64BImode:
          if (pattern343 (x2, 
E_V64BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10118 (insn, operands);

        case E_V128BImode:
          if (pattern343 (x2, 
E_V128BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10120 (insn, operands);

        case E_V256BImode:
          if (pattern343 (x2, 
E_V256BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10122 (insn, operands);

        case E_V512BImode:
          if (pattern343 (x2, 
E_V512BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10124 (insn, operands);

        case E_V1024BImode:
          if (pattern343 (x2, 
E_V1024BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10126 (insn, operands);

        case E_V2048BImode:
          if (pattern343 (x2, 
E_V2048BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10128 (insn, operands);

        case E_V4096BImode:
          if (pattern343 (x2, 
E_V4096BImode) != 0
              || !((
#line 1473 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1475 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10130 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_155 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4411 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4412 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4413 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4414 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4415 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4416 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4417 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4418 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4419 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4420 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4421 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4422 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4423 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4424 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4425 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4426 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4427 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4428 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4429 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4430 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4431 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4432 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4433 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4434 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4435 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4436 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4437 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4438 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4439 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 885 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4440 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_161 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return split_136 (x1, insn);

    case MULT:
      return split_137 (x1, insn);

    case NEG:
      switch (pattern144 (x2))
        {
        case 0:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5505 (insn, operands);

        case 1:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5506 (insn, operands);

        case 2:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5507 (insn, operands);

        case 3:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5508 (insn, operands);

        case 4:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5509 (insn, operands);

        case 5:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5510 (insn, operands);

        case 6:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5511 (insn, operands);

        case 7:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5512 (insn, operands);

        case 8:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5513 (insn, operands);

        case 9:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5514 (insn, operands);

        case 10:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5515 (insn, operands);

        case 11:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5516 (insn, operands);

        case 12:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5517 (insn, operands);

        case 13:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5518 (insn, operands);

        case 14:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5519 (insn, operands);

        case 15:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5520 (insn, operands);

        case 16:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5521 (insn, operands);

        case 17:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5522 (insn, operands);

        case 18:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5523 (insn, operands);

        case 19:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5524 (insn, operands);

        case 20:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5525 (insn, operands);

        case 21:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5526 (insn, operands);

        case 22:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5527 (insn, operands);

        case 23:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5528 (insn, operands);

        case 24:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5529 (insn, operands);

        case 25:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5530 (insn, operands);

        case 26:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5531 (insn, operands);

        case 27:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5532 (insn, operands);

        case 28:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5533 (insn, operands);

        case 29:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5534 (insn, operands);

        case 30:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5535 (insn, operands);

        case 31:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5536 (insn, operands);

        case 32:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5537 (insn, operands);

        case 33:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5538 (insn, operands);

        case 34:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5539 (insn, operands);

        case 35:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5540 (insn, operands);

        case 36:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5541 (insn, operands);

        case 37:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5542 (insn, operands);

        case 38:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5543 (insn, operands);

        case 39:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5544 (insn, operands);

        case 40:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5545 (insn, operands);

        case 41:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5546 (insn, operands);

        case 42:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5547 (insn, operands);

        case 43:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5548 (insn, operands);

        case 44:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5549 (insn, operands);

        case 45:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5550 (insn, operands);

        case 46:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5551 (insn, operands);

        case 47:
          if (!((
#line 1321 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1323 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5552 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      return split_139 (x1, insn);

    case ZERO_EXTEND:
      return split_138 (x1, insn);

    case FLOAT_EXTEND:
      switch (pattern150 (x2))
        {
        case 0:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8901 (insn, operands);

        case 1:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8904 (insn, operands);

        case 2:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8907 (insn, operands);

        case 3:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8910 (insn, operands);

        case 4:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8913 (insn, operands);

        case 5:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8916 (insn, operands);

        case 6:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8919 (insn, operands);

        case 7:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8922 (insn, operands);

        case 8:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8925 (insn, operands);

        case 9:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8928 (insn, operands);

        case 10:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8931 (insn, operands);

        case 11:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8934 (insn, operands);

        case 12:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8937 (insn, operands);

        case 13:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8940 (insn, operands);

        case 14:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8943 (insn, operands);

        case 15:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8946 (insn, operands);

        case 16:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8949 (insn, operands);

        case 17:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8952 (insn, operands);

        case 18:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8955 (insn, operands);

        case 19:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8958 (insn, operands);

        case 20:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8961 (insn, operands);

        case 21:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8964 (insn, operands);

        case 22:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8967 (insn, operands);

        case 23:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8970 (insn, operands);

        case 24:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8973 (insn, operands);

        case 25:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8976 (insn, operands);

        case 26:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8979 (insn, operands);

        case 27:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8982 (insn, operands);

        case 28:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8985 (insn, operands);

        case 29:
          if (!((
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8988 (insn, operands);

        case 30:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9050 (insn, operands);

        case 31:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9051 (insn, operands);

        case 32:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9052 (insn, operands);

        case 33:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9053 (insn, operands);

        case 34:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9054 (insn, operands);

        case 35:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9055 (insn, operands);

        case 36:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9056 (insn, operands);

        case 37:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9057 (insn, operands);

        case 38:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9058 (insn, operands);

        case 39:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9059 (insn, operands);

        case 40:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9060 (insn, operands);

        case 41:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9061 (insn, operands);

        case 42:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9062 (insn, operands);

        case 43:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9063 (insn, operands);

        case 44:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9064 (insn, operands);

        case 45:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9065 (insn, operands);

        case 46:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9066 (insn, operands);

        case 47:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9067 (insn, operands);

        case 48:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9068 (insn, operands);

        case 49:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9069 (insn, operands);

        case 50:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9070 (insn, operands);

        case 51:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9071 (insn, operands);

        case 52:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9072 (insn, operands);

        case 53:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9073 (insn, operands);

        case 54:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9074 (insn, operands);

        case 55:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9075 (insn, operands);

        case 56:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9076 (insn, operands);

        case 57:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9077 (insn, operands);

        case 58:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9078 (insn, operands);

        case 59:
          if (!((
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9079 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_175 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return NULL;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return NULL;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 0);
  switch (GET_CODE (x9))
    {
    case NE:
    case EQ:
      res = split_174 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!fp_native_comparison (x9, E_VOIDmode))
    return NULL;
  switch (pattern411 (x3))
    {
    case 0:
      if (!((
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3378 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_85 (insn, operands);

    case 1:
      if (!((
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3378 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_86 (insn, operands);

    case 2:
      if (!((
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3378 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_87 (insn, operands);

    case 3:
      if (!((
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3378 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_88 (insn, operands);

    case 4:
      if (!((
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3378 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_89 (insn, operands);

    case 5:
      if (!((
#line 3376 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3378 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_90 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_176 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT
      || GET_MODE (x4) != E_DImode)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_SImode))
    return NULL;
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern467 (x10))
        {
        case 0:
          if (!((
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 1:
          if (!((
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 768 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern467 (x10))
        {
        case 0:
          if (!((
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_156 (insn, operands);

        case 1:
          if (!((
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 768 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_177 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !p2m1_shift_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode))
            return NULL;
          return gen_split_50 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[3], E_DImode))
            return NULL;
          if (p2m1_shift_operand (operands[2], E_DImode)
              && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return gen_split_51 (insn, operands);
          if (!high_mask_shift_operand (operands[2], E_DImode)
              || !
#line 3119 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_52 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern340 (x1) != 0
          || !(
#line 3138 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)) && 
#line 3141 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_53 (insn, operands);

    case NOT:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          switch (pattern373 (x1))
            {
            case 0:
              if (((
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_112 (insn, operands);
              break;

            case 1:
              if (((
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) != SUBREG
              || maybe_ne (SUBREG_BYTE (x8), 0)
              || GET_MODE (x8) != E_DImode)
            return NULL;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x9, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return NULL;
          x11 = XEXP (x9, 1);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!arith_operand (operands[2], E_DImode))
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_DImode)
              || !
#line 893 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (INTVAL (operands[2])) >= 33))
            return NULL;
          return gen_split_168 (insn, operands);

        case SIGN_EXTEND:
          switch (pattern379 (x1))
            {
            case 0:
              if (!((
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            case 1:
              if (!((
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 768 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_161 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern379 (x1))
            {
            case 0:
              if (!((
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            case 1:
              if (!((
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 768 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_162 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x4) != E_DImode)
        return NULL;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != GE
          || GET_MODE (x8) != E_DImode)
        return NULL;
      x12 = XEXP (x8, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode))
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!register_operand (operands[3], E_DImode)
          || !
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
        return NULL;
      return gen_split_116 (insn, operands);

    case SIGN_EXTRACT:
      x13 = XEXP (x4, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x14 = XEXP (x4, 2);
      operands[2] = x14;
      if (!immediate_operand (operands[2], E_VOIDmode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern448 (x3, 
E_SImode) != 0)
            return NULL;
          if ((
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10533 (insn, operands);
          if ((
#line 119 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && !TARGET_ZBS && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10535 (insn, operands);
          if ((
#line 49 "../../gcc-15.1.1-20250425/gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10577 (insn, operands);
          if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10579 (insn, operands);

        case E_DImode:
          if (pattern448 (x3, 
E_DImode) != 0)
            return NULL;
          if ((
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && TARGET_ZBS) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10534 (insn, operands);
          if ((
#line 119 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && !TARGET_ZBS && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10536 (insn, operands);
          if ((
#line 49 "../../gcc-15.1.1-20250425/gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10578 (insn, operands);
          if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10580 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern356 (x1))
        {
        case 0:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10537 (insn, operands);

        case 1:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10541 (insn, operands);

        case 2:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10538 (insn, operands);

        case 3:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10542 (insn, operands);

        case 4:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10539 (insn, operands);

        case 5:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10543 (insn, operands);

        case 6:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10540 (insn, operands);

        case 7:
          if (!(
#line 137 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10544 (insn, operands);

        case 8:
          if (!(
#line 150 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10545 (insn, operands);

        case 9:
          if (!(
#line 150 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10547 (insn, operands);

        case 10:
          if (!(
#line 150 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10546 (insn, operands);

        case 11:
          if (!(
#line 150 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10548 (insn, operands);

        case 12:
          if (!(
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10549 (insn, operands);

        case 13:
          if (!(
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10551 (insn, operands);

        case 14:
          if (!(
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10550 (insn, operands);

        case 15:
          if (!(
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10552 (insn, operands);

        case 16:
          if (!(
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10553 (insn, operands);

        case 17:
          if (!(
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10555 (insn, operands);

        case 18:
          if (!(
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10554 (insn, operands);

        case 19:
          if (!(
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10556 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern356 (x1))
        {
        case 0:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10557 (insn, operands);

        case 1:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10561 (insn, operands);

        case 2:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10558 (insn, operands);

        case 3:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10562 (insn, operands);

        case 4:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10559 (insn, operands);

        case 5:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10563 (insn, operands);

        case 6:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10560 (insn, operands);

        case 7:
          if (!(
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10564 (insn, operands);

        case 8:
          if (!(
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10565 (insn, operands);

        case 9:
          if (!(
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10567 (insn, operands);

        case 10:
          if (!(
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10566 (insn, operands);

        case 11:
          if (!(
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10568 (insn, operands);

        case 12:
          if (!(
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10569 (insn, operands);

        case 13:
          if (!(
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10571 (insn, operands);

        case 14:
          if (!(
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10570 (insn, operands);

        case 15:
          if (!(
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10572 (insn, operands);

        case 16:
          if (!(
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10573 (insn, operands);

        case 17:
          if (!(
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10575 (insn, operands);

        case 18:
          if (!(
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10574 (insn, operands);

        case 19:
          if (!(
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10576 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
